<?php
/** 
 * Plugin 'dh_lister' for the 'ameos_formidable' extension.
 *
 * @author	Jerome Schneider <typo3dev@ameos.com>
 */

class tx_dhlister extends formidable_maindatahandler {
	
	var $sViewName = "";
	
	var $__aRdtCols = array();			// all the columns in the database table
	var $__aVirCols = array();			// virtual columns, that are to be created in the compiled table

	var $sHtmlList = "";				// contains generated list
	var $aLabels = array();
	var $_iNumResults = 0;

	function _doTheMagic($bShouldProcess = TRUE) {
		
		$this->oForm->oRenderer->_setHiddenCustom("AMEOSFORMIDABLE_DHLISTER_PAGE",				$this->_getPage());	// default page
		$this->oForm->oRenderer->_setHiddenCustom("AMEOSFORMIDABLE_DHLISTER_SORT_FIELD",		$this->_getSortfield());	// default sort field
		$this->oForm->oRenderer->_setHiddenCustom("AMEOSFORMIDABLE_DHLISTER_SORT_DIRECTION",	$this->_getSortdirection());	// default sort direction

		if(is_array($this->_navConf("/search/atstartup"))) {
			$atStartup = $this->oForm->_callUserObj(
				$this->_navConf("/search/atstartup")
			);
		} else {
			$atStartup =	(
								($this->_navConf("/search/atstartup") === FALSE )
								||
								(!$this->oForm->_isFalse("/search/atstartup", $this->aElement))
							);	// default value: TRUE
		}
		
		if($atStartup || ($this->_isSubmitted() && $this->_allIsValid())) {

			$aRs = array();
			
			$aFormData = $this->_processBeforeSearch(
				$this->_getFormDataManaged()
			);

			$this->oForm->_debug($aFormData, "DATAHANDLER LISTER - EXECUTION");

			reset($aFormData);
			while(list($elementname, $value) = each($aFormData)) {

				if(array_key_exists($elementname, $this->oForm->aORenderlets)) {
					$oRenderlet = $this->oForm->aORenderlets[$elementname];
	//				$value = $oRenderlet->_fromRenderletToDataHandler($value);
	//				$value = $oRenderlet->_flatten($value);
				} else {
					// la donne a t ajoute dans le tableau par process/beforesearch
					// et ne correspond  aucun renderlet du formulaire
					// on cre un renderlet PASSTHRU  la vole pour cette valeur

					$oRenderlet = $this->oForm->_makeRenderlet(
						array(
							"type" => "PASSTHRU",
							"name" => $elementname,
							"data" => array(
								"value" => $value
							)
						),
						"/control/datahandler/process/beforesearch"
					);

				}

				if(!$oRenderlet->_emptyFormValue($value)) {
					$aRs[$elementname] = array(
						"object" => $oRenderlet,
						"value" => $value
					);
				}				
			}
			// on cre la requte SQL
			$tablename	= $this->_navConf("/tablename");
			$keyname	= $this->_navConf("/keyname");

			if($tablename != "" && $keyname != "") {

				if(($mCompiledDataSource = $this->_navConf("/compiledatasource/")) !== FALSE) {
					
					if(is_array($mCompiledDataSource)) {
						if(($aView = $this->oForm->_navConf("/view", $mCompiledDataSource)) !== FALSE) {
							$tablename = $this->__createView($aView);
						}
					} elseif($this->oForm->_isTrueVal($mCompiledDataSource)) {
						$tablename = $this->__createCompiledDataSource();
					}
				}

				if($this->_navConf("/search/sql/query/userobj") !== FALSE) {
					
					$sql = $this->oForm->_callUserObj(
						$this->_navConf("/search/sql/query/")
					);

				} elseif($this->_navConf("/search/sql/query") !== FALSE) {
					
					$sql = $this->_navConf("/search/sql/query");

				} else {

					$sql = $this->_buildSql(
						$aRs,
						$tablename,
						$keyname,
						$this->_navConf("/search/sql/wheres"),
						$this->_navconf("/search/sql/selects")
					);
				}

				$aLimit = $this->_getLimit();
				
				$aResult = array();
				$aRawResults = array();
				
				$this->oForm->_debug($sql . $aLimit["sql"], "DATAHANDLER LISTER - SQL QUERY");

				$rSql = $this->oForm->_watchOutDB(
					$GLOBALS["TYPO3_DB"]->sql_query($sql . $aLimit["sql"]),
					$sql . $aLimit["sql"]
				);
				
				$iNumRows = $this->oForm->_navConf(
					"/nbrows",
					$GLOBALS["TYPO3_DB"]->sql_fetch_assoc(
						$this->oForm->_watchOutDB(
							$GLOBALS["TYPO3_DB"]->sql_query(
								"SELECT FOUND_ROWS() as nbrows"
							)
						)
					)
				);
				
				$this->_iNumResults = $iNumRows;
							
				if($iNumRows == 0 && (($aEmpty = $this->_navConf("/ifempty")) !== FALSE)) {

					if(is_array($aEmpty)) {
						if($this->oForm->isUserObj($aEmpty)) {
							$sHtmlEmpty = $this->oForm->_callUserObj($aEmpty);
						} elseif(array_key_exists("html", $aEmpty)) {
							//$sHtmlEmpty = $this->oForm->_getLLLabel($aEmpty["html"]);
							$sHtmlEmpty = $this->oForm->_substLLLInHtml($aEmpty["html"]);
						} else {
							$sHtmlEmpty = "";
						}
					} else {
						$sHtmlEmpty = $this->oForm->_getLLLabel($aEmpty);
					}

					// erasing search results from session

					if($this->oForm->_isTrue("/search/keepinsession", $this->aElement)) {
						$GLOBALS["_SESSION"]["ameos_formidable"]["dh_lister"][$this->oForm->formid]["nbresults"]	= 0;
						$GLOBALS["_SESSION"]["ameos_formidable"]["dh_lister"][$this->oForm->formid]["tstamp"]		= time();
						$GLOBALS["_SESSION"]["ameos_formidable"]["dh_lister"][$this->oForm->formid]["data"]			= $this->_getFormData();
						$GLOBALS["_SESSION"]["ameos_formidable"]["dh_lister"][$this->oForm->formid]["results"]		= array();
						$GLOBALS["_SESSION"]["ameos_formidable"]["dh_lister"][$this->oForm->formid]["page"]			= $GLOBALS["TSFE"]->id;
					}
					
					if($this->_navConf("/callback/userobj") !== FALSE) {

						$this->oForm->_callUserObj(
							$this->_navConf("/callback"),
							array(
								"HTML" => $sHtmlEmpty
							)
						);

						$this->sHtmlList = $sHtmlEmpty;

						return;
					} else {

						$this->sHtmlList = $sHtmlEmpty;
						return $sHtmlEmpty;
					}
				}

				while(($aRow = $GLOBALS["TYPO3_DB"]->sql_fetch_assoc($rSql)) !== FALSE) {

					$iUid = $aRow[$keyname];
					
					$aRow = $this->_processDuringListerRaw(
						$aRow
					);
					
					$aRawResults[$iUid] = $aRow;

					reset($aRow);
					while(list($sFieldName, $sFieldValue) = each($aRow)) {

						if(!empty($this->oForm->aORenderlets) && array_key_exists($sFieldName, $this->oForm->aORenderlets) && !$this->oForm->aORenderlets[$sFieldName]->_activeListable()) {

							$aRow[$sFieldName] = $this->oForm->aORenderlets[$sFieldName]->_getHumanReadableValue(
								$this->oForm->aORenderlets[$sFieldName]->_unFlatten(	// unflattening data after DB extraction
									$sFieldValue
								)
							);
						}
					}

					$aResult[$iUid] = $this->_processDuringLister(
						$aRow
					);
				}

				
				
				
				
				
				
				
				if($this->oForm->_isTrue("/search/keepinsession", $this->aElement)) {

					// SAVING the FULL ( NO SQL LIMIT ) list of uids in the session

					$aFull = array();

					$rSql = $this->oForm->_watchOutDB(
						$GLOBALS["TYPO3_DB"]->sql_query($sql),
						$sql
					);

					while(($aRow = $GLOBALS["TYPO3_DB"]->sql_fetch_assoc($rSql)) !== FALSE) {
						$aFull[$aRow[$keyname]] = $aRow[$keyname];
					}
					
					$GLOBALS["_SESSION"]["ameos_formidable"]["dh_lister"][$this->oForm->formid]["nbresults"]	= sizeOf($aFull);
					$GLOBALS["_SESSION"]["ameos_formidable"]["dh_lister"][$this->oForm->formid]["tstamp"]		= time();
					$GLOBALS["_SESSION"]["ameos_formidable"]["dh_lister"][$this->oForm->formid]["data"]			= $this->_getFormData();
					$GLOBALS["_SESSION"]["ameos_formidable"]["dh_lister"][$this->oForm->formid]["results"]		= $aFull;
					$GLOBALS["_SESSION"]["ameos_formidable"]["dh_lister"][$this->oForm->formid]["page"]			= $GLOBALS["TSFE"]->id;
					$GLOBALS["_SESSION"]["ameos_formidable"]["dh_lister"][$this->oForm->formid]["url"]			= t3lib_div::getIndpEnv("REQUEST_URI");

					// END SAVING
				}




				$aPaging = $this->_getPaging(
					$aLimit,
					$iNumRows
				);
				
//				debug($aPaging, $iNumRows . " ROWS");

				$sHtml = $this->_displayData(
					$aResult,
					$aRawResults,
					$aPaging
				);

				if($this->_navConf("/callback/userobj") !== FALSE) {

					$this->sHtmlList = $sHtml;

					$this->oForm->_callUserObj(
						$this->_navConf("/callback"),
						array("HTML" => $sHtml)
					);

				} else {

					$this->sHtmlList = $sHtml;
					return $sHtml;
				}
			} else {
				$this->oForm->mayday("DATAHANDLER LISTER configuration isn't correct");
			}
		}
	}
	
	function _hasSearchResults($sFormId) {
		return sizeOf(tx_dhlister::_getSearchResults($sFormId)) > 0;
	}
	
	function _getSearchResults($sFormId = FALSE) {

		if($sFormId === FALSE) {
			// only when used in an instance object, not tx_dhlister::_getSearchResults
			$sFormId = $this->oForm->formid;
		}

		$aSearchInfos = tx_dhlister::_getSearchInfos($sFormId);

		if(array_key_exists("results", $aSearchInfos)) {
			reset($aSearchInfos["results"]);
			return $aSearchInfos["results"];
		}

		return array();
	}

	function _getSearchInfos($sFormId = FALSE) {

		if($sFormId === FALSE) {
			// only when used in an instance object, not tx_dhlister::_getSearchInfos
			$sFormId = $this->oForm->formid;
		}
		
		if(array_key_exists("ameos_formidable", $GLOBALS["_SESSION"]) && array_key_exists("dh_lister", $GLOBALS["_SESSION"]["ameos_formidable"]) && is_array($GLOBALS["_SESSION"]["ameos_formidable"]["dh_lister"]) && array_key_exists($sFormId, $GLOBALS["_SESSION"]["ameos_formidable"]["dh_lister"])) {
			reset($GLOBALS["_SESSION"]["ameos_formidable"]["dh_lister"][$sFormId]);
			return $GLOBALS["_SESSION"]["ameos_formidable"]["dh_lister"][$sFormId];
		}

		return array();
	}

	function _getNumResults() {
		return $this->_iNumResults;
	}
	
	function _getLinkToPersistedSearchParams($sFormId = FALSE, $iPageId = FALSE, $aAddParams = array()) {
		
		if($sFormId === FALSE) {
			// only when used in an instance object, not tx_dhlister::_getLinkToPersistedSearchParams
			$sFormId = $this->oForm->formid;
		}
		
		$aInfos = tx_dhlister::_getSearchInfos($sFormId);
		if(array_key_exists("data", $aInfos)) {
			$aParams = array();
			
			reset($aInfos["data"]);
			while(list($sName, $sValue) = each($aInfos["data"])) {
				if($sValue != "") {
					$aParams[$sFormId . "[" . $sName . "]"] = $sValue;
				}
			}
			
			$aParams = array_merge(
				$aParams,
				$aAddParams
			);

			$sLink = $GLOBALS["TSFE"]->cObj->getTypoLink_URL(
				($iPageId !== FALSE ? $iPageId : $aInfos["page"]),
				$aParams,
				""
			);

			return $sLink;
		} else {
			return FALSE;
		}
	}
	
	function __createCompiledDataSource() {

		$sTable = $this->_navConf("/tablename/");
		$sNewTable = $sTable . md5($sTable);

		$sSql = "DROP TABLE IF EXISTS " . $sNewTable;
		
		$this->oForm->_watchOutDB(
			$GLOBALS["TYPO3_DB"]->sql_query($sSql),
			$sSql
		);

		$sSql = "CREATE TEMPORARY TABLE " . $sNewTable . " AS SELECT * FROM " . $sTable;
		
		$this->oForm->_watchOutDB(
			$GLOBALS["TYPO3_DB"]->sql_query($sSql),
			$sSql
		);
		
		

		reset($this->oForm->aORenderlets);
		while(list($sName, $oRdt) = each($this->oForm->aORenderlets)) {

			if(!$this->_isVirtualCol($sName) && !$oRdt->_renderonly()) {
				$aItems = $oRdt->_getItems();
				
				if(!empty($aItems)) {

					reset($aItems);
					while(list(, $aItem) = each($aItems)) {

						$sSql = "UPDATE " . $sNewTable . " SET " . $sName . " = '" . $GLOBALS["TYPO3_DB"]->quoteStr($aItem["caption"], $sNewTable) . "' WHERE " . $sName . " = '" . $GLOBALS["TYPO3_DB"]->quoteStr($aItem["value"], $sNewTable) . "'";

						$this->oForm->_watchOutDB(
							$GLOBALS["TYPO3_DB"]->sql_query($sSql),
							$sSql
						);
					}
				}
			}
		}

		$this->__processVirtualColumns(
			$sNewTable
		);
		
//		debug($GLOBALS["TYPO3_DB"]->exec_SELECTgetRows("*", $sNewTable, ""), "DATA");

		return $sNewTable;
	}
	
	function _initCols() {
		
		$this->__aCols = $GLOBALS["TYPO3_DB"]->admin_get_fields(
			$this->_navConf("/tablename")
		);
		
		$this->_initRdtCols();
		$this->_initVirtualCols();

		reset($this->__aCols);
	}
	
	function _initRdtCols() {
		
		$this->__aRdtCols = array();
		
		reset($this->oForm->aORenderlets);
		while(list($sName, $oRdt) = each($this->oForm->aORenderlets)) {
			
			if(array_key_exists($sName, $this->__aCols)) {
				$this->__aRdtCols[$sName] = $this->__aCols[$sName];
			}
		}

		reset($this->__aRdtCols);
	}
	
	function _fieldExists($sName) {
		return array_key_exists($sName, $this->__aCols);
	}
	
	function _initVirtualCols() {

		$this->__aVirCols = array();
		
		reset($this->oForm->aORenderlets);
		while(list($sName, $oRdt) = each($this->oForm->aORenderlets)) {
			
			if(!array_key_exists($sName, $this->__aCols)) {
				
				if(!$oRdt->_renderOnly()) {
					$this->__aVirCols[$sName] = $this->__aCols[$sName];
				}
			}
		}
//		echo $this->oForm->_viewMixed($this->__aCols);
//		echo $this->oForm->_viewMixed($this->__aVirCols);
		reset($this->__aVirCols);
	}
	
	function _isVirtualCol($sName) {
		return array_key_exists($sName, $this->__aVirCols);
	}

	function __processVirtualColumns($sCompTable) {

		$sKeyName = $this->_navConf("/keyname");

		if(!empty($this->__aVirCols)) {
			
			reset($this->__aVirCols);
			while(list($sName, ) = each($this->__aVirCols)) {	// creating the virtual columns
				$sSql = "ALTER TABLE " . $sCompTable . " add " . $sName . " TEXT NOT NULL default ''";
				$this->oForm->_watchOutDB(
					$GLOBALS["TYPO3_DB"]->sql_query($sSql),
					$sSql
				);

			}
			
			$sSql = $GLOBALS["TYPO3_DB"]->SELECTgetRows(
				"*",
				$sCompTable,
				""
			);

			$aData = $this->oForm->_watchOutDB(
				$GLOBALS["TYPO3_DB"]->sql_query($sSql),
				$sSql
			);

			$sStartBoundary = "start_" . uniqid("") . "|";
			$sBetweenBoundary = "|" . uniqid("") . "|";
			$sEndBoundary = "|" . uniqid("") . "_end";

			$this->__aListData = array();

			reset($aData);
			while(list($iIndex, $this->__aListData) = each($aData)) {

				$aVirTemp = $this->__aListData;
				
				reset($this->__aVirCols);
				while(list($sName, ) = each($this->__aVirCols)) {
					$aVirTemp[$sName] = $this->oForm->aORenderlets[$sName]->_getListValue();
				}

				$aCsv[] = $sStartBoundary . $this->__csvValues(
					$aVirTemp,
					$sBetweenBoundary
				) . $sEndBoundary;
			}

			
			$this->__aListData = array();


			$sFilePath = t3lib_div::tempnam(
				"tempcsv"
			);

			t3lib_div::writeFileToTypo3tempDir(
				$sFilePath,
				implode("\n", $aCsv)
			);
			
			@chmod($sFilePath, octdec(777));
			@chgrp($file, $GLOBALS['TYPO3_CONF_VARS']['BE']['createGroup']);		// "@" is there because file is not necessarily OWNED by the user

			$GLOBALS["TYPO3_DB"]->sql_query(
				"TRUNCATE TABLE " . $sCompTable
			);

			$GLOBALS["TYPO3_DB"]->sql_query(
				"FLUSH TABLES"
			);
			
			$sSql = "LOAD DATA INFILE \"" . $sFilePath . "\" REPLACE INTO TABLE " . $sCompTable . " FIELDS TERMINATED BY \"" . $sBetweenBoundary . "\" OPTIONALLY ENCLOSED BY '\"' LINES STARTING BY \"" . $sStartBoundary . "\" TERMINATED BY \"" . $sEndBoundary . "\"";

			$this->oForm->_watchOutDB(
				$GLOBALS["TYPO3_DB"]->sql_query($sSql), 
				$sSql
			);
			
			$GLOBALS["TYPO3_DB"]->sql_query(
				"FLUSH TABLES"
			);

			@unlink($sFilePath);
		}
	}

	

	function __csvValues($aRow, $sBoundary)	{
		$sQuote = '"';
		reset($aRow);
		$out=array();
		while(list(,$valPart)=each($aRow))	{
			$out[]=str_replace($sQuote,$sQuote.$sQuote,trim($valPart));
		}
		return $sQuote.implode($sQuote.$sBoundary.$sQuote,$out).$sQuote;
	}
	
	function __createView($aViewInfos) {
		
		$sTableName = $this->_navConf("/tablename/");
		$sSelect = $this->oForm->_navConf("/select/", $aViewInfos);

		if($this->oForm->isUserObj($sSelect)) {
			$sSelect = $this->oForm->_callUserObj($sSelect);
		}

		$aCustomTags = $this->oForm->_getCustomTags(
			$this->oForm->_navConf(
				"/customtags",
				$aViewInfos
			)
		);

		if(count($aCustomTags) > 0) {
			$sSelect = $this->oForm->_parseTemplateCode(
				$sSelect,
				$aCustomTags["values"],
				array(),
				FALSE,
				array_merge(
					$this->aLabels,
					$aCustomTags["labels"]
				)
			);
		}

		$this->sViewName = uniqid($sTableName);
		
		$sSql = "DROP TABLE IF EXISTS " . $this->sViewName;
		
		$this->oForm->_watchOutDB(
			$GLOBALS["TYPO3_DB"]->sql_query($sSql),
			$sSql
		);

		$sSql = "CREATE TEMPORARY TABLE " . $this->sViewName . " AS " . $sSelect;
		
		$this->oForm->_watchOutDB(
			$GLOBALS["TYPO3_DB"]->sql_query($sSql),
			$sSql
		);

		$this->oForm->_debug(
			$sSql,
			"DATAHANDLER LISTER - WE'RE CREATING THIS VIEW FOR COMPLEX DATA BROWSING"
		);

		if(($aDataModifiers = $this->oForm->_navConf("/datamodifiers/", $aViewInfos)) !== FALSE) {
			if($this->oForm->isUserObj($aDataModifiers)) {
				$this->oForm->_callUserObj($aDataModifiers);
			}
		}

		return $this->sViewName;
	}
	
	function _getPage() {
		$aPost = $this->_P();
		$page = 0;
		
		if(array_key_exists("AMEOSFORMIDABLE_DHLISTER_PAGE", $aPost) && !$this->_isFullySubmitted()) {	// when full submit, set page to 0
			$page = intval($aPost["AMEOSFORMIDABLE_DHLISTER_PAGE"]);
		}
		
		return $page;
	}
	
	function _getSortfield() {

		$aPost = $this->oForm->oDataHandler->_P();

		if(
				array_key_exists("AMEOSFORMIDABLE_DHLISTER_SORT_FIELD", $aPost)
				&&
				array_key_exists($aPost["AMEOSFORMIDABLE_DHLISTER_SORT_FIELD"], $this->oForm->aORenderlets)
		) {
			return $aPost["AMEOSFORMIDABLE_DHLISTER_SORT_FIELD"];

		} elseif(($mSortField = $this->_navConf("/pager/sort/field")) !== FALSE) {
			
			if($this->oForm->isUserObj($mSortField)) {
				$mSortField = $this->oForm->_callUserObj(
					$mSortField
				);
			}

			return $mSortField;
		}

		return $this->_navConf("/keyname/");
	}

	function _getSortdirection() {

		$aPost = $this->oForm->oDataHandler->_P();
		
		if(
				array_key_exists("AMEOSFORMIDABLE_DHLISTER_SORT_DIRECTION", $aPost)
				&&
				in_array($aPost["AMEOSFORMIDABLE_DHLISTER_SORT_DIRECTION"], array("ASC", "DESC"))
		) {
			return $aPost["AMEOSFORMIDABLE_DHLISTER_SORT_DIRECTION"];

		} elseif(($mSortDir = $this->_navConf("/pager/sort/dir")) !== FALSE) {
			
			if($this->oForm->isUserObj($mSortDir)) {
				$mSortDir = $this->oForm->_callUserObj(
					$mSortDir
				);
			}

			return $mSortDir;
		}
		


		return "DESC";
	}

	function _buildSql($aRs = array(), $sTableName, $sKeyName, $aWheres = FALSE, $aSelects = FALSE) {


		if($this->_navConf("/compiledatasource/") !== FALSE) {

			if($this->_navConf("/compiledatasource/view") === FALSE) {
				$tablename = $this->tableName();
				$newtablename = $sTableName;
			} else {
				$tablename = $sTableName;
				//$newtablename = $sTableName; // http://bugs.mysql.com/bug.php?id=10327
				$newtablename = uniqid($sTableName);
				
				$sSql = "CREATE TEMPORARY TABLE " . $newtablename . " AS SELECT * FROM " . $tablename;
				$this->oForm->_watchOutDB(
					$GLOBALS["TYPO3_DB"]->sql_query($sSql),
					$sSql
				);
			}

			$aFields = array();
			reset($this->__aCols);
			while(list($sName, ) = each($this->__aCols)) {
				$aFields[$sName] = "plain." . $sName;
			}

			reset($this->__aVirCols);
			while(list($sName) = each($this->__aVirCols)) {
				$aFields[$sName] = "compiled." . $sName;
			}

			$aQuery['SELECT']	= "SQL_CALC_FOUND_ROWS " . implode(",", $aFields) . " ";
			$aQuery['FROM']		= $newtablename . " AS compiled, " . $tablename . " AS plain";
			$aQuery['WHERE']	= array();
			
			if(count($aRs) > 0) {
				reset($aRs);
				while(list($fieldname, $aInfos) = each($aRs))
				{
					$oRenderlet	= $aInfos["object"];
					$value		= $oRenderlet->_flatten($aInfos["value"]);

					if(!$oRenderlet->_emptyFormValue($value)) {
						if(array_key_exists($fieldname, $this->__aVirCols)) {
							$aQuery["WHERE"][] = $oRenderlet->_sqlSearchClause($value, "compiled.");
						} else {
							$aQuery["WHERE"][] = $oRenderlet->_sqlSearchClause($value, "plain.");
						}
					}
				}
				
				$aQuery["WHERE"] = implode(" AND ", $aQuery["WHERE"]);
			}

			if(empty($aQuery['WHERE'])) {
				$aQuery['WHERE'] = "1";
			}
			
			$aQuery['WHERE'] .= " AND plain." . $sKeyName . " = compiled." . $sKeyName;
			
			$sTempWhere = "";

			if($aSelects !== FALSE) {
				reset($aSelects);
				while(list($sType, $sSelect) = each($aSelects)) {
					$aQuery["SELECT"] .= ", " . $sSelect . " ";
				}
			}

			$aQuery['WHERE'] .= $this->_getAdditionalWheres(
				$aWheres,
				"plain."
			);

			$sortfield		= "compiled." . $this->_getSortfield();

			if($this->i18n()) {
				$aQuery["WHERE"] .= " AND plain.sys_language_uid IN (-1, " . $this->i18n_getSysLanguageUid() . ") ";
			}

		} else {

			$aQuery['SELECT'] = "SQL_CALC_FOUND_ROWS *";
			$aQuery['FROM'] = $sTableName;

			if(count($aRs) > 0)
			{
				reset($aRs);
				while(list($fieldname, $aInfos) = each($aRs))
				{
					$oRenderlet	= $aInfos["object"];
					$value		= $oRenderlet->_flatten($aInfos["value"]);

					if(!$oRenderlet->_emptyFormValue($value)) {
						$aQuery["WHERE"][] = $oRenderlet->_sqlSearchClause($value);
					}
				}
				
				$aQuery["WHERE"] = implode(" AND ", $aQuery["WHERE"]);
			}
			else
			{ $aQuery['WHERE'] = "1";}
			
			$aQuery['WHERE'] .= $this->_getAdditionalWheres(
				$aWheres
			);

			$sortfield		= $this->_getSortfield();

			if($this->i18n()) {
				$aQuery["WHERE"] .= " AND sys_language_uid IN (-1, " . $this->i18n_getSysLanguageUid() . ") ";
			}

			/*
				enableFields patch by Manuel Rego Casasnovas
				@see http://lists.netfielders.de/pipermail/typo3-project-formidable/2007-December/000797.html
			*/

			if($this->enableFields()) {
				if(TYPO3_MODE == 'BE') {
					$aQuery['WHERE'] .= t3lib_BEfunc::BEenableFields($sTableName);
				} else {
					$aQuery['WHERE'] .= $GLOBALS['TSFE']->sys_page->enableFields($sTableName);
				}
			}
		}

		/*
			enableFields patch by Manuel Rego Casasnovas
			@see http://lists.netfielders.de/pipermail/typo3-project-formidable/2007-December/000797.html
		*/

		if($this->enableFields()) {
			if(TYPO3_MODE == 'BE') {
				$aQuery['WHERE'] .= t3lib_BEfunc::BEenableFields($sTableName);
			} else {
				$aQuery['WHERE'] .= $GLOBALS['TSFE']->sys_page->enableFields($sTableName);
			}
		}
		

		$sortdirection	= $this->_getSortdirection();
		$aQuery['GROUPBY'] = "";

		if($sortfield != "")
		{ $aQuery['ORDERBY'] = $sortfield . " " . $sortdirection;}
		
		$aQuery['LIMIT'] = "";

		$sql = $GLOBALS["TYPO3_DB"]->SELECTquery(
			$aQuery['SELECT'],
			$aQuery['FROM'],
			$aQuery['WHERE'],
			$aQuery['GROUPBY'],
			$aQuery['ORDERBY'],
			$aQuery['LIMIT']
		);

		return $sql;
	}

	function _getAdditionalWheres($aWheres, $sPrefix = "") {
		
		$sTempWhere = "";
		
		if($aWheres !== FALSE && is_array($aWheres) && count($aWheres) > 0) {

			$aClauses = array();
			$bClauses = FALSE;

			reset($aWheres);
			while(list($sType, $aWhere) = each($aWheres)) {
				
				$aTemp = explode("-", $sType); $sType = trim(strtoupper($aTemp[0]));
				$bProcess = TRUE;
				
				if(is_array($aWhere) && array_key_exists("process", $aWhere)) {
					if($this->oForm->isUserObj($aWhere["process"])) {
						$bProcess = $this->oForm->_callUserObj(
							$aWhere["process"]
						);
					} else {
						if($this->oForm->_isFalseVal($aWhere["process"])) {
							$bProcess = FALSE;
						}
					}
				}
				
				if($bProcess) {
					switch($sType) {
						case "WHERE" : {
							
							if(($mProcess = $this->oForm->_defaultTrue("/process", $aWhere)) !== FALSE) {
								if($this->oForm->isUserObj($mProcess)) {
									$mProcess = $this->oForm->_callUserObj($mProcess);
								}
							}
							
							if($mProcess === TRUE) {
								
								if(array_key_exists("value", $aWhere)) {
									$mValue = $aWhere["value"];
								} else {
									$mValue = "";
								}

								if($this->oForm->isUserObj($mValue)) {
									$mValue = $this->oForm->_callUserObj($mValue);
								}

								if($mValue == "") {
									$mValue = "''";
								}

								if($this->oForm->isUserObj($aWhere["comparison"])) {
									$aWhere["comparison"] = $this->oForm->_callUserObj($aWhere["comparison"]);
								}

								$sComparison = strtoupper(trim($aWhere["comparison"]));

								if($bClauses && (($mLogic = $this->oForm->_navConf("/logic", $aWhere)) !== FALSE)) {
									
									if($this->oForm->isUserObj($mLogic)) {
										$mLogic = $this->oForm->_callUserObj($mLogic);
									}

									$aClauses[] = (in_array(trim(strtoupper($mLogic)), array("AND", "OR"))) ? trim(strtoupper($mLogic)) : "AND";
								}

								$aClauses[] = " " . $sPrefix . $aWhere["term"] . " " . $sComparison . (($sComparison == "IN" || $sComparison == "NOT IN") ? " (" : " '") . $mValue . (($sComparison == "IN" || $sComparison == "NOT IN") ? ") " : "'");
								$bClauses = TRUE;
								break;

							}
						}
						case "BEGINBRACE" : {
							$aClauses[] = "(";
							break;
						}
						case "ENDBRACE" : {
							$aClauses[] = ")";
							break;
						}
						case "LOGIC" : {
							
							if($bClauses) {

								if(is_array($aWhere) && array_key_exists("value", $aWhere)) {
									$mValue = $aWhere["value"];
								} else {
									$mValue = $aWhere;
								}
								
								if($this->oForm->isUserObj($mValue)) {
									$mValue = $this->oForm->_callUserObj($mValue);
								}

								$aClauses[] = (in_array(trim(strtoupper($mValue)), array("AND", "OR"))) ? trim(strtoupper($mValue)) : "";
							}

							break;
						}
					}
				}
			}

			$sTempWhere = implode(" ", $aClauses);
		}

		if($bClauses && trim($sTempWhere) != "") {
			return " AND (" . $sTempWhere . ")";
		}

		return "";     
	}
	
	function __buildDefaultTemplate($aRows, $aRawRows, $aPaging) {

		$sHtml = "";
		$sHtml .= "<h2>DEFAULT TEMPLATE</h2>";

		$sPath		= $this->sExtPath . "res/_defaulttemplate.html";
		$sSubpart	= "###LIST###";

		$sTable .= t3lib_parsehtml::getSubpart(
			t3lib_div::getUrl($sPath),
			$sSubpart
		);

		$sTopColumn = t3lib_parsehtml::getSubpart(
			$sTable,
			"###TOPCOLUMN###"
		);

		$sDataColumn1 = t3lib_parsehtml::getSubpart(
			$sTable,
			"###DATACOLUMN1###"
		);

		$sDataColumn2 = t3lib_parsehtml::getSubpart(
			$sTable,
			"###DATACOLUMN2###"
		);

		$sDataColumnAct = t3lib_parsehtml::getSubpart(
			$sTable,
			"###DATACOLUMNACT###"
		);

		$aHtml = array(
			"TOP" => array(),
			"DATA" => array(
				"ROW1" => array(),
				"ROW2" => array(),
				"ROWACT" => array(),
			),
		);

		$iNbCols = 0;

		reset($this->oForm->aORenderlets);
		while(list($sKey, $oObj) = each($this->oForm->aORenderlets)) {

			if(!$oObj->isChild() && $oObj->_listable() && (($oObj->bSubmitter !== TRUE && !$oObj->_renderonly()) || $oObj->_activeListable())) {

				$iNbCols++;

				$aTemp = array(
					"COLNAME"		=> $sKey,
					"COLCONTENT"	=> "{" . $sKey . "}",
				);

				if(array_key_exists($sKey, $this->__aRdtCols)) {
					
					// the column exists in the DB and is sortable

					$aHtml["TOP"][]	= $this->oForm->_parseTemplateCode(
						$sTopColumn,
						array(
							"COLNAME" => $sKey,
							"COLCONTENT"	=> "<!-- ###SORT_" . $sKey . "### begin-->{" . $sKey . ".label}<!-- ###SORT_" . $sKey . "### end-->"
						),
						array(),
						FALSE
					);
				} else {
					
					// the column doesn't exists in the DB and is not sortable

					$aHtml["TOP"][]	= $this->oForm->_parseTemplateCode(
						$sTopColumn,
						array(
							"COLNAME" => $sKey,
							"COLCONTENT"	=> "{" . $sKey . ".label}"
						),
						array(),
						FALSE
					);
				}

				$aHtml["DATA"]["ROW1"][]	= $this->oForm->_parseTemplateCode(
					$sDataColumn1,
					$aTemp,
					array(),
					FALSE
				);

				$aHtml["DATA"]["ROW2"][]	= $this->oForm->_parseTemplateCode(
					$sDataColumn2,
					$aTemp,
					array(),
					FALSE
				);

				$aHtml["DATA"]["ROWACT"][]	= $this->oForm->_parseTemplateCode(
					$sDataColumnAct,
					$aTemp,
					array(),
					FALSE
				);
			}
		}

		$sCss = '
			.lister-table				{ width: 100%;}
			.lister-table TD			{ padding: 2px; margin: 0px;}
			
			.top-row					{ background-color: #ffc0b8;}
			.top-row TD					{ font-weight: bold;}

			.top-row TD A.sort-no		{}
			.top-row TD A.sort-act-asc	{ font-weight: bold; background-image: url(' . t3lib_div::getIndpEnv("TYPO3_SITE_URL") . $this->sExtRelPath . 'res/aasc.gif); background-repeat: no-repeat; padding-right: 15px; background-position: right;}
			.top-row TD A.sort-act-desc	{ font-weight: bold; background-image: url(' . t3lib_div::getIndpEnv("TYPO3_SITE_URL") . $this->sExtRelPath . 'res/adesc.gif); background-repeat: no-repeat; padding-right: 15px; background-position: right;}

			.data-row-1					{ background-color: #faf0c6;}
			.data-row-2					{ background-color: #fff48b;}
			.data-row-act				{ background-color: gold;}
			.bottom-row					{ background-color: transparent;}
		';

		$this->oForm->additionalHeaderData(
			$this->oForm->inline2TempFile($sCss, "css", "Default datahandler:LISTER CSS"),
			"tx_ameosformidable_defaultlister"
		);

		$sTable = t3lib_parsehtml::substituteSubpart($sTable, "###DATACOLUMN1###", implode("", $aHtml["DATA"]["ROW1"]), FALSE, FALSE);
		$sTable = t3lib_parsehtml::substituteSubpart($sTable, "###DATACOLUMN2###", implode("", $aHtml["DATA"]["ROW2"]), FALSE, FALSE);
		$sTable = t3lib_parsehtml::substituteSubpart($sTable, "###DATACOLUMNACT###", implode("", $aHtml["DATA"]["ROWACT"]), FALSE, FALSE);
		$sTable = t3lib_parsehtml::substituteSubpart($sTable, "###TOPCOLUMN###", implode("", $aHtml["TOP"]), FALSE, FALSE);

		$sTable	= $this->oForm->_parseTemplateCode(
			$sTable,
			array(
				"NBCOLS" => $iNbCols
			),
			array(),
			FALSE
		);

		return $sTable;
	}

	function _injectActiveListableRdt($aRow, $aRawRow) {

		$aListable = array();

		$aRdtKeys = array_keys($this->oForm->aORenderlets);
		reset($aRdtKeys);
		while(list(, $sRdtName) = each($aRdtKeys)) {
			if($this->oForm->aORenderlets[$sRdtName]->_activeListable()) {
				
				$mValue = "";
				if(array_key_exists($sRdtName, $aRawRow)) {
					$mValue = $aRawRow[$sRdtName];
				}

				$aListable[$sRdtName] = $this->oForm->oRenderer->processHtmlBag(
					$this->oForm->aORenderlets[$sRdtName]->renderWithForcedValue($mValue),
					$this->oForm->aORenderlets[$sRdtName]
				);
			}
		}

		reset($aListable);
		return $aListable;
	}

	function _displayData($aRows, $aRawRows, $aPaging) {

//		debug($aRows, "aRows");
//		debug($aRawRows, "aRaws");

		$bDefault = FALSE;
		$aLabels		= $this->_getHumanFormData();
		$this->aLabels	= $aLabels["labels"];

/*		if($this->oForm->_navConf("/template/path/", $this->aElement) === FALSE) {
			
		}
*/		
		if($this->_navConf("/template/path/userobj") !== FALSE) {
			
			$template_path	= $this->oForm->_callUserObj($this->_navConf("/template/path/"));
			$subpart		= $this->_navConf("/template/subpart/");
			
			if(file_exists($template_path)) {
				if(is_readable($template_path)) {
					$sTable = t3lib_parsehtml::getSubpart(
						t3lib_div::getUrl($template_path),
						$subpart
					);
				} else {
					$this->oForm->mayday("DATAHANDLER LISTER - the given template file '<b>" . $template_path . "</b>' isn't readable. Please check permissions for this file.");
				}
			} else {
				$this->oForm->mayday("DATAHANDLER LISTER - the given template file '<b>" . $template_path . "</b>' doesn't exists.");
			}

		} elseif($this->_navConf("/template/path/") !== FALSE) {
			
			$template_path = t3lib_div::getFileAbsFileName($this->_navConf("/template/path/"));
			$subpart	= $this->_navConf("/template/subpart/");

			if(file_exists($template_path)) {
				if(is_readable($template_path)) {
					$sTable = t3lib_parsehtml::getSubpart(
						t3lib_div::getUrl($template_path),
						$subpart
					);
				} else {
					$this->oForm->mayday("DATAHANDLER LISTER - the given template file '<b>" . $template_path . "</b>' isn't readable. Please check permissions for this file.");
				}
			} else {
				$this->oForm->mayday("DATAHANDLER LISTER - the given template file '<b>" . $template_path . "</b>' doesn't exists.");
			}

		} else {
			// default lister template
			$sTable = $this->__buildDefaultTemplate(
				$aRows,
				$aRawRows,
				$aPaging
			);

			$bDefault = TRUE;
		}

		$aCustomTags = $this->oForm->_getCustomTags(
			$this->_navConf("/template/customtags")
		);

		$sRows		= t3lib_parsehtml::getSubpart($sTable,	"###ROWS###");

		// on rcupre les lignes alternatives
		
		if($bDefault === TRUE) {
			$sAltList = "ROW1,ROW2";
		} elseif(($sAltList = $this->_navconf("/pager/rows/alternate")) === FALSE) {
			$this->oForm->mayday("DATAHANDLER LISTER requires /control/datahandler/pager/rows/alternate to be properly set. Check your XML conf.");
		}

		$aAltList = t3lib_div::trimExplode(",", $sAltList);
		if(sizeof($aAltList) > 0) {

			$aAlt = array();
			
			reset($aAltList);
			while(list($index, $altSubpart) = each($aAltList)) {
				$aAlt[] = t3lib_parsehtml::getSubpart($sRows, $altSubpart);
			}
		}

		if($bDefault === TRUE) {
			$sAltActive = t3lib_parsehtml::getSubpart(
				$sRows,
				"ROWACT"
			);
		} elseif(($sAltActive = $this->_navconf("/pager/rows/active")) !== FALSE) {
			$sAltActive = t3lib_parsehtml::getSubpart(
				$sRows,
				$sAltActive
			);
		}



		$k = 0;
		$aRowsHtml = array();
		
		$this->__aListData = array();

		reset($aRows);
		while(list($iIndex, $aRow) = each($aRows)) {

			$aRawRow = $aRawRows[$iIndex];
			
			$this->__aListData =& $aRawRow;

			$index = $k % count($aAlt);
			$k++;
			
			$sAlt = $aAlt[$index];

			if(
				$this->entryId !== FALSE &&
				$this->entryId == $aRow[$this->_navConf("/keyname")] &&
				$sAltActive !== FALSE
			) {
				$sAlt = $sAltActive;
			}

			$aTempTags = $this->oForm->_getCustomTags(
				$this->_navConf("/template/customtags"),
				array(
					"row" => $aRow,
					"raw" => $aRawRow
				)
			);

//			debug($aRow);
			
			$aActiveListable = $this->_injectActiveListableRdt($aRawRow, $aRow);
//			debug($aActiveListable);

			$aRowsHtml[] = $this->oForm->_parseTemplateCode(
				$sAlt,
				$this->_processBeforeDisplay(
						array_merge(
						$aRow,
						$aTempTags["values"],
						$aActiveListable
					)
				),
				array(),
				FALSE,
				array_merge(
					$this->aLabels,
					$aTempTags["labels"]
				)
			);
		}

		$this->__aListData = array();

		$sRowsHtml = implode("", $aRowsHtml);
		
		
		
		$sHtml = $sTable;
		$sHtml = t3lib_parsehtml::substituteSubpart($sHtml, "###ROWS###",		$sRowsHtml, FALSE, FALSE);

		$sPaging = $this->_getPagingHtml($aPaging, $aCustomTags, $bDefault);

		$sHtml = $this->oForm->_parseTemplateCode(
			$sHtml,
			array(
				"PAGER" => $sPaging
			),
			array(),
			FALSE,
			array_merge(
				$this->aLabels,
				empty($aTempTags["labels"]) ? array() : $aTempTags["labels"]
			)
		);

//		debug($this->aLabels);
//		debug($aCustomTags);
		$sHtml = $this->oForm->_parseTemplateCode(
			$sHtml,
			$aCustomTags["values"],
			array(),
			TRUE,	// TRUE ou FALSE ???
			array_merge(
				$this->aLabels,
				$aCustomTags["labels"]
			)
		);
//		debug($sHtml);
		
		
		
		// on traite les colones triables

		$sFormId = $this->oForm->formid;

		$sortfield		= $this->_getSortfield();
		$sortdirection	= $this->_getSortdirection();

		if(!empty($this->oForm->aORenderlets)) {

			reset($this->oForm->aORenderlets);
			while(list(, $oRenderlet) = each($this->oForm->aORenderlets)) {

				$sFieldName = $oRenderlet->_getName();

				$sorthandler = "###SORT_" . $sFieldName . "###";

				if(($sortHtml = trim(t3lib_parsehtml::getSubpart($sHtml, $sorthandler))) != "") {

					$direction = "DESC";
					$sDir = "";
					$sCssClass = "sort-asc-no";

					if(($sortfield == $sFieldName)) {
						
						if($sortdirection == "DESC") {
							
							$direction = "ASC";
							
							$sDir = (!$bDefault ? " [Z-a]" : "");
							$sCssClass = "sort-act-desc";

						} else {
							
							$sDir = (!$bDefault ? " [a-Z]" : "");
							$sCssClass = "sort-act-asc";
						}
					}

					
					$sCssClass = $sFieldName . "_sort " . $sCssClass;

					$sHtml = t3lib_parsehtml::substituteSubpart(
						$sHtml,
						$sorthandler,
						"<a href=\"javascript:void(Formidable.Lister.Sort.by('{$sFieldName}', '{$direction}', '{$sFormId}'));\" class=\"" . $sCssClass . "\">" . $sortHtml . $sDir . "</a>",
						FALSE,
						FALSE
					);
				}
			}
		}
		
		return "<p id='LISTER_" . $sFormId . "' style='height: 0px;'></p>" . $sHtml;
	}

	function _getPagingHtml($aPaging, $aCustomTags, $bDefault = FALSE) {

		$aPagerConf = $this->oForm->_navConf("/pager", $this->aElement);

		if($bDefault === TRUE) {
			$sPath = $this->sExtPath . "res/_defaulttemplate.html";
			$sSubPart = "###LISTPAGER###";
		} else {
			$sPath = t3lib_div::getFileAbsFileName($aPagerConf["template"]["path"]);
			$sSubPart = $aPagerConf["template"]["subpart"];
		}

		$sPager = t3lib_parsehtml::getSubpart(
			t3lib_div::getUrl($sPath),
			$sSubPart
		);

		$sLinkFirst = $sLinkPrev = $sLinkNext = $sLinkLast = "";

		if($aPaging["first"] != "") {

			$sLinkFirst	= $this->oForm->_parseTemplateCode(
				t3lib_parsehtml::getSubpart(
					$sPager,
					"###LINKFIRST###"
				),
				array_merge(
					array(
						"link" => $aPaging["first"]
					),
					$aCustomTags["values"]
				),
				array(),
				FALSE,
				array_merge(
					$this->aLabels,
					$aCustomTags["labels"]
				)
			);
		}

		if($aPaging["prev"] != "") {

			$sLinkPrev = $this->oForm->_parseTemplateCode(
				t3lib_parsehtml::getSubpart(
					$sPager,
					"###LINKPREV###"
				),
				array_merge(
					array(
						"link" => $aPaging["prev"]
					),
					$aCustomTags["values"]
				),
				array(),
				FALSE,
				array_merge(
					$this->aLabels,
					$aCustomTags["labels"]
				)
			);
		}
		
		if($aPaging["next"] != "") {

			$sLinkNext = $this->oForm->_parseTemplateCode(
				t3lib_parsehtml::getSubpart(
					$sPager,
					"###LINKNEXT###"
				),
				array_merge(
					array(
						"link" => $aPaging["next"]
					),
					$aCustomTags["values"]
				),
				array(),
				FALSE,
				array_merge(
					$this->aLabels,
					$aCustomTags["labels"]
				)
			);
		}

		if($aPaging["last"] != "") {

			$sLinkLast = $this->oForm->_parseTemplateCode(
				t3lib_parsehtml::getSubpart(
					$sPager,
					"###LINKLAST###"
				),
				array_merge(
					array(
						"link" => $aPaging["last"]
					),
					$aCustomTags["values"]
				),
				array(),
				FALSE,
				array_merge(
					$this->aLabels,
					$aCustomTags["labels"]
				)
			);
		}

		//debug($aPaging);

		if(!empty($aPaging["window"])) {

			$sWindow = t3lib_parsehtml::getSubpart(
				$sPager,
				"###WINDOW###"
			);

			$sLinkNo = t3lib_parsehtml::getSubpart(
				$sWindow,
				"###NORMAL###"
			);

			$sLinkAct = t3lib_parsehtml::getSubpart(
				$sWindow,
				"###ACTIVE###"
			);

			$aLinks = array();
			reset($aPaging["window"]);
			while(list($iPageNum, $sLink) = each($aPaging["window"])) {
				
				if($aPaging["page"] == $iPageNum) {
					$aLinks[] = $this->oForm->_parseTemplateCode(
						$sLinkAct,
						array(
							"link" => $sLink,
							"page" => $iPageNum,
						)
					);
				} else {
					$aLinks[] = $this->oForm->_parseTemplateCode(
						$sLinkNo,
						array(
							"link" => $sLink,
							"page" => $iPageNum,
						)
					);
				}

				$sLinks = implode(" ", $aLinks);
			}
			
			$sWindow = t3lib_parsehtml::substituteSubpart($sWindow, "###WINDOWLINKS###", $sLinks, FALSE, FALSE);
		}

		$sPager = $this->oForm->_parseTemplateCode(
			$sPager,
			array_merge(
				array(
					"page" => $aPaging["page"],
					"pagemax" => $aPaging["pagemax"]
				),
				$aCustomTags["values"]
			),
			array(),
			FALSE,
			array_merge(
				$this->aLabels,
				$aCustomTags["labels"]
			)
		);

		$sPager = t3lib_parsehtml::substituteSubpart($sPager, "###LINKFIRST###",$sLinkFirst, FALSE, FALSE);
		$sPager = t3lib_parsehtml::substituteSubpart($sPager, "###LINKPREV###",	$sLinkPrev, FALSE, FALSE);
		$sPager = t3lib_parsehtml::substituteSubpart($sPager, "###LINKNEXT###",	$sLinkNext, FALSE, FALSE);
		$sPager = t3lib_parsehtml::substituteSubpart($sPager, "###LINKLAST###",	$sLinkLast, FALSE, FALSE);

		return t3lib_parsehtml::substituteSubpart($sPager, "###WINDOW###", $sWindow, FALSE, FALSE);
	}

	function _getLimit() {
		
		$iPage = $this->_getPage();

		$iRowsPerPage = 5;	// default value

		if(($mRowsPerPage = $this->_navConf("/pager/rows/perpage")) !== FALSE) {
			if($this->oForm->isUserObj($mRowsPerPage)) {
				$iRowsPerPage = $this->oForm->_callUserObj($mRowsPerPage);
			} else {
				if(intval($mRowsPerPage) > 0) {
					$iRowsPerPage = $mRowsPerPage;
				}
			}
		}
		
		$iOffset = ($iPage) * $iRowsPerPage;	// counting the offset
		$iNbDisplayed = $iRowsPerPage;
		
		if(($mMaximum = $this->_navConf("/pager/rows/maximum")) !== FALSE) {

			if($this->oForm->isUserObj($mMaximum)) {
				$mMaximum = $this->oForm->_callUserObj($mMaximum);
			}
			
			if($mMaximum !== FALSE && (($iOffset + $iRowsPerPage) > $mMaximum)) {
				$iNbDisplayed = $mMaximum - $iOffset;
			}
		}
		
		return array(
			"sql"			=> " LIMIT " . $iOffset . ", " . $iNbDisplayed . " ",
			"page"			=> $iPage,
			"offset"		=> $iOffset,
			"rowsperpage"	=> $iRowsPerPage
		);
	}
	
	function _getPaging($aLimit, $iNumRows) {
		
		if(($mMaximum = $this->_navConf("/pager/rows/maximum")) !== FALSE) {

//			debug($mMaximum);

			if($this->oForm->isUserObj($mMaximum)) {
				$mMaximum = $this->oForm->_callUserObj($mMaximum);
			}
			
			if($mMaximum !== FALSE && $iNumRows > $mMaximum) {
				
				if(($mTooMany = $this->_navConf("/pager/rows/toomany")) !== FALSE) {

					if(is_array($mTooMany)) {
						if(
							$this->_isSubmitted()
							||
							(array_key_exists("atstartup", $mTooMany) && $this->oForm->_isTrueVal($mTooMany["atstartup"]))
						) {
							
							if($this->oForm->isUserObj($mTooMany)) {
								$this->oForm->_callUserObj(
									$mTooMany,
									array(
										"numrows" => $iNumRows,
										"maximum" => $mMaximum,
									)
								);
							}

						}
					}
				}

				$iNumRows = $mMaximum;
			}
		}

		$iPageMax = (ceil($iNumRows/ $aLimit["rowsperpage"]) - 1);

		$sFirst = $sPrev = $sNext = $sLast = "";




		// generating javascript links & functions

		$sLinkFirst = $sLinkPrev = $sLinkNext = $sLinkLast = "";

		$sFormId = $this->oForm->formid;

		require_once(PATH_tslib . "class.tslib_pagegen.php");
		
		if($iPageMax >= 0) {

			if($aLimit["page"] > 0) {

				$sLinkFirst = "javascript:void(Formidable.Lister.Pager.goTo('" . $sFormId . "', 0));";
				$sLinkPrev = "javascript:void(Formidable.Lister.Pager.goTo('" . $sFormId . "', " . ($aLimit["page"] - 1) . "));";

			} else {
				// we're on page one, don't enable 'previous' link
				// nor 'first page' link
			}
			
			// print 'next' link only if we're not
			// on the last page
			
			if($aLimit["page"] == $iPageMax) {
				// we're on the last page, don't enable 'next' link
				// nor 'last page' link
			} else {
				$sLinkNext = "javascript:void(Formidable.Lister.Pager.goTo('" . $sFormId . "', " . ($aLimit["page"] + 1) . "));";
				$sLinkLast = "javascript:void(Formidable.Lister.Pager.goTo('" . $sFormId . "', " . ($iPageMax) . "));";
			}
		}

		$iPage = ($iPageMax == -1) ? 0 : $aLimit["page"] + 1;
		$aWindow = array();

		if(($iWindow = $this->_navConf("/pager/nav/window")) !== FALSE && $iNumRows > 0) {

			// generating something like < 24 25 *26* 27 28 >

			$iStart = $iPage - 3;
			if($iStart < 0) {
				$iStart = 0;
			}

			$iEnd = $iPage + 1;
			if($iEnd > $iPageMax) {
				$iEnd = $iPageMax;
			}

			for($k = $iStart; $k <= $iEnd; $k++) {
				$aWindow[($k + 1)] = "javascript:void(Formidable.Lister.Pager.goTo('" . $sFormId . "', " . $k . "));";
			}
		}
		
		return array(
			"numrows"	=>	$iNumRows,
			"offset"	=>	$aLimit["offset"],
			"page"		=>	$iPage,
			"pagemax"	=>	$iPageMax + 1,
			"first"		=>	$sLinkFirst,
			"prev"		=>	$sLinkPrev,
			"next"		=>	$sLinkNext,
			"last"		=>	$sLinkLast,
			"window"	=>	$aWindow,
		);
	}

	function _getFormData($bDefault = TRUE) {

		/* trying to avoid infinite recursivity renderlet::defaultvalue->getFormdata->renderlet::defaultvalue ... */
		return parent::_getFormData($bDefault);
	}

	function _processDuringLister($aRow) {
		
		if(($aUserObj = $this->_navConf("/process/duringlister/")) !== FALSE) {

			$aRow = $this->oForm->_callUserObj(
				$aUserObj,
				$aRow
			);

			if(!is_array($aRow)) {
				$aRow = array();
			}
		}

		reset($aRow);
		return $aRow;
	}

	function _processDuringListerRaw($aRow) {
		
		if(($aUserObj = $this->_navConf("/process/duringlisterraw/")) !== FALSE) {

			$aRow = $this->oForm->_callUserObj(
				$aUserObj,
				$aRow
			);

			if(!is_array($aRow)) {
				$aRow = array();
			}
		}

		reset($aRow);
		return $aRow;
	}

	function _processBeforeSearch($aData) {
		
		if(($aUserObj = $this->_navConf("/process/beforesearch/")) !== FALSE) {

			$aData = $this->oForm->_callUserObj(
				$aUserObj,
				$aData
			);

			if(!is_array($aData)) {
				$aData = array();
			}
		}

		reset($aData);
		return $aData;
	}

	function _processBeforeDisplay($aRow) {

		if(($aUserObj = $this->_navConf("/process/beforedisplay/")) !== FALSE) {

			$aRow = $this->oForm->_callUserObj(
				$aUserObj,
				$aRow
			);

			if(!is_array($aRow)) {
				$aRow = array();
			}
		}

		reset($aRow);
		return $aRow;
	}

	function i18n_getSysLanguageUid() {

		if(($mSysLanguageUid = $this->_navConf("/i18n/sys_language_uid/")) !== FALSE) {
			
			if($this->oForm->isUserObj($mSysLanguageUid)) {
				$mSysLanguageUid = $this->oForm->_callUserObj($mSysLanguageUid);
			}
			
			return $mSysLanguageUid;
		}
		
		return $GLOBALS["TSFE"]->tmpl->setup["config."]["sys_language_uid"];
	}

	function enableFields() {
		return $this->_defaultFalse("/enablefields");
	}
}


	if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/base/dh_lister/api/class.tx_dhlister.php"])	{
		include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/base/dh_lister/api/class.tx_dhlister.php"]);
	}
?>