<?php
/** 
 * Plugin 'dh_raw' for the 'ameos_formidable' extension.
 *
 * @author	Jerome Schneider <typo3dev@ameos.com>
 */


class tx_dhraw extends formidable_maindatahandler {

	function _doTheMagic($bShouldProcess = TRUE) {

		if($bShouldProcess && $this->_allIsValid()) {

			$sReturnMode = strtoupper($this->_navConf("/returnmode/"));

			$aDataRaw		= $this->_getFormData();
			$aDataManaged	= $this->_getFormDataManaged();
			$aDataProcessed	= array();

			reset($aDataManaged);
			while(list($elementname, $value) = each($aDataManaged)) {
				// $aDataProcessed[$elementname] = $this->oForm->aORenderlets[$elementname]->_fromRenderletToDataHandler($value);
				$aDataProcessed[$elementname] = $this->oForm->aORenderlets[$elementname]->_flatten($value);
			}
			
			switch($sReturnMode)
			{
				case "MANAGED" :
				{
					$aVars = $aDataManaged;
					break;
				}
				case "PROCESSED" :
				{
					$aVars = $aDataProcessed;
					break;
				}
				case "RAW" :
				default :
				{
					$sReturnMode = "RAW ( unprocessed )";
					$aVars = $aDataRaw;
					break;
				}
			}

			$this->oForm->_debug($aVars, "DATAHANDLER RAW - EXECUTION using mode " . $sReturnMode . " for returned data array");
			
			// on apelle le callback sur l'objet parent
			// pour lui passer les valeurs brutes du formulaire
			
			$callback = $this->oForm->_navConf("/control/datahandler/parentcallback/");
			if($callback === FALSE) {
				$callback = $this->oForm->_navConf("/control/datahandler/callback/");
			}
			
			if($callback !== FALSE) {

				if(is_string($callback)) {
					if(method_exists($this->oForm->_oParent, $callback)) {
						$this->oForm->_oParent->{$callback}($aVars);
					} else {
						$this->oForm->mayday("DATAHANDLER RAW : the callback method " . $callback . " doesn't exists in the definition of the Parent object");
					}
				} elseif($this->oForm->isUserObj($callback)) {
					$this->oForm->_callUserObj(
						$callback,
						$aVars
					);
				}
			}
			else
			{ $this->oForm->mayday("DATAHANDLER RAW : you MUST declare a callback method on the Parent Object <b>" . get_class($this->oForm->_oParent) . "</b> in the section <b>/control/datahandler/parentcallback/</b> of the XML conf for this DATAHANDLER ( RAW )");}
		}
	}
}


	if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/base/dh_raw/api/class.tx_dhraw.php"])	{
		include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/base/dh_raw/api/class.tx_dhraw.php"]);
	}
?>