<?php
/** 
 * Plugin 'rdr_template' for the 'ameos_formidable' extension.
 *
 * @author	Jerome Schneider <typo3dev@ameos.com>
 */

class tx_rdrtemplate extends formidable_mainrenderer {
	
	var $aCustomTags	= array();
	var $aExcludeTags	= array();
	var $sTemplateHtml	= FALSE;
	
	function getTemplatePath() {
		if($this->_navConf("/template/path/userobj/") !== FALSE) {
			return $this->oForm->_callUserObj($this->_navConf("/template/path/"));
		} else {
			return t3lib_div::getFileAbsFileName($this->_navConf("/template/path/"));
		}

		return "";
	}

	function getTemplateSubpart() {
		 $sSubpart = $this->_navConf("/template/subpart/");
		 if($this->oForm->isUserObj($sSubpart)) {
			$sSubpart = $this->oForm->_callUserObj(
				$sSubpart
			);
		}

		return $sSubpart;
	}

	function getTemplateHtml() {

		if($this->sTemplateHtml === FALSE) {
			$sPath = $this->getTemplatePath();

			if(!empty($sPath)) {
				$sSubpart = $this->getTemplateSubpart();
				$mHtml = t3lib_parsehtml::getSubpart(
					t3lib_div::getUrl($sPath),
					$sSubpart
				);

				if(trim($mHtml) == "") {
					$this->oForm->mayday("RENDERER TEMPLATE - The given template (<b>'" . $sPath . "'</b> with subpart marquer <b>'" . $sSubpart . "'</b>) <b>returned an empty string</b> - Check your template");
				}

			} elseif(($mHtml = $this->_navConf("/html")) !== FALSE) {
				if($this->oForm->isUserObj($mHtml)) {
					$mHtml = $this->oForm->_callUserObj($mHtml);
				}
			}

			$this->sTemplateHtml = $mHtml;
		}

		return $this->sTemplateHtml;
	}

	function _render($aRendered) {

		$aRendered = $this->beforeDisplay($aRendered);

		$this->oForm->_debug($aRendered, "RENDERER TEMPLATE - rendered elements array");
		$template_path	= $this->getTemplatePath();
		$form_subpart	= $this->getTemplateSubpart();
		
		$errors_tag		= $this->_navConf("/template/errortag/");
		if($this->oForm->isUserObj($errors_tag)) {
			$errors_tag = $this->oForm->_callUserObj(
				$errors_tag
			);
		}

		$aLabels		= $this->oForm->oDataHandler->_getHumanFormData();
		$aLabels		= $aLabels["labels"];

		if(($aTags = $this->_navConf("/template/customtags")) !== FALSE) {
			$this->aCustomTags = $this->oForm->_getCustomTags($aTags);
			reset($this->aCustomTags["values"]);

			while(list($sKey, $sValue) = each($this->aCustomTags["values"])) {
				// on substitue les balises dans les customtags
				$this->aCustomTags["values"][$sKey] = $this->oForm->_parseTemplateCode(
					$sValue,
					$aRendered,
					array_merge($this->aExcludeTags, array($errors_tag, $errors_tag . ".cssdisplay")),
					FALSE,
					array_merge(
						$aLabels,
						$this->aCustomTags["labels"]
					)
				);
			}
		}

		$aRendered = $this->displayOnlyIfJs($aRendered);
		$mHtml = $this->getTemplateHtml();
		$sForm = $this->oForm->_parseTemplateCode(
			$mHtml,
			array_merge($aRendered, (is_array($this->aCustomTags["values"]) ? $this->aCustomTags["values"] : array())),
			array_merge($this->aExcludeTags, array($errors_tag, $errors_tag . ".cssdisplay")),
			FALSE,
			array_merge(
				$aLabels,
				(is_array($this->aCustomTags["labels"]) ? $this->aCustomTags["labels"] : array())
			)
		);

		$aErrors = array();
		$aCompiledErrors = array();
		$aErrorKeys = array_keys($this->oForm->_aValidationErrors);
		while(list(, $sRdtName) = each($aErrorKeys)) {
			if(trim($this->oForm->_aValidationErrors[$sRdtName]) !== "") {
				$aCompiledErrors[] = $this->oForm->_aValidationErrors[$sRdtName];
				$aErrors[$sRdtName] = $this->oForm->_aValidationErrors[$sRdtName];
				$aErrors[$sRdtName . ".tag"] = "<span class='errors'>" . $this->oForm->_aValidationErrors[$sRdtName] . "</span>";
			}
		}


		$aErrors["__compiled"] = implode("<br />", $aCompiledErrors);
		$aErrors["cssdisplay"] = ($this->oForm->oDataHandler->_allIsValid()) ? "none" : "block";
		$aHelp = array_keys($aErrors);
		sort($aHelp);
		$aErrors["help"] = t3lib_div::view_array($aHelp);

		$sGlobal = $this->oForm->_parseTemplateCode(
			$sForm,
			array(
				$errors_tag => $aErrors,
			),
			$this->aExcludeTags,
			TRUE
		);

		return $this->_wrapIntoForm($sGlobal);
	}

	function beforeDisplay($aRendered) {

		if(($aUserObj = $this->_navConf("/beforedisplay/")) !== FALSE) {
			$aRendered = $this->oForm->_callUserObj(
				$aUserObj,
				$aRendered
			);
		}

		if(!is_array($aRendered)) {
			$aRendered = array();
		}

		reset($aRendered);
		return $aRendered;
	}

	function cleanBeforeSession() {
		$this->sTemplateHtml = FALSE;
		parent::cleanBeforeSession();
	}
}


	if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/base/rdr_template/api/class.tx_rdrtemplate.php"])	{
		include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/base/rdr_template/api/class.tx_rdrtemplate.php"]);
	}

?>