<?php
/** 
 * Plugin 'rdt_ajaxlist' for the 'ameos_formidable' extension.
 *
 * @author	Jerome Schneider <typo3dev@ameos.com>
 */


class tx_rdtajaxlist extends formidable_mainrenderlet {

	var $sMajixClass = "AjaxList";
	var $aLibs = array(
		"rdt_ajaxlist_class" => "res/js/ajaxlist.js",
		"rdt_ajaxlist_slider" => "res/slider.js",		// http://www.aldenta.com/examples/script.aculo.us/slider-images.html
	);
	var $bCustomIncludeScript = TRUE;

	function _render() {

		$this->_initSessionData();
		return $this->_getHtml();
	}


	function _getHtml() {

		$aData = $this->_fetchData();
		$sSkin = (($sTemp = $this->_navConf("/template/sliderskin/")) !== FALSE) ? $sTemp : "grey";
		$aSkinInfos = $this->_getSliderSkinInfos($sSkin);

		$this->includeScripts($aData);
		$this->includeStyles($aSkinInfos);
		
		

		$sLabel = $this->oForm->_getLLLabel($this->aElement["label"]);

		// PRODUCING HTML
		$sHtmlId = $this->_getElementHtmlId();
		$sHtmlGrid = "<div id='" . $sHtmlId . "'>" . $this->_renderRows() . "</div>";
		$sHtmlHandler =<<<HANDLER

		<div id="{$sHtmlId}_pager" style="height:10px;">
			<div id="{$sHtmlId}_left"></div>
			<div id="{$sHtmlId}_pagerhandler">
				<img src="{$aSkinInfos["skinwebpath"]}handle.png" alt="" style="float: left;" />
			</div>
		</div>
		
		<p id="{$sHtmlId}_pagerdebug">&nbsp;</p>

HANDLER;


		$sSortingHtml = $this->_getSorting($aData);

		$aHtmlBag = array(
			"__compiled" => $this->_displayLabel($sLabel) . $sSortingHtml . $sHtmlGrid . $sHtmlHandler,
			"input" => $sInput,
		);

		return $aHtmlBag;
	}

	

	function includeScripts($aData) {
		
		$sHtmlId = $this->_getElementHtmlId();
		$sPath = t3lib_div::getIndpEnv("TYPO3_SITE_URL") . "/index.php?eID=tx_ameosformidable&object=rdt_ajaxlist&servicekey=content&safelock=" . $this->_getSessionDataHashKey() . "&formhash=" . $this->oForm->_getSessionDataHashKey();
		
		
		$sJson = $this->oForm->array2json(
			array(
				"id" => $sHtmlId,
				"url" => $sPath,
				"pagerid" => $sHtmlId . "_pager",
				"pagerhandlerid" => $sHtmlId . "_pagerhandler",
				"pagerdebugid" => $sHtmlId . "_pagerdebug",
				"pagernbrows" => $aData["nbrows"],
				"pagernbpages" => $aData["nbpages"],
			)
		);

		$sScript =<<<JAVASCRIPT

	Formidable.Context.Forms["{$this->oForm->formid}"].Objects["{$sHtmlId}"] = new Formidable.Classes.AjaxList(
		{$sJson}
	);

JAVASCRIPT;

		$this->oForm->attachInitTask(
			$sScript,
			"AjaxList " . $sHtmlId . " initialization"
		);
	}

	function includeStyles($aSkinInfos) {

		$sCssId = $this->_getElementCssId();

		$sStyles =<<<STYLES

			/* put the left rounded edge on the track */

			#{$sCssId}_left {
				position: absolute;
				width: 5px;
				height: 9px;
				background: transparent url({$aSkinInfos["skinwebpath"]}track-left.png) no-repeat top left;
				cursor: pointer;
			}
			
			/* put the track and the right rounded edge on the track */

			#{$sCssId}_pager {
				background: transparent url({$aSkinInfos["skinwebpath"]}track-right.png) no-repeat top right;
				cursor: pointer;
			}

			#{$sCssId}_pagerhandler {
				cursor: ew-resize;
				width: {$aSkinInfos["handle"]["dimensions"][0]}px;
				height:{$aSkinInfos["handle"]["dimensions"][1]}px;
			}

STYLES;

		$this->oForm->additionalHeaderData(
			$this->oForm->inline2TempFile($sStyles, 'css', "AjaxList " . $sCssId . " skin styles")
		);
	}

	function _getSliderSkinInfos($sSkin) {

		$aInfos = array();

		if(!is_dir($this->sExtPath . "res/skins/slider/" . $sSkin . "/")) {
			$sSkin = "grey";
		}

		require_once(PATH_t3lib . "class.t3lib_stdgraphic.php");
		$oGraph = t3lib_div::makeInstance("t3lib_stdgraphic");

		$aInfos["skin"] = $sSkin;
		$aInfos["skinabspath"] = $this->sExtPath . "res/skins/slider/" . $sSkin . "/";
		$aInfos["skinrelpath"] = $this->sExtRelPath . "res/skins/slider/" . $sSkin . "/";
		$aInfos["skinwebpath"] = $this->sExtWebPath . "res/skins/slider/" . $sSkin . "/";

		$aInfos["handle"] = array();
		$aInfos["handle"]["abspath"] = $aInfos["skinabspath"] . "handle.png";
		$aInfos["handle"]["relpath"] = $aInfos["skinrelpath"] . "handle.png";
		$aInfos["handle"]["webpath"] = $aInfos["skinwebpath"] . "handle.png";
		$aInfos["handle"]["dimensions"] = $oGraph->getImageDimensions($aInfos["handle"]["abspath"]);

		return $aInfos;
	}
	
	function _initSessionData() {

		$sHashKey = $this->_getSessionDataHashKey();
		
		if(!array_key_exists("rdt_ajaxlist", $GLOBALS["_SESSION"]["ameos_formidable"]["ajax_services"])) {
			$GLOBALS["_SESSION"]["ameos_formidable"]["ajax_services"]["rdt_ajaxlist"] = array();
			$GLOBALS["_SESSION"]["ameos_formidable"]["ajax_services"]["rdt_ajaxlist"]["content"] = array();
		}

		// flush all previous session data for this list
		$GLOBALS["_SESSION"]["ameos_formidable"]["ajax_services"]["rdt_ajaxlist"]["content"][$sHashKey] = array(
			"requester" => array(
				"name" => $this->_getName(),
				"xpath" => $this->sXPath,
			),
		);

		$this->oForm->bStoreFormInSession = TRUE;
	}

	function _getSorting($aData) {

		$sTemplate = $this->_getTemplate();
		
		if(($sSortSubpart = $this->_navConf("/template/sort")) !== FALSE) {
			$sSortTemplate = t3lib_parsehtml::getSubpart($sTemplate, $sSortSubpart);
		}

//		debug($aData, $sSortTemplate);

		$this->aSortingTags = array();

		@preg_replace_callback(
			"/{[a-zA-Z0-9_:\/.]*}/",
			array($this, "__getSortingTags"),
			$sSortTemplate
		);

		reset($this->aSortingTags);
//		debug($this->aSortingTags, "aSortingTags");

		while(list(, $sTag) = each($this->aSortingTags)) {
			
			$sAction = $this->_getSortingAction($sTag);
			
			$sSortTemplate = str_replace(
				"{" . $sTag . "}",
				"<a href=\"javascript:void(" . $sAction . ");\">" . $sTag . "</a>",
				$sSortTemplate
			);
		}

		return $sSortTemplate;
	}

	function __getSortingTags($aLabel) {	// tool function for _getSorting::preg_replace_callback
		$this->aSortingTags[] = str_replace(array("{", "}"), "", array_pop($aLabel));
	}

	function _getSortingAction($sTag) {
		return "Formidable.f('" . $this->oForm->formid . "').o('" . $this->_getElementHtmlId() . "').doSortOn('" . $sTag . "')";
	}
	
	function _fetchData($aParams = array()) {

		$iPage = array_key_exists("page", $aParams) ? intval($aParams["page"]) : 0;

		$aConfig = array(
			"page" => $iPage,
			"sortcolumn" => $aParams["sortcolumn"],
			"sortdirection" => $aParams["sortdirection"],
			"perpage" => $this->aElement["datasource"]["perpage"],
		);
		
		if(($sDsToUse = $this->_navConf("/datasource/use")) === FALSE) {
			$this->oForm->mayday("RENDERLET AJAXLIST - requires /datasource/use to be properly set. Check your XML conf.");
		} elseif(!array_key_exists($sDsToUse, $this->oForm->aODataSources)) {
			$this->oForm->mayday("RENDERLET AJAXLIST - refers to undefined datasource '" . $sDsToUse . "'. Check your XML conf.");
		}

		$aData = $this->oForm->aODataSources[$this->aElement["datasource"]["use"]]->fetchData($aConfig);
		$aData = $this->_refine($aData);
		return $aData;
	}

	function handleAjaxRequest($oRequest) {
		if($oRequest->aRequest["servicekey"] == "content") {

			return array(
				"html" => utf8_encode(
					$this->_renderRows(
						array(
							"page"			=> $_GET["page"],
							"sortcolumn"	=> $_GET["sortcolumn"],
							"sortdirection"	=> $_GET["sortdirection"],
						)
					)
				)
			);

		}
	}

	function _renderRows($aParams = array()) {
		
		require_once(PATH_t3lib . "class.t3lib_parsehtml.php");

		$aData = $this->_fetchData($aParams);
		$sTemplate = $this->_getTemplate();

		if(($sAltList = $this->_navconf("/template/alternate")) === FALSE) {
			$this->oForm->mayday("RENDERLET AJAXLIST - requires /template/alternate to be properly set. Check your XML conf.");
		}
		
		$aAltList = t3lib_div::trimExplode(",", $sAltList);
		if(sizeof($aAltList) > 0) {

			$aAlt = array();
			
			reset($aAltList);
			while(list(, $sAltSubpart) = each($aAltList)) {
				$aAlt[] = t3lib_parsehtml::getSubpart($sTemplate, $sAltSubpart);
			}
		}


		$k = 0;
		$aHtml = array();

		reset($aData["data"]);
		while(list($iIndex, ) = each($aData["data"])) {
			$aHtml[] = $this->oForm->_parseTemplateCode(
				$aAlt[$k++ % count($aAlt)],		// current alternate subpart for row
				$aData["data"][$iIndex]
			);
		}

		return implode("", $aHtml);
	}

	function _getTemplate() {

		$sTemplate = "";

		if(($sPath = $this->_navConf("/template/path")) === FALSE) {
			$this->oForm->mayday("RENDERLET AJAXLIST - requires /template/path to be properly set. Check your XML conf.");
		} else {
			
			$sRealPath	= t3lib_div::getFileAbsFileName($sPath);

			if(file_exists($sRealPath)) {
				if(is_readable($sRealPath)) {
					$sTemplate = t3lib_div::getUrl($sRealPath);
				} else {
					$this->oForm->mayday("RENDERLET AJAXLIST - the given template file '<b>" . $sRealPath . "</b>' isn't readable. Please check permissions for this file.");
				}
			} else {
				$this->oForm->mayday("RENDERLET AJAXLIST - the given template file '<b>" . $sRealPath . "</b>' doesn't exists.");
			}
		}

		return $sTemplate;
	}
	
	function _refine($aData) {
		
//		debug($aData["data"]);

		if(($aColumns = $this->_navConf("/datasource/columns/")) !== FALSE) {

			$aRdt = array();
			reset($aColumns);
			while(list($sTagName, $aColumn) = each($aColumns)) {
				$aRdt[$aColumn["name"]] = $this->oForm->_makeRenderlet($aColumn, $this->sXPath . "datasource/columns/" . $sTagName . "/");
			}

			reset($aData["data"]);
			while(list($iRow, ) = each($aData["data"])) {

				$this->oForm->oDataHandler->__aListData = $aData["data"][$iRow];

				reset($aRdt);
				while(list($sRdt, ) = each($aRdt)) {
					if(array_key_exists($sRdt, $aData["data"][$iRow])) {
						
						// this column exists in the datasource
						if($aRdt[$sRdt]->_activeListable()) {
							$aData["data"][$iRow][$sRdt] = $aRdt[$sRdt]->renderWithForcedValue(
								$aData["data"][$iRow][$sRdt]
							);
						} else {
							$aData["data"][$iRow][$sRdt] = $aRdt[$sRdt]->_getHumanReadableValue(
								$aData["data"][$iRow][$sRdt]
							);
						}
					} else {
						// this is a virtual column
						if($aRdt[$sRdt]->_activeListable()) {
							$aData["data"][$iRow][$sRdt] = $aRdt[$sRdt]->render();
						}
					}
				}

				$this->oForm->oDataHandler->__aListData = array();
			}

			
//			debug($aColumns);
		}

		return $aData;
	}
	
	function _renderOnly() {
		return TRUE;
	}
}


	if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/base/rdt_ajaxlist/api/class.tx_rdtajaxlist.php"])	{
		include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/base/rdt_ajaxlist/api/class.tx_rdtajaxlist.php"]);
	}
?>