Formidable.Classes.AjaxList = Formidable.Classes.RdtBaseClass.extend({
	Buffer: {},			// caches ajax requests
	Slider: null,		// Sliderbar object
	CurrentSort: {		// current sorting info
		column: "",
		direction: ""
	},
	
	constructor: function(config) {		// constructor
		this.base(config);

		this.Slider = new Control.Slider(
			this.config.pagerhandlerid,
			this.config.pagerid,
			{
				range: $R(1, this.config.pagernbpages),
				step: 1,
				values: $R(1, this.config.pagernbpages),
				increment: 1,
				restricted: true,
				onSlide: this.doSlide.bind(this),
				onChange: this.doChange.bind(this)
			}
		);
	},
	clearBuffer: function() {
		this.Buffer = {};
	},
	doSlide: function(v) {
		$(this.config.pagerdebugid).innerHTML = 'slide page: ' + Math.round(v);
	},
	doChange: function(v) {
		
		var iValue = Math.round(v);
		$(this.config.pagerdebugid).innerHTML = 'changed: ' + iValue;
		this.request(
			this.config.url + "&page=" + (iValue-1) + "&sortcolumn=" + escape(this.CurrentSort.column) + "&sortdirection=" + escape(this.CurrentSort.direction)
		);
	},
	doSortOn: function(sColumn) {
		this.setSortOn(sColumn);
		this.Slider.setValue(1);
	},
	setSortOn: function(sColumn) {
		if(this.CurrentSort.column == "" || this.CurrentSort.column != sColumn) {
			this.CurrentSort.column = sColumn;
			this.CurrentSort.direction = "DESC";
		} else {
			if(this.CurrentSort.column == sColumn) {
				if(this.CurrentSort.direction == "DESC") {
					this.CurrentSort.direction = "ASC";
				} else {
					this.CurrentSort.direction = "DESC";
				}
			}
		}
	},
	request: function(sUrl) {
		if(!this.Buffer[sUrl]) {
			Formidable.displayLoader();
			new Ajax.Request(
				sUrl,
				{
					method:'get',
					onSuccess: function(transport) {
						Formidable.removeLoader();
						eval("var oJson=" + transport.responseText + ";");
						this.domNode().innerHTML = oJson.html;
						this.Buffer[sUrl] = oJson;
					}.bind(this),
					onFailure: function(){
						Formidable.removeLoader();
						$(this.config.id).innerHTML='Something went wrong...';
					}.bind(this)
				}
			);

		} else {
			$(this.config.id).innerHTML = this.Buffer[sUrl].html;
		}
	}
});