<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 2006 Radu Cocieru <radu@cocieru.com>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/** 
 * Plugin 'rdt_captcha' for the 'ameos_formidable' extension.
 *
 * @author	Luc Muller <l.muller@ameos.com>
 */
class tx_rdtcaptcha extends formidable_mainrenderlet{
  
	function _render(){

		$sLabel = $this->oForm->_getLLLabel($this->aElement["label"]);
		$sValue = htmlspecialchars(
			$this->oForm->oDataHandler->getThisFormData($this->_getName())
		);
		$aFormData = $this->oForm->oDataHandler->_getFormData();

		$this->_MakeCaptchaConfig();

		

		$sLabel = $this->_displayLabel($sLabel);
		$aCaptcha = $this->dsp_crypt(0,1);
		$sCopy =  $this->oForm->_getLLLabel($this->aElement["copylabel"]);;
		$sInput = '<input type="text" name="' . $this->_getElementHtmlName() . '" id="' . $this->_getElementHtmlId() . '" '.$this->_getAddInputParams().' />';

		$aHtmlBag = array(
			"__compiled" => $sLabel .$aCaptcha["img"].$aCaptcha["reload"]."<br />".$sCopy."<br />". $sInput,
			"label" => $this->oForm->_getLLLabel($this->aElement["label"]),
			"image"=>$aCaptcha["img"],
			"reload"=>$aCaptcha["reload"],
			"copylabel"=>$sCopy,
			"input" => $sInput,
		);

		return $aHtmlBag;
	}

	function _renderOnly() {
		return true;
	}
/*
	function _readOnly() {
		return true;
	}
*/	

	function declareCustomValidationErrors() {
		if ($this->oForm->oDataHandler->_isFullySubmitted()){
			$this->chk_crypt($this->oForm->oDataHandler->getThisFormData($this->_getName()));
		}
	}

function _getPathReload() {
		
		if(($sPath = $this->_navConf("/reloadpic/")) !== FALSE) {
			
			if($this->oForm->isUserObj($sPath)) {
				$sPath = $this->oForm->_callUserObj($sPath);
			}

			if(t3lib_div::isFirstPartOfStr($sPath, "EXT:")) {
				
				$sPath = t3lib_div::getIndpEnv("TYPO3_SITE_URL") .
					str_replace(
						t3lib_div::getIndpEnv("TYPO3_DOCUMENT_ROOT"),
						"",
						t3lib_div::getFileAbsFileName($sPath)
					);
			}
		}
		
		return $sPath;
	}

	function dsp_crypt($cfg=0,$reload=1) {
	//if(session_id() == "") session_start();
	//$_SESSION['cryptdir'] =  str_replace ($_SERVER['DOCUMENT_ROOT'],'',str_replace('\\','/',dirname(__FILE__)))."/";
	$_SESSION['cryptdir'] = $this->sExtRelPath.'res/lib/';

 // Affiche le cryptogramme

	$iSID = session_id();

 $aCaptcha=array();


	$aCaptcha["img"]="<img id='" . $this->_getElementHtmlId() . "' src='".$_SESSION['cryptdir']."cryptographp.php?cfg=".$cfg."&amp;".$iSID."' alt='captcha'></img>";

 if(($sValue = $this->_navConf("/reloadpic"))){
	 if(is_string(trim(strtolower($this->aElement["reloadpic"])))){
		if ($reload) $aCaptcha["reload"] = "<a title='".($reload==1?'':$reload)."' style=\"cursor:pointer\" onclick=\"javascript:document.images.cryptogram.src='".$_SESSION['cryptdir']."cryptographp.php?cfg=".$cfg."&amp;".$iSID."&amp;'+Math.round(Math.random(0)*1000)+1\"><img src=\"".$this->_getPathReload(trim(strtolower($this->aElement["reloadpic"])))."\" class=\"captchapic\" /></a>";
	 }else{
		if ($reload) $aCaptcha["reload"] = "<a title='".($reload==1?'':$reload)."' style=\"cursor:pointer\" onclick=\"javascript:document.images.cryptogram.src='".$_SESSION['cryptdir']."cryptographp.php?cfg=".$cfg."&amp;".$iSID."&amp;'+Math.round(Math.random(0)*1000)+1\"><img src=\"".$_SESSION['cryptdir']."img/reload.png\" alt='reload' /></a>";
	 }	 
 }else{
	 if ($reload) $aCaptcha["reload"] = "<a title='".($reload==1?'':$reload)."' style=\"cursor:pointer\" onclick=\"javascript:document.images.cryptogram.src='".$_SESSION['cryptdir']."cryptographp.php?cfg=".$cfg."&amp;".$iSID."&amp;'+Math.round(Math.random(0)*1000)+1\"><img src=\"".$_SESSION['cryptdir']."img/reload.png\" alt='reload' /></a>";
 }

 return $aCaptcha;
 }


function chk_crypt($code) {
	// Vrifie si le code est correct
	
	$code = addslashes ($code);
	$code = ($_SESSION["rdt_captcha"]["config"]["difuplow"]=="true"?$code:strtoupper($code));
	
	switch(strtoupper($_SESSION["rdt_captcha"]["config"]["cryptsecure"])) {
		case "MD5"  : $code = md5($code); break;
		case "SHA1" : $code = sha1($code); break;
	}
	
	if($_SESSION['cryptcode'] and ($_SESSION['cryptcode'] == $code)) {
		unset($_SESSION['cryptreload']);
		return true;
	} else {
		
		if($this->aElement["errormessage"]) {
			$sError = $this->aElement["errormessage"];
		} else {
			$sError = "Captcha Error";
		}
		
		$_SESSION['cryptreload']= true;
		$this->oForm->_declareValidationError(
			$this->_getName(),
			"STANDARD:required",
			$sError
		);
		return false;
	}
}

 function _MakeCaptchaConfig() {

		//debug($this->aElement,"elements");

		($this->aElement["width"])?$_SESSION["rdt_captcha"]["config"]["width"] = $this->aElement["width"]:$_SESSION["rdt_captcha"]["config"]["width"] = 100;
		($this->aElement["height"])?$_SESSION["rdt_captcha"]["config"]["height"] = $this->aElement["height"]:$_SESSION["rdt_captcha"]["config"]["height"] = 30;

		/***************************************************
		*CONFIGURATION DU BACKGROUND
		****************************************************/
		if(trim($this->aElement["bgcolor"]) != ""){
			if(is_string($this->aElement["bgcolor"])){
				$aColors = explode(",",$this->aElement["bgcolor"]);
				$aBgColors["red"] = $aColors['0'];
				$aBgColors["green"] = $aColors['1'];
				$aBgColors["blue"] = $aColors['2'];
			}elseif(is_array($this->aElement["bgcolor"])){
				$aBgColors["red"] = $this->aElement["bgcolor"]["red"];
				$aBgColors["green"] = $this->aElement["bgcolor"]["green"];
				$aBgColors["blue"] = $this->aElement["bgcolor"]["blue"];
			}else{
				$_SESSION["rdt_captcha"]["config"]["bgR"] = 255;
				$_SESSION["rdt_captcha"]["config"]["bgG"] = 255;
				$_SESSION["rdt_captcha"]["config"]["bgB"] = 255;
			}
			$_SESSION["rdt_captcha"]["config"]["bgR"] = trim($aBgColors["red"]);
			$_SESSION["rdt_captcha"]["config"]["bgG"] = trim($aBgColors["green"]);
			$_SESSION["rdt_captcha"]["config"]["bgB"] = trim($aBgColors["blue"]);
		}else{
			$_SESSION["rdt_captcha"]["config"]["bgR"] = 255;
			$_SESSION["rdt_captcha"]["config"]["bgG"] = 255;
			$_SESSION["rdt_captcha"]["config"]["bgB"] = 255;
		}

		if(trim($this->aElement["transparent_background"]) != ""){
			if(strtolower($this->aElement["transparent_background"]) == "true"){
				$_SESSION["rdt_captcha"]["config"]["bgClear"] = true;
			}else{
				$_SESSION["rdt_captcha"]["config"]["bgClear"] = false;
			}
		}else{
			$_SESSION["rdt_captcha"]["config"]["bgClear"] = false;
		}

		if(trim($this->aElement["frame"]) != ""){
			if(strtolower($this->aElement["frame"]) == "true"){
				$_SESSION["rdt_captcha"]["config"]["bgFrame"] = true;
			}else{
				$_SESSION["rdt_captcha"]["config"]["bgFrame"] = false;
			}
		}else{
			$_SESSION["rdt_captcha"]["config"]["bgFrame"] = false;
		}

		/***************************************************
		*FIN DE LA CONFIGURATION DU BACKGROUND
		****************************************************/

		/***************************************************
		*CONFIGURATION DU TEXTE
		****************************************************/


		if(trim($this->aElement["font"]["fontcolor"]) != ""){
			if(is_string($this->aElement["font"]["fontcolor"])){
				$aColors = explode(",",$this->aElement["font"]["fontcolor"]);
				$aFontColors["red"] = $aColors['0'];
				$aFontColors["green"] = $aColors['1'];
				$aFontColors["blue"] = $aColors['2'];
			}elseif(is_array($this->aElement["font"]["fontcolor"])){
				(is_numeric(trim($this->aElement["font"]["fontcolor"]["red"])))?$aFontColors["red"] = $this->aElement["font"]["fontcolor"]["red"]:$aFontColors["red"] = 0;
				(is_numeric(trim($this->aElement["font"]["fontcolor"]["green"])))?$aFontColors["green"] = $this->aElement["font"]["fontcolor"]["green"]:$aFontColors["green"] = 0;
				(is_numeric(trim($this->aElement["font"]["fontcolor"]["blue"])))?$aFontColors["blue"] = $this->aElement["font"]["fontcolor"]["blue"]:$aFontColors["blue"] = 0;
			}else{
				$_SESSION["rdt_captcha"]["config"]["charR"] = 255;
				$_SESSION["rdt_captcha"]["config"]["charG"] = 0;
				$_SESSION["rdt_captcha"]["config"]["charB"] = 0;
			}
			$_SESSION["rdt_captcha"]["config"]["charR"] = trim($aFontColors["red"]);
			$_SESSION["rdt_captcha"]["config"]["charG"] = trim($aFontColors["green"]);
			$_SESSION["rdt_captcha"]["config"]["charB"] = trim($aFontColors["blue"]);
		}else{
			$_SESSION["rdt_captcha"]["config"]["charR"] = 255;
			$_SESSION["rdt_captcha"]["config"]["charG"] = 0;
			$_SESSION["rdt_captcha"]["config"]["charB"] = 0;
		}


		if($this->aElement["font"]["fontcolor"]["random"]){
			if(strtolower($this->aElement["font"]["fontcolor"]["random"]) == "true"){
				$_SESSION["rdt_captcha"]["config"]["charcolorrnd"] = true;
			}else{
				$_SESSION["rdt_captcha"]["config"]["charcolorrnd"] = false;
			}
		}else{
			$_SESSION["rdt_captcha"]["config"]["charcolorrnd"] = false;
		}

		if($this->aElement["font"]["fontcolor"]["level"]){
			switch(strtolower(trim($this->aElement["font"]["fontcolor"]["level"]))){
				case "darker":
					$_SESSION["rdt_captcha"]["config"]["charcolorrndlevel"] = 1;
				break;
				case "dark":
					$_SESSION["rdt_captcha"]["config"]["charcolorrndlevel"] = 2;
				break;
				case "light":
					$_SESSION["rdt_captcha"]["config"]["charcolorrndlevel"] = 3;
				break;
				case "lighter":
					$_SESSION["rdt_captcha"]["config"]["charcolorrndlevel"] = 4;
				break;
				default:
					$_SESSION["rdt_captcha"]["config"]["charcolorrndlevel"] = 1;
				break;
			}
		}else{
			$_SESSION["rdt_captcha"]["config"]["charcolorrndlevel"] = 0;
		}

		if($this->aElement["font"]["fontcolor"]["alpha"] && is_numeric($this->aElement["font"]["fontcolor"]["alpha"])){
			if(is_numeric($this->aElement["font"]["fontcolor"]["alpha"] >= 127)){
				$_SESSION["rdt_captcha"]["config"]["charclear"] = 127;
			}else{
				$_SESSION["rdt_captcha"]["config"]["charclear"] = $this->aElement["font"]["fontcolor"]["alpha"];
			}
		}else{
			$_SESSION["rdt_captcha"]["config"]["charclear"] = 0;
		}

		if($this->aElement["font"]["family"] && trim($this->aElement["font"]["family"]) != ""){
			$_SESSION["rdt_captcha"]["config"]["tfont"] = explode(",",trim($this->aElement["font"]["family"]));

		}else{
			$_SESSION["rdt_captcha"]["config"]["tfont"][] = "luggerbu.ttf";
		}

		if($this->aElement["authchar"]){
			$_SESSION["rdt_captcha"]["config"]["charel"] = trim(strtoupper($this->aElement["authchar"]));
		}else{
			$_SESSION["rdt_captcha"]["config"]["charel"] = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ123456789';
		}

//		debug($_SESSION["rdt_captcha"]["config"]["charel"]);

		if(($sValue = $this->_navConf("/font/size")) !== FALSE) {
			$_SESSION["rdt_captcha"]["config"]["crypteasy"] = true;
			if(($sValue = $this->_navConf("/crypteasy/con")) !== FALSE) {
				$_SESSION["rdt_captcha"]["config"]["charelc"] = trim(strtoupper($this->aElement["crypteasy"]["con"]));
			}else{
				$_SESSION["rdt_captcha"]["config"]["charelc"] = "BCDFGHJKLMNPQRSTVWXZ";
			}
			if(($sValue = $this->_navConf("/crypteasy/vow")) !== FALSE) {
				$_SESSION["rdt_captcha"]["config"]["charelv"] = trim(strtoupper($this->aElement["crypteasy"]["vow"]));
			}else{
				$_SESSION["rdt_captcha"]["config"]["charelv"] = "AEIOUY";
			}
		}else{
			$_SESSION["rdt_captcha"]["config"]["crypteasy"] = false;
		}

		if($this->aElement["difuplow"]){
			if(strtolower($this->aElement["difuplow"]) == "true"){
				$_SESSION["rdt_captcha"]["config"]["difuplow"] = "true";
			}else{
				$_SESSION["rdt_captcha"]["config"]["difuplow"] = "false";
			}
		}else{
			$_SESSION["rdt_captcha"]["config"]["difuplow"] = "false";
		}

		if(($sValue = $this->_navConf("/nbchar")) !== FALSE) {
			$aNum = explode("-",trim(strtolower($this->aElement["nbchar"])));
			$_SESSION["rdt_captcha"]["config"]["charnbmin"] = min($aNum);
			$_SESSION["rdt_captcha"]["config"]["charnbmax"] = max($aNum);
		}else{
			$_SESSION["rdt_captcha"]["config"]["charnbmin"] = 5;
			$_SESSION["rdt_captcha"]["config"]["charnbmax"] = 5;
		}

		if(($sValue = $this->_navConf("/charspace")) !== FALSE && $sValue = trim($this->_navConf("/charspace")) != "") {
			$_SESSION["rdt_captcha"]["config"]["charspace"] = trim(strtolower($this->aElement["charspace"]));
		}else{
			$_SESSION["rdt_captcha"]["config"]["charspace"] = "20";
		}

		if(($sValue = $this->_navConf("/font/size")) !== FALSE) {
			$aNum = explode("-",trim(strtolower($this->aElement["font"]["size"])));
			$_SESSION["rdt_captcha"]["config"]["charsizemin"] = min($aNum);
			$_SESSION["rdt_captcha"]["config"]["charsizemax"] = max($aNum);
		}else{
			$_SESSION["rdt_captcha"]["config"]["charsizemin"] = 12;
			$_SESSION["rdt_captcha"]["config"]["charsizemax"] = 12;
		}

		if(($sValue = $this->_navConf("/charangle")) !== FALSE) {
			if(is_numeric(trim(strtolower($this->aElement["charangle"])))){
				$_SESSION["rdt_captcha"]["config"]["charanglemax"] = trim(strtolower($this->aElement["charangle"]));
			}else{
				$_SESSION["rdt_captcha"]["config"]["charanglemax"] = 0;
			}
		}else{
			$_SESSION["rdt_captcha"]["config"]["charanglemax"] = 0;
		}

		if(($sValue = $this->_navConf("/charup")) !== FALSE) {
			if($this->aElement["charup"] == "true"){
				$_SESSION["rdt_captcha"]["config"]["charup"] = true;
			}else{
				$_SESSION["rdt_captcha"]["config"]["charup"] = false;
			}
		}else{
			$_SESSION["rdt_captcha"]["config"]["charup"] = false;
		}

		/***************************************************
		*FIN DE LA CONFIGURATION DU TEXTE
		****************************************************/

		/***************************************************
		*CONFIGURATION DU BRUIT
		****************************************************/

		if(($sValue = $this->_navConf("/noise")) !== FALSE) {

			if(($sValue = $this->_navConf("/noise/pixel")) !== FALSE) {
				$aNum = explode("-",trim(strtolower($this->aElement["noise"]["pixel"])));
				$_SESSION["rdt_captcha"]["config"]["noisepxmin"] = min($aNum);
				$_SESSION["rdt_captcha"]["config"]["noisepxmax"] = max($aNum);
			}else{
			$_SESSION["rdt_captcha"]["config"]["noisepxmin"] = 250;
			$_SESSION["rdt_captcha"]["config"]["noisepxmax"] = 250;
			}
			if(($sValue = $this->_navConf("/noise/line")) !== FALSE) {
				$aNum = explode("-",trim(strtolower($this->aElement["noise"]["line"])));
				$_SESSION["rdt_captcha"]["config"]["noiselinemin"] = min($aNum);
				$_SESSION["rdt_captcha"]["config"]["noiselinemax"] = max($aNum);
			}else{
			$_SESSION["rdt_captcha"]["config"]["noiselinemin"] = 3;
			$_SESSION["rdt_captcha"]["config"]["noiselinemax"] = 3;
			}

			if(($sValue = $this->_navConf("/noise/noisecolor")) !== FALSE) {
				switch($this->aElement["noise"]["noisecolor"]){
					case "charcolor":
						$_SESSION["rdt_captcha"]["config"]["noisecolorchar"] = true;
					break;
					case "backcolor":
						$_SESSION["rdt_captcha"]["config"]["noisecolorchar"] = false;
					break;
					default:
						$_SESSION["rdt_captcha"]["config"]["noisecolorchar"] = true;
					break;
				}
			}

		}else{
			$_SESSION["rdt_captcha"]["config"]["noisepxmin"] = 0;
			$_SESSION["rdt_captcha"]["config"]["noisepxmax"] = 0;

			$_SESSION["rdt_captcha"]["config"]["noiselinemin"] = 0;
			$_SESSION["rdt_captcha"]["config"]["noiselinemax"] = 0;

			$_SESSION["rdt_captcha"]["config"]["noisecolorchar"] = true;
		}

		/***************************************************
		*FIN DE LA CONFIGURATION DU BRUIT
		****************************************************/

		/***************************************************
		*CONFIGURATION DU SYSTEME
		****************************************************/

		if(($sValue = $this->_navConf("/imgtype")) !== FALSE) {

			switch(trim(strtolower($this->aElement["imgtype"]))){
				case "png":
					$_SESSION["rdt_captcha"]["config"]["cryptformat"] = "png";
				break;
				case "jpg":
					$_SESSION["rdt_captcha"]["config"]["cryptformat"] = "jpg";
				break;
				case "gif":
					$_SESSION["rdt_captcha"]["config"]["cryptformat"] = "gif";
				break;
				default:
					$_SESSION["rdt_captcha"]["config"]["cryptformat"] = "png";
				break;
			}

		}else{
			$_SESSION["rdt_captcha"]["config"]["cryptformat"] = "png";
		}

		if($this->aElement["cryptsecure"]){
			$this->aElement["cryptsecure"] = strtolower($this->aElement["cryptsecure"]);
			switch($this->aElement["cryptsecure"]){
				case "md5":
					$_SESSION["rdt_captcha"]["config"]["cryptsecure"] = "md5";
				break;
				case "sha1":
					$_SESSION["rdt_captcha"]["config"]["cryptsecure"] = "sha1";
				break;
				default:
					$_SESSION["rdt_captcha"]["config"]["cryptsecure"] = "md5";
				break;
			}

		}else{
			$_SESSION["rdt_captcha"]["config"]["cryptsecure"] = "md5";
		}

		if(($sValue = $this->_navConf("/timer")) !== FALSE) {
			if(($sValue = $this->_navConf("/timer/time")) !== FALSE) {
				if(is_numeric($this->aElement["timer"]["time"])){
					$_SESSION["rdt_captcha"]["config"]["cryptusetimer"] = $this->aElement["timer"]["time"];
					if(($sValue = $this->_navConf("/timer/action")) !== FALSE) {

						switch(trim(strtolower($this->aElement["timer"]["action"]))){
							case "image":
								$_SESSION["rdt_captcha"]["config"]["cryptusertimererror"] = 2;
							break;
							case "wait":
								$_SESSION["rdt_captcha"]["config"]["cryptusertimererror"] = 3;
							break;
							default:
								$_SESSION["rdt_captcha"]["config"]["cryptusertimererror"] = 2;
							break;
						}

					}else{
						$_SESSION["rdt_captcha"]["config"]["cryptusertimererror"] = 1;
					}
				}else{
					$_SESSION["rdt_captcha"]["config"]["cryptusetimer"] = 3; 
				}
			}
			else{
			$_SESSION["rdt_captcha"]["config"]["cryptusetimer"] = 3;
			$_SESSION["rdt_captcha"]["config"]["cryptusertimererror"] = 3;
			}
		}else{
			$_SESSION["rdt_captcha"]["config"]["cryptusetimer"] = 0;
			$_SESSION["rdt_captcha"]["config"]["cryptusertimererror"] = 3;
		}

		if(($sValue = $this->_navConf("/maxattempt")) !== FALSE) {
			if(is_numeric($this->aElement["maxattempt"])){
				$_SESSION["rdt_captcha"]["config"]["cryptusemax"] = $this->aElement["maxattempt"];
			}else{
				$_SESSION["rdt_captcha"]["config"]["cryptusemax"] = 1000000000000000000;
			}
		}else{
			$_SESSION["rdt_captcha"]["config"]["cryptusemax"] = 1000000000000000000;
		}

		//debug($_SESSION["rdt_captcha"]["config"],"max");

		/***************************************************
		*FIN DE LA CONFIGURATION DU SYSTEME
		****************************************************/



	return FALSE;

 }
  
}

if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/base/rdt_captcha/api/class.tx_rdtcaptcha.php"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/base/rdt_captcha/api/class.tx_rdtcaptcha.php"]);
}

?>