<?php
/** 
 * Plugin 'rdt_checkbox' for the 'ameos_formidable' extension.
 *
 * @author	Jerome Schneider <typo3dev@ameos.com>
 */


class tx_rdtcheckbox extends formidable_mainrenderlet {
	
	var $sMajixClass = "CheckBox";
	var $aLibs = array(
		"rdt_checkbox_class" => "res/js/checkbox.js",
	);

	var $bCustomIncludeScript = TRUE;

	function _render() {

		$sParentId = $this->_getElementHtmlId();
		$aHtml = array();
		$aHtmlBag = array();

		$aItems = $this->_getItems();
		$aChecked = $this->oForm->oDataHandler->_getThisFormData(
			$this->_getName()
		);

		$aSubRdts = array();

		reset($aItems);
		while(list($index, $aItem) = each($aItems)) {
			$value = $aItem["value"];
			$caption = $this->oForm->_getLLLabel($aItem["caption"]);

			// on cree le nom du controle
			$name = $this->_getElementHtmlName() . "[" . $index . "]";
			$sId = $this->_getElementHtmlId() . "_" . $index;
			$aSubRdts[] = $sId;
			$this->sCustomElementId = $sId;
			$this->includeScripts(
				array(
					"bParentObj" => FALSE,
					"parentid" => $sParentId,
				)
			);

			$checked = "";

			if(is_array($aChecked)) {
				if(in_array($value, $aChecked)) {
					$checked = " checked=\"checked\" ";
				}
			}

			$sInput = "<input type=\"checkbox\" name=\"" . $name . "\" id=\"" . $sId . "\" value=\"" . $value . "\" " . $checked . $this->_getAddInputParams($sId) . " ";

			if(array_key_exists("custom", $aItem)) {
				$sInput .= $aItem["custom"];
			}

			$sInput .= "/>";

			$sLabelStart = "<label for=\"" . $sId . "\" ";
			if(array_key_exists("labelcustom", $aItem)) {
				$sLabelStart .= $aItem["labelcustom"];
			}

			$sLabelStart .= ">";
			$sLabelEnd = "</label>";

			$aHtmlBag[$value . "."] = array(
				"input" => $sInput,
				"caption" => $caption,
				"value." => array(
					"htmlspecialchars" => htmlspecialchars($value),
				),
				"label" => $sLabelStart . $caption . $sLabelEnd,
				"label." => array(
					"for." => array(
						"start" => $sLabelStart,
						"end" => $sLabelEnd,
					)
				)
			);

			$aHtml[] = (($checked !== "") ? $this->_wrapSelected($sInput . $sLabelStart . $caption . $sLabelEnd) : $this->_wrapItem($sInput . $sLabelStart . $caption . $sLabelEnd));

			$this->sCustomElementId = FALSE;
		}

		// allowed because of $bCustomIncludeScript = TRUE
		$this->includeScripts(
			array(
				"checkboxes" => $aSubRdts,
				"bParentObj" => TRUE,
			)
		);


		$sInput = $this->_implodeElements($aHtml);

		$aHtmlBag["__compiled"] = $this->_displayLabel(
			$this->oForm->_getLLLabel(
				$this->_navConf("/label")
			)
		) . $sInput;

		$aHtmlBag["input"] = $sInput;

		return $aHtmlBag;
	}

	function _flatten($mData) {

		if(is_array($mData)) {
			if(!$this->_emptyFormValue($mData)) {
				return implode(",", $mData);
			}

			return "";
		}

		return $mData;
	}

	function _unFlatten($sData) {
		
		if(!$this->_emptyFormValue($sData)) {
			return t3lib_div::trimExplode(",", $sData);
		}

		return array();
	}
	
	function _getHumanReadableValue($data) {

		if(!is_array($data)) {
			$data = t3lib_div::trimExplode(",", $data);
		}

		$aLabels = array();
		$aItems = $this->_getItems();
		
		reset($data);
		while(list(, $selectedItemValue) = each($data)) {

			reset($aItems);
			while(list(, $aItem) = each($aItems)) {

				if($aItem["value"] == $selectedItemValue) {

					$aLabels[] = $this->oForm->_getLLLabel($aItem["caption"]);
					break;
				}
			}
		}
		
		return implode(", ", $aLabels);
	}
	
	function _sqlSearchClause($sValues, $sFieldPrefix = "") {

		$aParts = array();
		$aValues = t3lib_div::trimExplode(",", $sValues);
		
		if(sizeof($aValues) > 0) {

			reset($aValues);
			
			$sFieldName = $this->_navConf("/name");
			$sTableName = $this->oForm->_navConf("/tablename", $this->oForm->oDataHandler->aElement);
			$aConf = $this->_navConf("/search");
			
			while(list(, $sValue) = each($aValues)) {
				
				if(array_key_exists("onfields", $aConf)) {

					if($this->oForm->isUserObj($aConf["onfields"])) {
						$sOnFields = $this->oForm->_callUserObj($aConf["onfields"]);
					} else {
						$sOnFields = $aConf["onfields"];
					}

					$aFields = t3lib_div::trimExplode(",", $sOnFields);
					reset($aFields);
				} else {
					$aFields = array($this->_getName());
				}
				
				reset($aFields);
				while(list(, $sField) = each($aFields)) {
					$aParts[] = "FIND_IN_SET('" . $GLOBALS["TYPO3_DB"]->quoteStr($sValue, $sTableName) . "', " . $sFieldPrefix . $sField . ")";
				}
			}

			$sSql = " ( " . implode(" OR ", $aParts) . " ) ";

			return $sSql;
		}

		return "";
	}

	function majixCheckAll() {
		return $this->buildMajixExecuter(
			"checkAll"
		);
	}

	function majixCheckNone() {
		return $this->buildMajixExecuter(
			"checkNone"
		);
	}

	function majixCheckItem($sValue) {
		return $this->buildMajixExecuter(
			"checkItem",
			$sValue
		);
	}

	function majixUnCheckItem($sValue) {
		return $this->buildMajixExecuter(
			"unCheckItem",
			$sValue
		);
	}


	function _getSeparator() {

		if(($mSep = $this->_navConf("/separator")) === FALSE) {
			$mSep = "<br />\n";
		} else {
			if($this->oForm->isUserObj($mSep)) {
				$mSep = $this->oForm->_callUserObj($mSep);
			}
		}

		return $mSep;
	}
	
	function _implodeElements($aHtml) {

		return implode(
			$this->_getSeparator(),
			$aHtml
		);
	}

	function _wrapSelected($sHtml) {

		if(($mWrap = $this->_navConf("/wrapselected")) !== FALSE) {
			
			if($this->oForm->isUserObj($mWrap)) {
				$mWrap = $this->oForm->_callUserObj($mWrap);
			}

			$sHtml = str_replace("|", $sHtml, $mWrap);

		} else {
			$sHtml = $this->_wrapItem($sHtml);
		}

		return $sHtml;
	}

	function _wrapItem($sHtml) {
		
		if(($mWrap = $this->_navConf("/wrapitem")) !== FALSE) {
			
			if($this->oForm->isUserObj($mWrap)) {
				$mWrap = $this->oForm->_callUserObj($mWrap);
			}

			$sHtml = str_replace("|", $sHtml, $mWrap);
		}

		return $sHtml;
	}

	function _displayLabel($sLabel) {
		$sId = $this->_getElementHtmlId() . "_label";
		return ($this->oForm->oRenderer->bDisplayLabels && (trim($sLabel) != "")) ? "<label id='" . $sId . "' class='formidable-rdrstd-label " . $sId . "'>" . $sLabel . "</label>\n" : "";
	}
}


	if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/base/rdt_checkbox/api/class.tx_rdtcheckbox.php"])	{
		include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/base/rdt_checkbox/api/class.tx_rdtcheckbox.php"]);
	}

?>