<?php
/** 
 * Plugin 'rdt_checksingle' for the 'ameos_formidable' extension.
 *
 * @author	Jerome Schneider <typo3dev@ameos.com>
 */


class tx_rdtchecksingle extends formidable_mainrenderlet {
	
	var $sMajixClass = "CheckSingle";
	var $aLibs = array(
		"rdt_checksingle_class" => "res/js/checksingle.js",
	);

	function _render() {

		$aHtml = array();
		$sChecked = "";

		$iValue = intval($this->oForm->oDataHandler->getThisFormData($this->_getName()));
		if($iValue === 1) {
			$sChecked = " checked=\"checked\" ";
		}
		
		$sInput = "<input type=\"checkbox\" name=\"" . $this->_getElementHtmlName() . "\" id=\"" . $this->_getElementHtmlId() . "\" " . $sChecked . $this->_getAddInputParams() . " value=\"1\" />";


		$sLabel = $this->oForm->_getLLLabel($this->aElement["label"]);
		$sLabelForBegin = "<label for=\"" . $this->_getElementHtmlId() . "\">";
		$sLabelForEnd = "</label>";

		$sLabelFor = $sLabelForBegin . $sLabel . $sLabelForEnd;

		$sCompiled = ($this->oForm->oRenderer->bDisplayLabels) ? $sInput . $sLabelFor : $sInput;

		$aHtmlBag = array(
			"__compiled"		=> $sCompiled,
			"input"				=> $sInput,
			"checked"			=> $sChecked,
			"label"				=> $sLabelFor,
			"labelfor"			=> $sLabelFor,
			"labelfor." => array(
				"begin"	=> $sLabelForBegin,
				"end" => $sLabelForEnd,
			),
			"value" => $iValue,
			"value." => array(
				"humanreadable" => $this->_getHumanReadableValue($iValue)
			),
		);

		return $aHtmlBag;
	}

	/*
		internationalization of checked labels thanks to Manuel Rego Casanovas
		http://lists.netfielders.de/pipermail/typo3-project-formidable/2007-May/000343.html
	*/
	
	function _getCheckedLabel() {
		$mCheckedLabel = $this->_navConf("/labels/checked/");
		return ($mCheckedLabel) ? $this->oForm->_getLLLabel($mCheckedLabel) : "Y";
	}
	
	function _getNonCheckedLabel() {
		$mNonCheckedLabel = $this->_navConf("/labels/nonchecked/");
		return  ($mNonCheckedLabel) ? $this->oForm->_getLLLabel($mNonCheckedLabel) : "N";
	}
	
	function _getHumanReadableValue($data) {
		
		if(intval($data) === 1) {
			return $this->_getCheckedLabel();
		}

		return $this->_getNonCheckedLabel();
	}

	/*
		END internationalization of checked labels
	*/

	function majixCheck() {
		return $this->buildMajixExecuter(
			"check"
		);
	}

	function majixUnCheck() {
		return $this->buildMajixExecuter(
			"unCheck"
		);
	}
}


	if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/base/rdt_checksingle/api/class.tx_rdtchecksingle.php"])	{
		include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/base/rdt_checksingle/api/class.tx_rdtchecksingle.php"]);
	}

?>
