import flash.net.FileReferenceList;
import flash.net.FileReference;
import flash.external.ExternalInterface;
import flexpload_delegate;
import JSON;

class flexpload {

	private var oListener:Object;
	private var oFileList:FileReferenceList;
	private var fileQueue:Array = new Array();

	private var oConfig:Object;

	function flexpload() {

		this.initVars();
		System.security.allowDomain("*");	// Security fix
		
		this.oListener = new Object();
		this.oListener.onCancel			= flexpload_delegate.create(this, onCancel);
		this.oListener.onComplete		= flexpload_delegate.create(this, onComplete);
		this.oListener.onProgress		= flexpload_delegate.create(this, onProgress);
		this.oListener.onHTTPError		= flexpload_delegate.create(this, onHTTPError);
		this.oListener.onIOError		= flexpload_delegate.create(this, onIOError);
		this.oListener.onSecurityError	= flexpload_delegate.create(this, onSecurityError);
		this.oListener.onSelect			= flexpload_delegate.create(this, onSelect);

		// Add listener to the fileList object
		this.oFileList = new FileReferenceList();
		this.oFileList.addListener(this.oListener);

		ExternalInterface.addCallback("browse", this, browse);

		this.reflexFlashLoaded();
	}

	function initVars() {

		if(_root.config) {
			this.oConfig = JSON.parse(_root.config);
		}

	}

	function onCancel()			{ trace("onCancel");}
	function onComplete()		{ trace("onComplete");}
	function onProgress()		{ trace("onProgress");}
	function onHTTPError()		{ trace("onHTTPError");}
	function onIOError()		{ trace("onIOError");}
	function onSecurityError()	{ trace("onSecurityError");}

	function onSelect(fileRefList:FileReferenceList):Void {

		var fileListArray:Array = fileRefList.fileList;
		var file:FileReference;
		
		// Loop through all files in fileList
		for (var i:Number = 0; i < fileListArray.length; i++) {
			// Get current file
			file = fileListArray[i];
			
			// Add file to queue
			this.fileQueue.push(file);

			this.reflexFileSelected(
				this.getFileObject(
					fileQueue.length - 1,
					file
				)
			);
		};

		
		trace("onSelect");
	}


	private function getFileObject(id:Number, file:FileReference):Object {
		return {
			id: id.toString(),
			name: file.name,
			size: file.size,
			type: file.type,
			creationDate: file.creationDate,
			creator: file.creator
		};
	};




	/**
	* Open the file-browsing dialog box with allowed filetypes.
	*
	* @return {Void}
	*/
	private function browse():Void {
		this.oFileList.browse(
			[{description: "Description", extension: "*.*"}]
		);
	}

	function reflexFlashLoaded() {

		this.reflex(this.buildExecuter(
			this.oConfig.flash_loaded_callback,
			new Object()
		));
	}

	function reflexFileSelected(oFile) {

		this.reflex(this.buildExecuter(
			this.oConfig.file_selected_callback,
			oFile
		));
	}

	function buildExecuter(sMethod:String, oData: Object) {
		var oExecuter = new Object();
		oExecuter.object = this.oConfig.id;
		oExecuter.method = sMethod;
		oExecuter.data = oData;

		return oExecuter;
	}

	function reflex(oJson:Object) {
		var sJson:String = JSON.stringify(oJson);

		var sJs:String = "Formidable.f('" + this.oConfig.formuniqueid + "').executeClientEvent('" + this.oConfig.id + "', false, " + sJson + ")";
		getURL("javascript:" + sJs);
	}
}