Formidable.Classes.Flexpload = Formidable.Classes.RdtBaseClass.extend({
	oFlash: null,
	defConfig: {
		showdebug: false,										// Turn debugging on/off
		flash_loaded_callback: "cbkFlashLoaded",				// Invoked when the flash is loaded
		file_selected_callback: "cbkFileSelected",
		allowed_filetypes: "*.*",								// List of allowed filetypes
		allowed_filetypes_description: "All files",				// Description for allowed filetypes
		allowed_filesize: 1024,									// Max allowed filesize
		flash_path: "api/base/rdt_flexpload/res/flash/flexpload.swf",							// Path to flash-file
		flash_target: "",										// Where to output the flash (not used)
		flash_width: "1px",										// Flash width
		flash_height: "1px",									// Flash height
		flash_color: "#000000"									// Flash color
	},
	
	constructor: function(config) {
		this.base(config);
		this.initSettings();
		// Remove background flicker in IE
		try { document.execCommand('BackgroundImageCache', false, true);} catch(e) {}

		// Generate the tags ID
		this.movieName = "flexpload" + Math.ceil(Math.random()*(1/Math.random())*10000);

		// Load the settings.  Load the Flash movie.
		
		this.loadFlash();
		this.oUploadQueue = $(this.config.id + "_uploadqueue");
	},
	initSettings: function() {
		this.config = Object.extend(this.defConfig, this.config);
		this.showdebug = this.getSetting("showdebug");
	},
	loadFlash: function() {

		// Build the DOM nodes to hold the flash;
		var oContainer = Element.setStyle($div(), $H({
			"width": "0px",
			"height": "0px",
			"position": "absolute",
			"top": "0px",
			"left": "0px"
		}));

		if(Formidable.Browser.name == "internet explorer" || Formidable.Browser.name == "opera") {
			// Create IE Object HTML

			var oFlash = $object({
					"id": this.movieName,
					"classid": "clsid:D27CDB6E-AE6D-11cf-96B8-444553540000",
					"width": this.getSetting("flash_width"),
					"height": this.getSetting("flash_height")
				},
				$param({"name": "movie",	"value": Formidable.path + this.getSetting("flash_path")}),
				$param({"name": "bgcolor",	"value": this.getSetting["flash_color"]}),
				$param({"name": "quality",	"value": "high"}),
				$param({"name": "wmode",	"value": "transparent"}),
				$param({"name": "menu",		"value": "false"}),
				$param({"name": "flashvars","value": this._getFlashVars()}),
				$param({"name": "AllowScriptAccess", "value": "1"})
			);

			document.getElementsByTagName("body")[0].appendChild(oContainer);
			oContainer.innerHTML = oFlash.outerHTML;

		} else {

			// Create Mozilla Embed HTML
			
			var oFlash = $embed({
				"type": "application/x-shockwave-flash",
				"src": Formidable.path + this.getSetting("flash_path"),
				"width": this.getSetting("flash_width"),
				"height": this.getSetting("flash_height"),
				"id": this.movieName,
				"name": this.movieName,
				"bgcolor": this.getSetting["flash_color"],
				"quality": "high",
				"wmode": "transparent",
				"menu": "false",
				"flashvars": this._getFlashVars()
			});

			document.getElementsByTagName("body")[0].appendChild(oContainer);
			oContainer.appendChild(oFlash);
		}

		this.oFlash = $(this.movieName);
	},
	_getFlashVars: function() {
		return "config=" + escape(JSONstring.make(this.config, true));
	},
	cbkFlashLoaded: function(bool) {
		this.loadUI();
	},
	cbkFileSelected: function(oFile) {
		this.addFileToQueue(oFile);
	},
	addFileToQueue: function(oFile) {

		var oItem = $li();
		oItem.innerHTML = oFile.name;
		Event.observe(oItem, "click", function() {
			alert("clicked");
		}.bindAsEventListener(this));

		this.oUploadQueue.appendChild(oItem);
	},
	loadUI: function() {
		// Load the UI elements.  Show the UI Target, build the "link" according to the settings, and hide the Degraded Target

		if(this.getSetting("target") != "" && this.getSetting("target") != "fileinputs") {
		
			var instance = this;
			var target = $(this.config.id);
			
			// Create the link for uploading
			var browselink = $a({
				"class": this.getSetting("browse_link_class"),
				"id": this.movieName + "BrowseBtn",
				"href": "javascript:void(0);"
			}, "Add file");

			Event.observe(browselink, "click", function() {
				this.browse();
				return false;
			}.bindAsEventListener(this));
		
			target.innerHTML = "";
			target.appendChild(browselink);
				
			// Add upload btn if auto upload not used
			if(this.getSetting("auto_upload") == false) {

				// Create the link for uploading
				var uploadlink = document.createElement("a");
				uploadlink.className = this.getSetting("upload_link_class");
				uploadlink.id = this.movieName + "UploadBtn";
				uploadlink.href = "#";
				uploadlink.onclick = function() { instance.upload(); return false; }
				uploadlink.innerHTML = this.getSetting("upload_link_innerhtml");
				target.appendChild(uploadlink);
			}
		
		}	
	},
	debug: function(value) {
		if(window.console) {console.log(value);}
		else{ alert(value);}
	},
	getSetting: function(name) {
		return (typeof(this.config[name]) == "undefined") ? null : this.config[name];
	},
	browse: function() {
		this.oFlash.browse();
	},
	upload: function() {
		this.oFlash.upload();
	},
	cancelFile: function(file_id) {
		this.oFlash.cancelFile(file_id);
	},
	cancelQueue: function() {
		this.oFlash.cancelQueue();
	}
});


/* UTILS */

function stringBuilder(join) {

this._strings = new Array;
this._join = (typeof join == "undefined") ? "" : join;

	stringBuilder.prototype.append = function(str) {
		this._strings.push(str);
	};
		
	stringBuilder.prototype.toString = function() {
		return this._strings.join(this._join);
	};

};