<?php
/** 
 * Plugin 'rdt_radio' for the 'ameos_formidable' extension.
 *
 * @author	Jerome Schneider <typo3dev@ameos.com>
 */


class tx_rdtradio extends formidable_mainrenderlet {
	
	var $sMajixClass = "Radio";
	var $aLibs = array(
		"rdt_radio_class" => "res/js/radio.js",
	);

	var $bCustomIncludeScript = TRUE;

	function _render() {

		$aHtmlBag = array();
		$sCurValue = $this->oForm->oDataHandler->getThisFormData($this->_getName());
		$sRadioGroup = "";

		// on construit la liste des lments du groupe radio
		
		$optionsList = "";
		$aItems = $this->_getItems();
		$aSubRdts = array();
		
		if(count($aItems) > 0) {

			$aHtml = array();
			
			reset($aItems);
			while(list($itemindex, $aItem) = each($aItems)) {

				$selected = "";
				
				if($aItem["value"] == $sCurValue) {
					$selected = " checked=\"checked\" ";
				}

				$sCaption = $this->oForm->_getLLLabel($aItem["caption"]);

				$sId = $this->_getElementHtmlId() . "_" . $itemindex;
				$aSubRdts[] = $sId;
				$this->sCustomElementId = $sId;
				$this->includeScripts();

				$sValue = $aItem["value"];
				
				$sInput = "<input type=\"radio\" name=\"" . $this->_getElementHtmlName() . "\" id=\"" . $sId . "\" value=\"" . $aItem["value"] . "\" " . $selected . $this->_getAddInputParams() . " />";
				$sLabel = "<label for=\"" . $sId . "\">" . $sCaption . "</label>";
				
				$aHtmlBag[$sValue . "."] = array(
					"label" => $sLabel,
					"input" => $sInput,
					"value" => $sValue,
					"caption" => $sCaption,
				);

				$aHtml[] = (($selected !== "") ? $this->_wrapSelected($sInput . $sLabel) : $this->_wrapItem($sInput . $sLabel));
				$this->sCustomElementId = FALSE;
			}
			
			reset($aHtml);
			$sRadioGroup = $this->_implodeElements($aHtml);
		}

		// allowed because of $bCustomIncludeScript = TRUE
		$this->includeScripts(
			array(
				"name" => $this->_getElementHtmlName(),
				"radiobuttons" => $aSubRdts,
				"bParentObj" => TRUE,
			)
		);

		$sLabel = $this->oForm->_getLLLabel($this->aElement["label"]);
		$aHtmlBag["__compiled"] = $this->_displayLabel($sLabel) . $sRadioGroup;

		reset($aHtmlBag);
		return $aHtmlBag;
	}
	
	function _getHumanReadableValue($data) {

		$aItems = $this->_getItems();
		
		reset($aItems);
		while(list(, $aItem) = each($aItems)) {

			if($aItem["value"] == $data) {
				return $this->oForm->_getLLLabel($aItem["caption"]);
			}
		}

		return $data;
	}




	function _getSeparator() {

		if(($mSep = $this->_navConf("/separator")) === FALSE) {
			$mSep = "\n";
		} else {
			if($this->oForm->isUserObj($mSep)) {
				$mSep = $this->oForm->_callUserObj($mSep);
			}
		}

		return $mSep;
	}
	
	function _implodeElements($aHtml) {

		return implode(
			$this->_getSeparator(),
			$aHtml
		);
	}

	function _wrapSelected($sHtml) {

		if(($mWrap = $this->_navConf("/wrapselected")) !== FALSE) {
			
			if($this->oForm->isUserObj($mWrap)) {
				$mWrap = $this->oForm->_callUserObj($mWrap);
			}

			$sHtml = str_replace("|", $sHtml, $mWrap);

		} else {
			$sHtml = $this->_wrapItem($sHtml);
		}

		return $sHtml;
	}

	function _wrapItem($sHtml) {
		
		if(($mWrap = $this->_navConf("/wrapitem")) !== FALSE) {
			
			if($this->oForm->isUserObj($mWrap)) {
				$mWrap = $this->oForm->_callUserObj($mWrap);
			}

			$sHtml = str_replace("|", $sHtml, $mWrap);
		}

		return $sHtml;
	}

	function _displayLabel($sLabel) {
		$sId = $this->_getElementHtmlId() . "_label";
		return ($this->oForm->oRenderer->bDisplayLabels && (trim($sLabel) != "")) ? "<label id='" . $sId . "' class='formidable-rdrstd-label " . $sId . "'>" . $sLabel . "</label>\n" : "";
	}
}


	if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/base/rdt_radio/api/class.tx_rdtradio.php"])	{
		include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/base/rdt_radio/api/class.tx_rdtradio.php"]);
	}

?>