<?php
/** 
 * Plugin 'rdt_searchform' for the 'ameos_formidable' extension.
 *
 * @author	Jerome Schneider <typo3dev@ameos.com>
 */


class tx_rdtsearchform extends formidable_mainrenderlet {

	var $oDataSource = FALSE;
	var $aCriterias = FALSE;
	var $aFilters = FALSE;
	var $aDescendants = FALSE;

	function _init(&$oForm, $aElement, $aObjectType, $sXPath) {
		parent::_init($oForm, $aElement, $aObjectType, $sXPath);
		$this->_initDescendants();
	}

	function _render() {

		$this->_initData();

		$aChildBags = $this->renderChildsBag();
		$sCompiledChilds = $this->renderChildsCompiled($aChildBags);

		return array(
			"__compiled" => $this->_displayLabel($sLabel) . $sCompiledChilds,
			"childs" => $aChildBags
		);
	}
	
	function getDescendants() {
		
		$aDescendants = array();
		$sMyName = $this->_getName();
		
		$aRdts = array_keys($this->oForm->aORenderlets);
		reset($aRdts);
		while(list(, $sName) = each($aRdts)) {
			if($this->oForm->aORenderlets[$sName]->isDescendantOf($sMyName)) {
				$aDescendants[] = $sName;
			}
		}

		return $aDescendants;
	}

	function _initDescendants() {
		if($this->aDescendants === FALSE) {
			$this->aDescendants = $this->getDescendants();
		}
	}

	function _initData() {
		//$this->_initDescendants();	// done in _init()
		$this->_initCriterias();	// if submitted, take from post ; if not, take from session
									// and inject values into renderlets
		$this->_initFilters();
		$this->_initDataSource();
	}

	function mayHaveChilds() {
		return TRUE;
	}

	function _initDataSource() {

		if($this->oDataSource === FALSE) {

			if(($sDsToUse = $this->_navConf("/datasource/use")) === FALSE) {
				$this->oForm->mayday("RENDERLET SEARCHFORM - requires /datasource/use to be properly set. Check your XML conf.");
			} elseif(!array_key_exists($sDsToUse, $this->oForm->aODataSources)) {
				$this->oForm->mayday("RENDERLET SEARCHFORM - refers to undefined datasource '" . $sDsToUse . "'. Check your XML conf.");
			}

			$this->oDataSource =& $this->oForm->aODataSources[$sDsToUse];
		}
	}

	function clearFilters() {

		reset($this->aDescendants);
		while(list(, $sName) = each($this->aDescendants)) {
			$this->oForm->aORenderlets[$sName]->setValue("");
		}

		$this->aCriterias = array();
		$aAppData =& $GLOBALS["_SESSION"]["ameos_formidable"]["applicationdata"];
		$aAppData["rdt_lister"][$this->oForm->formid][$this->_getName()]["criterias"] = array();
	}

	function _initCriterias() {

		if($this->aCriterias === FALSE) {
			
			$this->aCriterias = array();

			$aAppData =& $GLOBALS["_SESSION"]["ameos_formidable"]["applicationdata"];
			if(!array_key_exists("rdt_lister", $aAppData)) {
				$aAppData["rdt_lister"] = array();
			}

			if(!array_key_exists($this->oForm->formid, $aAppData["rdt_lister"])) {
				$aAppData["rdt_lister"][$this->oForm->formid] = array();
			}

			if(!array_key_exists($this->_getName(), $aAppData["rdt_lister"][$this->oForm->formid])) {
				$aAppData["rdt_lister"][$this->oForm->formid][$this->_getName()] = array();
			}

			if(!array_key_exists("criterias", $aAppData["rdt_lister"][$this->oForm->formid][$this->_getName()])) {
				$aAppData["rdt_lister"][$this->oForm->formid][$this->_getName()]["criterias"] = array();
			}
			
			if($this->_getParamsFromGET()) {
				if(!$this->shouldUpdateCriterias()) {
					// take from GET params
					$this->aCriterias = (t3lib_div::_GET($this->oForm->formid)) ? t3lib_div::_GET($this->oForm->formid) : array();
					
					reset($this->aCriterias);
					while(list($sName, ) = each($this->aCriterias)) {
						if(array_key_exists($sName, $this->oForm->aORenderlets)) {
							$this->oForm->aORenderlets[$sName]->setValue(
								$this->aCriterias[$sName]
							);
						}
					}	
				}
			} else {
				if($this->shouldUpdateCriterias()) {
					// set in session
					reset($this->aDescendants);
					while(list(, $sName) = each($this->aDescendants)) {
						$this->aCriterias[$sName] = $this->oForm->oDataHandler->getThisFormData($sName);
					}
					
					$aAppData["rdt_lister"][$this->oForm->formid][$this->_getName()]["criterias"] = $this->aCriterias;
				} else {
					// take from session
					$this->aCriterias = $aAppData["rdt_lister"][$this->oForm->formid][$this->_getName()]["criterias"];
					
					reset($this->aCriterias);
					while(list($sName, ) = each($this->aCriterias)) {
						if(array_key_exists($sName, $this->oForm->aORenderlets)) {
							$this->oForm->aORenderlets[$sName]->setValue(
								$this->aCriterias[$sName]
							);
						}
					}
				}
			}
		}

		$this->aCriterias = $this->processBeforeSearch($this->aCriterias);
//		$this->oForm->d($this->aCriterias);
	}
	
	function shouldUpdateCriterias() {

		if($this->oForm->oDataHandler->_isSubmitted() === TRUE) {
			reset($this->aDescendants);
			while(list(, $sName) = each($this->aDescendants)) {
				if($this->oForm->aORenderlets[$sName]->_getType() === "SUBMIT" || $this->oForm->aORenderlets[$sName]->_getType() === "CHOOSER") {
					if($this->oForm->aORenderlets[$sName]->hasSubmitted() && $this->oForm->oDataHandler->_isSearchSubmitted()) {
						return TRUE;
					}
				}
			}
		}

		return FALSE;
	}
	
	function processBeforeSearch($aCriterias) {
		
		if(($aBeforeSearch = $this->_navConf("/beforesearch")) !== FALSE && $this->oForm->isUserObj($aBeforeSearch)) {
			$aCriterias = $this->oForm->_callUserObj($aBeforeSearch, $aCriterias);
		}

		return $aCriterias;
	}

	function _initFilters() {

		if($this->aFilters === FALSE) {

			$this->aFilters = array();

			//$aFormData = $this->oForm->oDataHandler->_getFormDataManaged();
			$aCriterias = $this->aCriterias;

			reset($this->aCriterias);
			while(list($sRdtName,) = each($this->aCriterias)) {
				if(array_key_exists($sRdtName, $this->oForm->aORenderlets)) {
					$oRdt =& $this->oForm->aORenderlets[$sRdtName];
					
					if($oRdt->_searchable()) {
						
						$sValue = $oRdt->_flatten($aCriterias[$sRdtName]);

						if(!$oRdt->_emptyFormValue($sValue)) {
							$this->aFilters[] = $oRdt->_sqlSearchClause($sValue);
						}
					}
				}
			}

			reset($this->aFilters);
		}
	}

	function &_getFilters() {
		$this->_initFilters();
		reset($this->aFilters);
		return $this->aFilters;
	}

	function &_fetchData($aConfig = array()) {

		return $this->oDataSource->_fetchData(
			$aConfig,
			$this->_getFilters()
		);
	}

	function _renderOnly() {
		return $this->_defaultTrue("/renderonly");
	}
	
	function _getParamsFromGET() {
		return $this->_defaultFalse("/paramsfromget");
	}
}


	if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/base/rdt_searchform/api/class.tx_rdtsearchform.php"])	{
		include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/base/rdt_searchform/api/class.tx_rdtsearchform.php"]);
	}
?>
