<?php
/** 
 * Plugin 'rdt_tinymce' for the 'ameos_formidable' extension.
 *
 * @author	Jerome Schneider <typo3dev@ameos.com>
 */

//	FOR CONFIGURATON REFERENCE, SEE
//		http://wiki.moxiecode.com/index.php/TinyMCE:Configuration

class tx_rdttinymce extends formidable_mainrenderlet {
	
	function _render() {

		$sLabel = $this->oForm->_getLLLabel($this->aElement["label"]);
		$sValue = htmlspecialchars(
			$this->oForm->oDataHandler->getThisFormData($this->_getName())
		);

		$sInput = "<textarea name=\"" . $this->_getElementHtmlName() . "\" id=\"" . $this->_getElementHtmlId() . "\" rows='2' cols='20'>" . $sValue . "</textarea>";

		$aHtmlBag = array(
			"__compiled" => $this->_displayLabel($sLabel) . $sInput,
			"input" => $sInput,
		);


		$sPath = $this->sExtWebPath  ."res/tiny_mce/tiny_mce.js";
		$this->oForm->additionalHeaderData(
			"<script type='text/javascript' src='" . $sPath . "'></script>",
			"ameosformidable_tx_rdttinymce"
		);


		$aConfig = array(
			"mode" => "exact",
			"elements" => $this->_getElementHtmlId(),
		);

		if(is_array($aUserConfig = $this->_navConf("/config")) && !empty($aUserConfig)) {
			$aConfig = t3lib_div::array_merge_recursive_overrule($aUserConfig, $aConfig);
		}

		if(!array_key_exists("theme", $aConfig)) {
			$aConfig["theme"] = "simple";
		}

		if(array_key_exists("content_css", $aConfig)) {
			$aConfig["content_css"] = $this->oForm->toWebPath($aConfig["content_css"]);
		}

		if(is_array($aAddConfig = $this->_navConf("/addconfig")) && $this->oForm->isUserObj($aAddConfig)) {
			$aAddConfig = $this->oForm->_callUserObj($aAddConfig);
			if(is_array($aAddConfig) && !empty($aAddConfig)) {
				$aConfig = t3lib_div::array_merge_recursive_overrule($aConfig, $aAddConfig);
			}
		}

		//	FOR CONFIGURATON REFERENCE, SEE
		//		http://wiki.moxiecode.com/index.php/TinyMCE:Configuration

		$sJson = $this->oForm->array2json($aConfig);

		$this->oForm->attachInitTask(
			"tinyMCE.init(" . $sJson . ");",
			"TinyMCE " . $this->_getElementHtmlId() . " initialization",
			$this->_getElementHtmlId(),
			TRUE
		);

		

		return $aHtmlBag;
	}
}


	if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/base/rdt_tinymce/api/class.tx_rdttinymce.php"])	{
		include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/base/rdt_tinymce/api/class.tx_rdttinymce.php"]);
	}
?>