<?php
/** 
 * Plugin 'rdt_tree' for the 'ameos_formidable' extension.
 *
 * @author	Jerome Schneider <typo3dev@ameos.com>
 */


class tx_rdttree extends formidable_mainrenderlet {

	var $sMajixClass = "Tree";
	var $aLibs = array(
		"rdt_tree_class" => "res/js/tree.js"
	);
	var $bCustomIncludeScript = TRUE;

	function _render() {
		
		$sLabel = $this->oForm->_getLLLabel($this->aElement["label"]);


		//$sInput = "<input type=\"text\" name=\"" . $this->_getElementHtmlName() . "\" id=\"" . $this->_getElementHtmlId() . "\" value=\"" . $sValue . "\"" . $this->_getAddInputParams() . " />";
		
		$sInput = "<div class='root' id='" . $this->_getElementHtmlId() . "'></div><div id='debug'></div>";

		

		$this->includeLibs();
		$this->includeScripts();
		$this->includeStyles();

		$aHtmlBag = array(
			"__compiled" => $this->_displayLabel($sLabel) . $sInput,
			"input" => $sInput,
		);
		
		return $aHtmlBag;
	}

	function _renderOnly() {
		return TRUE;
	}

	function majixInsertNodes($aNodes) {
		return $this->buildMajixExecuter(
			"insertNodes",
			$this->oForm->array2tree($aNodes)
		);
	}

	function includeScripts() {
		$aValue = $this->oForm->oDataHandler->getThisFormData($this->_getName());
		$sJson = $this->oForm->array2json($aValue);
		$sHtmlId = $this->_getElementHtmlId();
		$sScript =<<<JAVASCRIPT

	Formidable.Context.Forms["{$this->oForm->formid}"].Objects["{$sHtmlId}"] = new Formidable.Classes.Tree({
		placeHolder: \$("{$sHtmlId}"),
		onSelect: function(oNode) {
			\$("debug").innerHTML = "Selected:" + oNode.innerHTML;
		},
		onSelectNode: function() {
		},
		onSelectLeaf: function() {
		},
		onUnSelect: function() {
		},
		onUnSelectNode: function() {
		},
		onSelectLeaf: function() {
		},
		tree: {$sJson}
	});

	Formidable.f("{$this->oForm->formid}").o("{$sHtmlId}").render();

JAVASCRIPT;
		
		$this->oForm->attachInitTask(
			$sScript,
			"Tree " . $sHtmlId . " initialization"
		);
	}

	function includeStyles() {

		$sStyles =<<<STYLES

			.root { padding: 0px 0px 2px 0px;}
			.root div {
				padding: 0px 0px 0px 0px;
				margin-left: 20px;
			}

			.root a.closed, .root a.opened, .root a.leaf {
/*				padding-left: 18px;*/
				background-repeat: no-repeat;
				font-family: Verdana;
				font-size: 13px;
				color: black;
				line-height: 16px;
				text-align: bottom;
				content-align: bottom;
				/*display: block;*/
				cursor: pointer;
				background-align: bottom left;
			}

			.root a.closed			{ background-image: url({$this->sExtWebPath}res/img/plus.gif);}
			.root a.opened			{ background-image: url({$this->sExtWebPath}res/img/moins.gif);}
			.root a.leaf			{ background-image: url({$this->sExtWebPath}res/img/leaf.gif);}
			.root a.selected		{ background-color: orange;}

STYLES;
		$this->oForm->additionalHeaderData(
			$this->oForm->inline2TempFile($sStyles, 'css', "Tree " . $this->_getElementHtmlId() . " default styles")
		);
	}
}


	if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/base/rdt_tree/api/class.tx_rdttree.php"])	{
		include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/base/rdt_tree/api/class.tx_rdttree.php"]);
	}
?>