Formidable.Classes.Tree = Formidable.Classes.RdtBaseClass.extend({
	
	selectedNode: null,

	toggleNode: function(node, oHandler) {

/*		oBr = oHandler.nextElement();
		oDiv = oBr.nextElement();*/
		//oDiv = oHandler.nextElement();

		oDiv = this.getNextTreeNode(oHandler);

		if(!oDiv.style.display || oDiv.style.display == 'block') {
			this.closeNode(oDiv, oHandler);
		} else {
			this.openNode(oDiv, oHandler);
		}

		oHandler.blur();
	},

	openNode: function(node, oHandler) {
		node.style.display = 'block';
		oHandler.className = "opened";
	},

	closeNode: function(node, oHandler) {
		node.style.display = 'none';
		oHandler.className = "closed";
	},
	selectNode: function(oNode) {

		if(this.onSelect) { this.onSelect(oNode)};

		if(this.selectedNode) {
			this.selectedNode.removeClassName("selected");
		}

		if(this.selectedNode != oNode) {
			oNode.addClassName("selected");
			this.selectedNode = oNode;

		} else {
			this.selectedNode = null;
		}
	},
	getNextTreeNode: function(oNode) {
		var oCurrentNode = oNode;
		
		while(oCurrentNode = oCurrentNode.nextElement()) {
			if(oCurrentNode.hasClassName("treeNode")) {
				return oCurrentNode;
			}
		}

		return null;
	},
	getRootLine: function(oNode) {

		var aRootLine = [oNode];
		var oCurrentNode = oNode;
		
		while(oCurrentNode != this.config.placeHolder && (oCurrentNode = oCurrentNode.parentNode)) {
			if(oCurrentNode.tagName == "div") {
				aRootLine.push(oCurrentNode);
			}
		}
		
		return aRootLine.reverse();
	},
	render: function(oNodes, oDomNode) {
		
		if(!oNodes)		{oNodes = this.config.tree;}
		if(!oDomNode)	{oDomNode = this.config.placeHolder;}

		var _this = this;

		oNodes.each(function(oNode, index) {

			if(_this.hasChilds(oNode)) {

				var aTagOpener = $a({
						"class": "opened",
						href: "javascript:void(0);"
					},
					$img({
						"src": "/typo3conf/ext/ameos_formidable/api/base/rdt_tree/res/img/blank.gif",
						"width": "18px",
						"height": "16px",
						"border": "0"
					})
				);

				var aTagSelecter = $a(oNode.label);

				Event.observe(aTagOpener, "click", function(e) {
					_this.toggleNode(this.parentNode, this);
				});

				Event.observe(aTagSelecter, "click", function(e) {
					_this.selectNode(this);
				});

				oDomNode.appendChild(aTagOpener);
				oDomNode.appendChild(aTagSelecter);
				oDomNode.appendChild($div({"style": "clear: both;"}, ""));

//				oDomNode.appendChild($br());

				oDomNode.appendChild(
					_this.render(oNode.nodes, $div({"class": "treeNode"}))
				);

			} else {

				var aTag = $a(
					{"class" : 'leaf'},
					$img({
						"src": "/typo3conf/ext/ameos_formidable/api/base/rdt_tree/res/img/blank.gif",
						"width": "18px",
						"height": "16px",
						"border": "0"
					})
				);

				var aTagSelecter = $a(oNode.label);

				Event.observe(aTagSelecter, "click", function(e) {
					_this.selectNode(this);
				});

				oDomNode.appendChild(aTag);
				oDomNode.appendChild(aTagSelecter);
				oDomNode.appendChild($div({"style": "clear: both;"}, ""));
//				oDomNode.appendChild($br());
			}
		});
		
		return oDomNode;
	},
	hasChilds: function(oNode) {
		return oNode.nodes != undefined;
	},
	insertNodes: function(oNodes) {
		this.render(oNodes, this.selectedNode);
	}
});