<?php
/** 
 * Plugin 'rdt_txtarea' for the 'ameos_formidable' extension.
 *
 * @author	Jerome Schneider <typo3dev@ameos.com>
 */


class tx_rdttxtarea extends formidable_mainrenderlet {
	
	function _render() {
		
		$value = $this->oForm->oDataHandler->getThisFormData($this->_getName());
		$sLabel = $this->oForm->_getLLLabel($this->aElement["label"]);
		$value = $this->oForm->_getLLLabel($value);

		$value = htmlspecialchars($value);

		$sAddInputParams = $this->_getAddInputParams();
		

		/* adaptation for XHTML1.1 strict validation */
		
		if(strpos($sAddInputParams, "rows") === FALSE) {
			$sAddInputParams = " rows='2' " . $sAddInputParams;
		}

		if(strpos($sAddInputParams, "cols") === FALSE) {
			$sAddInputParams = " cols='20' " . $sAddInputParams;
		}

		/* */


		$sInput = "<textarea name=\"" . $this->_getElementHtmlName() . "\" id=\"" . $this->_getElementHtmlId() . "\"" . $sAddInputParams . ">" . $value . "</textarea>";
		
		return array(
			"__compiled" => $this->_displayLabel($sLabel) . $sInput,
			"input" => $sInput,
			"label" => $sLabel,
			"value" => $value,
			"value.nl2br" => nl2br($value),
			"value.htmlspecialchars" => htmlspecialchars($value),
			"value.htmlspecialchars.nl2br" => nl2br(htmlspecialchars($value)),
		);
	}
	
	function _getHumanReadableValue($sValue) {
		return nl2br(htmlspecialchars($sValue));
	}
}


	if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/base/rdt_txtarea/api/class.tx_rdttxtarea.php"])	{
		include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/base/rdt_txtarea/api/class.tx_rdttxtarea.php"]);
	}

?>