<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 2006 Radu Cocieru <radu@cocieru.com>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/** 
 * Validator 'formidable_capthcava' for the 'ameos_formidable' extension.
 *
 * @author	Radu Cocieru <radu.cocieru@gmail.com>
 */
class tx_vacaptcha extends formidable_mainvalidator{
  
	function _doTheMagic($aInfos, $aConf, $aElement)
	{
		if($this->oForm->oDataHandler->_isSubmitted())
		{
			$this->oForm->_debug(array($aInfos, $aConf, $aElement), "VALIDATOR CAPTCHA");
			
			$aParams = $aConf;
			$aFormData = $this->oForm->oDataHandler->_getFormData();
			
			$elementname = $this->oForm->_navConf("/name/", $aElement);
			$value = $aFormData[$elementname];

			if (t3lib_extMgm::isLoaded('sr_freecap') ) {
				require_once(t3lib_extMgm::extPath('sr_freecap').'pi2/class.tx_srfreecap_pi2.php');
				$this->freeCap = t3lib_div::makeInstance('tx_srfreecap_pi2');
				if(!$this->freeCap->checkWord($value)){
					$message = $this->oForm->_getLLLabel($this->oForm->_navConf("/message/", $aParams));
					$this->oForm->_declareValidationError($elementname, "capthca", $message);
				}
				
			}			
		}
	}

}

if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/base/va_captcha/api/class.tx_vacaptcha.php"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/base/va_captcha/api/class.tx_vacaptcha.php"]);
}

?>