<?php
/**
 * Plugin 'va_std' for the 'ameos_formidable' extension.
 *
 * @author	Jerome Schneider <typo3dev@ameos.com>
 */


class tx_vadb extends formidable_mainvalidator {
	
	function _doTheMagic($aInfos, $aConf, $aElement) {

		if($this->oForm->oDataHandler->_isSubmitted()) {

			$this->oForm->_debug(array($aInfos, $aConf, $aElement), "VALIDATOR DB");
			
			$aParams = $aConf;
			$aFormData = $this->oForm->oDataHandler->_getFormData();
			
			$elementname = $this->oForm->_navConf("/name/", $aElement);
			$value = $aFormData[$elementname];

			if($this->oForm->_navConf("/unique", $aParams) !== FALSE && $this->oForm->_defaultTrue("/unique/value/", $aParams)) {

				// le champ est unique
				// on vrifie qu'il est bien renseign

				if(!$this->_isUnique($aElement, $value, $aParams)) {

					$message = $this->oForm->_getLLLabel($this->oForm->_navConf("/unique/message/", $aParams));
					$this->oForm->_declareValidationError($elementname, "DB:unique", $message);
				}
			}
		}
	}
	
	function _isUnique($aElement, $value, $aParams) {
		
		$aDhConf = $this->oForm->_navConf("/control/datahandler/");
		
		$sDeleted = strtolower($this->oForm->_navConf("/unique/deleted/", $aParams));

		$value = addslashes($value);

		if($this->oForm->oDataHandler->_edition()) {
			if($sDeleted == "true"){
			$where = $aElement["name"] . " = '" . $value . "' and " . $aDhConf["keyname"] . " != '" . $this->oForm->oDataHandler->_currentEntryId() . "'";
			}
			else{
				$where = $aElement["name"] . " = '" . $value . "' and " . $aDhConf["keyname"] . " != '" . $this->oForm->oDataHandler->_currentEntryId() . "' and deleted != 1";
			}
		} else {
				if($sDeleted == "true"){
			$where = $aElement["name"] . " = '" . $value . "'";
		}
				else{
				$where = $aElement["name"] . " = '" . $value . "' and deleted != 1";
				}
			
		}
		
		$sSql = $GLOBALS["TYPO3_DB"]->SELECTquery(
			"count(*) as nbentries",
			$aDhConf["tablename"],
			$where
		);

		$rs = $GLOBALS["TYPO3_DB"]->sql_fetch_assoc(
			$this->oForm->_watchOutDB(
				$GLOBALS["TYPO3_DB"]->sql_query($sSql),
				$sSql
			)
		);
		
		if($rs["nbentries"] > 0) {
			return FALSE;
		}
		
		return TRUE;
	}
}


	if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/base/va_db/api/class.tx_vadb.php"])	{
		include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/base/va_db/api/class.tx_vadb.php"]);
	}

?>