<?php
/** 
 * Plugin 'va_num' for the 'ameos_formidable' extension.
 *
 * @author	Luc Muller <typo3dev@ameos.com>
 */


class tx_vanum extends formidable_mainvalidator {
	
	function _doTheMagic($aInfos, $aConf, $aElement) {

		$sElementName = $this->oForm->_navConf("/name/", $aElement);

		if($this->oForm->oDataHandler->_isSubmitted()) {

			$aFormData = $this->oForm->oDataHandler->_getFormData();
			$iNum = trim($aFormData[$sElementName]);

			if($iNum !== "") {
				if(($mValue = $this->oForm->_navConf("/isnum", $aConf)) !== FALSE) {
					if(!$this->_checkIsNum($iNum)) {
						$message = $this->oForm->_getLLLabel($this->oForm->_navConf("/message/", $mValue));
						$this->oForm->_declareValidationError($sElementName, "NUM:isnum", $message);
					}
				}

				if(($mValue = $this->oForm->_navConf("/isbetween/", $aConf)) !== FALSE) {

					$aValues = t3lib_div::trimExplode(",",$mValue["value"]);

					if(!$this->_checkIsIn($iNum, $aValues)) {
						$message = $this->oForm->_getLLLabel($this->oForm->_navConf("/message/", $mValue));
						$this->oForm->_declareValidationError($sElementName, "NUM:isbetween", $message);
					}
				}


				if(($mValue = $this->oForm->_navConf("/islower/", $aConf)) !== FALSE) {

					$aValues = t3lib_div::trimExplode(",", $mValue["value"]);

					if(!$this->_checkIsLow($iNum, $aValues)) {
						$message = $this->oForm->_getLLLabel($this->oForm->_navConf("/message/", $mValue));
						$this->oForm->_declareValidationError($sElementName, "NUM:islower", $message);
					}
				}

				if(($mValue = $this->oForm->_navConf("/ishigher/", $aConf)) !== FALSE) {

					$aValues = t3lib_div::trimExplode(",", $mValue["value"]);

					if(!$this->_checkIsHigh($iNum, $aValues)) {
						$message = $this->oForm->_getLLLabel($this->oForm->_navConf("/message/", $mValue));
						$this->oForm->_declareValidationError($sElementName, "NUM:ishigher", $message);
					}
				}

				if(($mValue = $this->oForm->_navConf("/isfloat", $aConf)) !== FALSE) {
					if(!$this->_checkIsFloat($iNum)) {
						$message = $this->oForm->_getLLLabel($this->oForm->_navConf("/message/", $mValue));
						$this->oForm->_declareValidationError($sElementName, "NUM:isfloat", $message);
					}
				}

				if(($mValue = $this->oForm->_navConf("/isinteger", $aConf)) !== FALSE) {
					if(!$this->_checkIsInteger($iNum)) {
						$message = $this->oForm->_getLLLabel($this->oForm->_navConf("/message/", $mValue));
						$this->oForm->_declareValidationError($sElementName, "NUM:isinteger", $message);
					}
				}
			}
		}
	}

	function _checkIsNum($iNum) {
		return is_numeric($iNum);
	}

	function _checkIsInteger($iNum) {
		return ctype_digit($iNum) && intval($iNum) == $iNum;
	}

	function _checkIsIn($iNum,$aValues) {

		if($this->_checkIsNum($iNum)) {
			return (($iNum >= min($aValues)) && ($iNum <= max($aValues)));
		}
		
		return FALSE;
	}

	function _checkIsLow($iNum,$aValues) {

		if($this->_checkIsNum($iNum)) {
			return ($iNum < min($aValues));
		}
		
		return FALSE;
	}

	function _checkIsHigh($iNum, $aValues) {

		if($this->_checkIsNum($iNum)) {
			return ($iNum > max($aValues));
		}
		
		return FALSE;
	}

	function _checkIsFloat($iNum) {
		  $split = split('\.', $iNum);
		  if ( count($split) == 2 ) {
			if ( ctype_digit($split[0]) && ctype_digit($split[1]) )
			  return true;
			else
			  return false;
		  } else {
			return false;
		  }
	}
}


	if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/base/va_num/api/class.tx_vanum.php"])	{
		include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/base/va_num/api/class.tx_vanum.php"]);
	}
?>