<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 2006 Jrmy Lecour (jeremy.lecour@nurungrandsud.com)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/** 
 * Plugin 'va_preg' for the 'ameos_formidable' extension.
 *
 * @author	Jrmy Lecour <jeremy.lecour@nurungrandsud.com>
 */


class tx_vapreg extends formidable_mainvalidator {

	function _doTheMagic($aInfos, $aConf, $aElement) {
		
		if($this->oForm->oDataHandler->_isSubmitted()) {
			
			$this->oForm->_debug(array($aInfos, $aConf, $aElement), "VALIDATOR PREG");

			$aParams = $aConf;
			$aFormData = $this->oForm->oDataHandler->_getFormData();

			$elementname = $this->oForm->_navConf("/name/", $aElement);
			$value = $aFormData[$elementname];

			$sPattern = $this->oForm->_navConf("/pattern/value/", $aParams);

			$bIsValid = $this->_isValid($sPattern);
			$bIsMatch = $this->_isMatch($sPattern, $value);
			
			
			$this->oForm->_debug(array($aInfos, $aConf, $aElement, array("Pattern"=>$sPattern,"Valid pattern ?"=>$bIsValid,"Value to test"=>$value,"Value matches pattern ?"=>$bIsMatch) ), "VALIDATOR PREG", __LINE__, __FILE__);
			
			if( $bIsValid && !$bIsMatch ) {
				$message = $this->oForm->_getLLLabel($this->oForm->_navConf("/pattern/message/", $aParams));
				$this->oForm->_declareValidationError($elementname, "PREG:pattern", $message);
			} // Nothing is done if the pattern syntax is illegal. I don't know what could be done ! Any ideas ?
		}
	}
	
	function _isValid($sPattern) {
		return preg_match("/!*\/[^\/]+\//",$sPattern);
	}
	
	function _isMatch($sPattern, $value) {
		if($value == "") {
			return TRUE;
		} else {
			if ($sPattern{0} == '!') return !preg_match(substr($sPattern,1),$value);
			else return preg_match($sPattern,$value);
		}
	}
}

	if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/base/va_preg/api/class.tx_vapreg.php"])	{
		include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/base/va_preg/api/class.tx_vapreg.php"]);
	}
?>