<?php
	
	class formidable_jslayer {

		var $oForm = null;
		var $bLoadScriptaculous = FALSE;

		function _init(&$oForm) {
			require_once(PATH_tslib . "class.tslib_pagegen.php");
			$this->oForm =& $oForm;
		}

		function _includeOnceLibs() {
			
			if(!isset($GLOBALS["FORMIDABLE_LIBS_INCLUDED"])) {

				$this->_includeJSFramework();
				$this->_includePrototype();
				

				$GLOBALS["FORMIDABLE_LIBS_INCLUDED"] = TRUE;
			}

			$this->_includeDebugStyles();
		}
		
		function _includeThisFormDesc() {

			$aConf = array(
				"sFormId"				=> $this->oForm->formid,
				"Misc" => array(
					"HiddenIds" => array(
						"Lister" => array(
							"page" => $this->oForm->oRenderer->_getHiddenHtmlId("AMEOSFORMIDABLE_DHLISTER_PAGE"),
							"sortField" => $this->oForm->oRenderer->_getHiddenHtmlId("AMEOSFORMIDABLE_DHLISTER_SORT_FIELD"),
							"sortDirection" => $this->oForm->oRenderer->_getHiddenHtmlId("AMEOSFORMIDABLE_DHLISTER_SORT_DIRECTION"),
						),
					),
					"Urls" => array(
						"Lister" => array(
							"sortAction" => t3lib_div::getIndpEnv("REQUEST_URI") . "#LISTER_" . $this->oForm->formid,
						),
						"Ajax" => array(
							"event" => $this->oForm->_removeEndingSlash(t3lib_div::getIndpEnv("TYPO3_SITE_URL")) . "/index.php?eID=tx_ameosformidable&object=tx_ameosformidable&servicekey=ajaxevent"
						),
					),
					"MajixSpinner" => (($aSpinner = $this->oForm->_navConf("/meta/majixspinner")) !== FALSE) ? $aSpinner : array(),
				),
			);

			$sJson = $this->oForm->array2json($aConf);
			$sScript = <<<JAVASCRIPT

	Formidable.Context.Forms["{$this->oForm->formid}"] = new Formidable.Classes.FormBaseClass(
		{$sJson}
	);

JAVASCRIPT;
			
			if(isset($GLOBALS["BE_USER"]) && method_exists($GLOBALS["BE_USER"], "isAdmin") && $GLOBALS["BE_USER"]->isAdmin()) {
				
				if($this->oForm->bDebug) {

					$sScript .= <<<JAVASCRIPT

	Formidable.f("{$this->oForm->formid}").Manager = {
		enabled: true,
		Xml: {
			path: "{$this->oForm->_xmlPath}"
		}
	};

JAVASCRIPT;

				}
			}

			$this->oForm->attachInitTask(
				$sScript,
				"Form '" . $this->oForm->formid . "' instance description"
			);
		}
		
		function _includeDebugStyles() {
			if($this->oForm->bDebug) {					
				
				$sPath = t3lib_extMgm::siteRelPath("ameos_formidable");
				$this->oForm->additionalHeaderData(
					"<link rel='stylesheet' type='text/css' href='" . $sPath . "res/css/debug.css' />",
					"tx_ameosformidable_debugstyles"
				);
			}
		}

		function _includePrototype() {

			// JSON stringifier
			// http://www.thomasfrank.se/downloadableJS/jsonStringify.js
			$sPath = t3lib_div::getIndpEnv("TYPO3_SITE_URL") . t3lib_extMgm::siteRelPath("ameos_formidable") . "res/jsfwk/json/json.js";

			$this->oForm->additionalHeaderData(
				"<script type=\"text/javascript\" src=\"" . $sPath . "\"></script>",
				"tx_ameosformidable_json",
				TRUE
			);

			// Dean Edward's Base API for clean prototype inheritance
			$sPath = t3lib_div::getIndpEnv("TYPO3_SITE_URL") . t3lib_extMgm::siteRelPath("ameos_formidable") . "res/jsfwk/prototype/addons/base/Base.js";

			$this->oForm->additionalHeaderData(
				"<script type=\"text/javascript\" src=\"" . $sPath . "\"></script>",
				"tx_ameosformidable_prototype_base",
				TRUE
			);

			// Lowpro event & dom prototype addon
			// http://www.danwebb.net/2006/9/3/low-pro-unobtrusive-scripting-for-prototype
			$sPath = t3lib_div::getIndpEnv("TYPO3_SITE_URL") . t3lib_extMgm::siteRelPath("ameos_formidable") . "res/jsfwk/prototype/addons/lowpro/lowpro.js";

			$this->oForm->additionalHeaderData(
				"<script type=\"text/javascript\" src=\"" . $sPath . "\"></script>",
				"tx_ameosformidable_lowpro",
				TRUE
			);

			$sPath = t3lib_div::getIndpEnv("TYPO3_SITE_URL") . t3lib_extMgm::siteRelPath("ameos_formidable") . "res/jsfwk/prototype/prototype.js";

			$this->oForm->additionalHeaderData(
				"<script type=\"text/javascript\" src=\"" . $sPath . "\"></script>",
				"tx_ameosformidable_prototype",
				TRUE
			);
		}
		
		function _includeJSFramework() {
			$sPath = t3lib_div::getIndpEnv("TYPO3_SITE_URL") . t3lib_extMgm::siteRelPath("ameos_formidable") . "res/jsfwk/framework.js";

			$this->oForm->additionalHeaderData(
				"<script type=\"text/javascript\" src=\"" . $sPath . "\"></script>",
				"tx_ameosformidable_jsframework",
				TRUE
			);
			
			$sPath = t3lib_div::getIndpEnv('TYPO3_SITE_URL') . t3lib_extmgm::siteRelPath("ameos_formidable");
			$sScript =<<<JAVASCRIPT
				
	Formidable.initialize({path: '{$sPath}'});

JAVASCRIPT;

			$this->oForm->attachInitTask(
				$sScript,
				"Framework Formidable.path initialization"
			);
		}

		function loadScriptaculous() {
			$this->bLoadScriptaculous = TRUE;
		}

		function loadScriptaculousDragDrop() {
			$this->bLoadScriptaculousDragDrop = TRUE;
		}

		function _loadScriptaculous() {
			if($this->bLoadScriptaculous === TRUE) {
				
				// scriptaculous
				$sPath = t3lib_div::getIndpEnv("TYPO3_SITE_URL") . t3lib_extMgm::siteRelPath("ameos_formidable") . "res/jsfwk/scriptaculous/scriptaculous.js";

				$this->oForm->additionalHeaderData(
					"<script type=\"text/javascript\" src=\"" . $sPath . "\"></script>",
					"tx_ameosformidable_scriptaculous"
				);

				
				$sPath = t3lib_div::getIndpEnv("TYPO3_SITE_URL") . t3lib_extMgm::siteRelPath("ameos_formidable") . "res/jsfwk/scriptaculous/effects.js";

				$this->oForm->additionalHeaderData(
					"<script type=\"text/javascript\" src=\"" . $sPath . "\"></script>",
					"tx_ameosformidable_scriptaculous_effects"
				);

				if($this->bLoadScriptaculousDragDrop === TRUE) {
					$sPath = t3lib_div::getIndpEnv("TYPO3_SITE_URL") . t3lib_extMgm::siteRelPath("ameos_formidable") . "res/jsfwk/scriptaculous/dragdrop.js";

					$this->oForm->additionalHeaderData(
						"<script type=\"text/javascript\" src=\"" . $sPath . "\"></script>",
						"tx_ameosformidable_scriptaculous_dragdrop"
					);
				}
			}
		}
	}

	if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/class.jslayer.php"])	{
		include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/class.jslayer.php"]);
	}
?>