<?php

	class formidable_maindatahandler extends formidable_mainobject {
		
		var $entryId		= null;
		var $forcedId		= null;		// wether $entryId id forced by the PHP, or not
		var $newEntryId		= null;
		
		var $__aStoredData		= array();	// internal use only
		var $__aFormData		= array();	// internal use only
		var $__aFormDataManaged	= array();	// internal use only
		
		var $__aCols = array();				// columns associated to an existing renderlet
		var $__aListData = array();			// contextual data, containing the current list record
		var $__aParentListData = array();			// contextual data, containing the current list record

		var $aT3Languages = FALSE;




		function _init(&$oForm, $aElement, $aObjectType, $sXPath) {
			parent::_init($oForm, $aElement, $aObjectType, $sXPath);
			if($this->i18n()) {
				if(($this->i18n_getDefLangUid() === FALSE)) {
					$this->oForm->mayday("DATAHANDLER: <b>/i18n/use</b> is active but no <b>/i18n/defLangUid</b> given");
				}
			}
		}

		/**
		 * Processes data returned by the HTML Form after validation, and only if validated
		 * Note that this is only the 'abstract' definition of this function
		 *  as it must be overloaded in the specialized DataHandlers
		 *
		 * @return	void
		 */
		function _doTheMagic($bShouldProcess = TRUE) {
		}


		/**
		 * Returns the slashstripped GET vars array
		 *
		 * @return	array		GET vars array
		 * @see	formidable_maindatahandler::_GP()
		 */
		function _G() {

			$aG = t3lib_div::_GET(
				$this->oForm->formid
			);

			$aG = (is_array($aG) ? $aG : array());

			reset($aG);
			return $aG;
		}

		/**
		 * Returns the slashstripped POST vars array
		 *  merged with the _FILES vars array
		 *
		 * @return	array		POST vars array
		 * @see	formidable_maindatahandler::_GP()
		 */
		function _P($sName = FALSE) {

			$aPost = t3lib_div::_POST($this->oForm->formid);
			$aFiles = $this->_F();
			
			$aPost = (is_array($aPost) ? $aPost : array());
			$aFiles = (is_array($aFiles) ? $aFiles : array());

			$aP = t3lib_div::array_merge_recursive_overrule(
				$aPost,
				$aFiles
			);

			reset($aP);

			if($sName !== FALSE) {
				if(array_key_exists($sName, $aP)) {
					return $aP[$sName];
				} else {
					return "";
				}
			}

			return $aP;
		}

		/**
 * Returns the slashstripped _FILES vars array
 *
 * @return	array		_FILES vars array
 * @see	formidable_maindatahandler::_P()
 */
		function _F()
		{
			$aElements = array();
			$form_id = $this->oForm->formid;
			$aF = is_array($GLOBALS["_FILES"][$form_id]) ? $GLOBALS["_FILES"][$form_id] : array();

			if(array_key_exists("name", $aF)) {
				$aElementsNames = array_keys($aF["name"]);
				
				reset($aElementsNames);
				while(list(, $sElementName) = each($aElementsNames)) {
					$aElements[$sElementName] = array(
						"name"		=> $aF["name"][$sElementName],
						"type"		=> $aF["type"][$sElementName],
						"tmp_name"	=> $aF["tmp_name"][$sElementName],
						"error"		=> $aF["error"][$sElementName],
						"size"		=> $aF["size"][$sElementName],
					);
				}
				
			}

			reset($aElements);
			return $aElements;
		}

		/**
		 * Returns the merged GET and POST arrays
		 *  using the formidable_maindatahandler::_G() and formidable_maindatahandler::_P() functions
		 *  and therefore not slashstripped
		 *
		 *	POST overrides GET
		 *
		 * @return	array		GET and POST vars array
		 */
		function _GP() {
			
			return t3lib_div::array_merge_recursive_overrule(
				$this->_G(),
				$this->_P()
			);
		}

		/**
		 * Returns the merged GET and POST arrays
		 *  using the formidable_maindatahandler::_G() and formidable_maindatahandler::_P() functions
		 *  and therefore not slashstripped
		 *
		 *	GET overrides POST
		 *
		 * @return	array		GET and POST vars array
		 */
		function _PG() {
			return t3lib_div::array_merge_recursive_overrule(
				$this->_P(),
				$this->_G()
			);
		}

		/**
		 * Determines if the FORM is submitted
		 *  using the AMEOSFORMIDABLE_SUBMITTED constant for naming the POSTED variable
		 *
		 * @return	boolean
		 */
		
		function _getSubmittedValue($sFormId = FALSE) {
			
			$aP = $this->oForm->_getRawPost();
			
			if(array_key_exists("AMEOSFORMIDABLE_SUBMITTED", $aP) && (trim($aP["AMEOSFORMIDABLE_SUBMITTED"]) !== "")) {
				return intval($aP["AMEOSFORMIDABLE_SUBMITTED"]);
			}

			return FALSE;
		}
		
		function _isSubmitted() {

			/*return in_array(
				$this->_getSubmittedValue(),
				array(
					AMEOSFORMIDABLE_EVENT_SUBMIT_FULL,		// full submit
					AMEOSFORMIDABLE_EVENT_SUBMIT_REFRESH,	// refresh submit
					AMEOSFORMIDABLE_EVENT_SUBMIT_TEST,		// test submit
					AMEOSFORMIDABLE_EVENT_SUBMIT_DRAFT,		// draft submit
					AMEOSFORMIDABLE_EVENT_SUBMIT_CLEAR,		// clear submit
					AMEOSFORMIDABLE_EVENT_SUBMIT_SEARCH,	// clear submit
				)
			);*/
			return (
				$this->_isFullySubmitted() ||
				$this->_isRefreshSubmitted() ||
				$this->_isTestSubmitted() ||
				$this->_isDraftSubmitted() ||
				$this->_isClearSubmitted() ||
				$this->_isSearchSubmitted()
			);
		}

		function _isFullySubmitted() {
			return ($this->_getSubmittedValue() == AMEOSFORMIDABLE_EVENT_SUBMIT_FULL);
		}

		function _isRefreshSubmitted() {
			return ($this->_getSubmittedValue() == AMEOSFORMIDABLE_EVENT_SUBMIT_REFRESH);
		}
		
		function _isTestSubmitted() {
			return ($this->_getSubmittedValue() == AMEOSFORMIDABLE_EVENT_SUBMIT_TEST);
		}

		function _isDraftSubmitted() {
			return ($this->_getSubmittedValue() == AMEOSFORMIDABLE_EVENT_SUBMIT_DRAFT);
		}

		function _isClearSubmitted() {
			return ($this->_getSubmittedValue() == AMEOSFORMIDABLE_EVENT_SUBMIT_CLEAR);
		}

		function _isSearchSubmitted() {
			return ($this->_getSubmittedValue() == AMEOSFORMIDABLE_EVENT_SUBMIT_SEARCH);
		}

		function getFormData() {
			return $this->_getFormData();
		}

		function _getFormData() {
			
			if(empty($this->__aFormData)) {
				
				$this->__aFormData = array();

				if(!empty($this->oForm->aORenderlets)) {
					$aKeys = array_keys($this->oForm->aORenderlets);
					reset($aKeys);
					while(list(,$sName) = each($aKeys)) {
						$this->__aFormData[$sName] = $this->_getThisFormData($sName);
					}
				}
				$this->__aFormData = $this->_processBeforeRender($this->__aFormData);
			}
			
			reset($this->__aFormData);
			return $this->__aFormData;
		}

		function getThisFormData($sName) {
			return $this->_getThisFormData($sName);
		}

		function _getThisFormData($sName) {
			
			if(array_key_exists($sName, $this->oForm->aORenderlets)) {
				if(isset($this->oForm->aORenderlets[$sName]->mForcedValue)) {
					return $this->oForm->aORenderlets[$sName]->mForcedValue;
				} else {
					if(!array_key_exists($sName, $this->__aFormData)) {
						$this->__aFormData[$sName] = $this->oForm->aORenderlets[$sName]->_getValue();
					}
				}
			} else {
				return "";
			}
			
			return $this->__aFormData[$sName];
		}

		function _processBeforeRender($aData) {
			
			if(($aUserObj = $this->_navConf("/process/beforerender/")) !== FALSE) {
				$aData = $this->oForm->_callUserObj(
					$aUserObj,
					$aData
				);
			}

			if(!is_array($aData)) {
				$aData = array();
			}

			reset($aData);
			return $aData;
		}
		
		function getFormDataManaged() {
			return $this->_getFormDataManaged();
		}
		
		function _getFormDataManaged() {

			if(empty($this->__aFormDataManaged)) {

				$aFormData = $this->_getFormData();

				reset($aFormData);
				while(list($elementname, $value) = each($aFormData)) {

					// pour viter les champs de la table de BDD non dfinis dans les renderlets ; typiquement uid
					if(array_key_exists($elementname, $this->oForm->aORenderlets)) {
						
						if($this->oForm->aORenderlets[$elementname]->_renderOnly()) {
							unset($aFormData[$elementname]);
						}
					}
				}

				reset($aFormData);
				$this->__aFormDataManaged = $aFormData;
				return $this->__aFormDataManaged;

			} else {

				reset($this->__aFormDataManaged);
				return $this->__aFormDataManaged;
			}
		}

		function _getFlatFormData() {
			$aFormData = $this->_getFormData();
			$aRes = array();
			reset($aFormData);
			while(list($sName, $mData) = each($aFormData)) {
				if(array_key_exists($sName, $this->oForm->aORenderlets)) {
					$aRes[$sName] = $this->oForm->aORenderlets[$sName]->_flatten($mData);
				}
			}

			reset($aRes);
			return $aRes;
		}
		
		function _getFlatFormDataManaged() {
			$aFormData = $this->_getFormDataManaged();
			reset($aFormData);
			while(list($sName, $mData) = each($aFormData)) {
				if(array_key_exists($sName, $this->oForm->aORenderlets)) {
					$aFormData[$sName] = $this->oForm->aORenderlets[$sName]->_flatten($mData);
				}
			}

			reset($aFormData);
			return $aFormData;
		}

		/**
		 * Determines if something was not validated during the validation process
		 *
		 * @return	boolean	TRUE if everything is valid, FALSE if not
		 */
		function _allIsValid() {
			return (count($this->oForm->_aValidationErrors) == 0);
		}

		function _isValid($sRdtName) {

			if(is_array($this->oForm->_aValidationErrors) && array_key_exists($sRdtName, $this->oForm->_aValidationErrors)) {
				return FALSE;
			}

			return TRUE;
		}
		
		/**
		 * Determines if the DataHandler should work in 'edition' mode
		 * Note that this is only the 'abstract' definition of this function
		 *  in the simple case where your DataHandler should never have to edit data
		 *
		 * @return	boolean	TRUE if edition mode, FALSE if not
		 */
		function _edition() {
			return FALSE;
		}

		function _creation() {
			return !$this->_edition();
		}

		/**
		 * Gets the data previously stored by the DataHandler
		 * for edition
		 * Note that this is only the 'abstract' definition of this function
		 *  in the simple case where your DataHandler should never have to edit data
		 *
		 * @return	boolean	TRUE if edition mode, FALSE if not
		 * @see	formidable_maindatahandler::_edition()
		 */
		function _getStoredData($sName = FALSE) {
			
			if($sName !== FALSE) {
				return "";
			}

			return array();
		}

		function getStoredData($sName = FALSE) {
			return $this->_getStoredData($sName);
		}

		function refreshStoredData() {
			$this->__aStoredData = array();
			$this->_getStoredData();
		}

		function refreshFormData() {
			$this->__aFormData = array();
			$this->_getFormData();
		}
		
		function refreshFormDataManaged() {
			$this->__aFormDataManaged = array();
			$this->_getFormDataManaged();
		}

		function refreshAllData() {
			$this->refreshStoredData();
			$this->refreshFormData();
			$this->refreshFormDataManaged();
		}

		function _currentEntryId() {

			if(!is_null($this->newEntryId)) {
				return $this->newEntryId;
			}

			if(!is_null($this->entryId)) {
				return $this->entryId;
			}

			if($this->_isSubmitted() && !$this->_isClearSubmitted()) {
				
				$form_id = $this->oForm->formid;

				$aPost = t3lib_div::_POST();

				$aPost	= is_array($aPost[$form_id]) ? $aPost[$form_id] : array();
				$aFiles	= is_array($GLOBALS["_FILES"][$form_id]) ? $GLOBALS["_FILES"][$form_id] : array();
				$aP = t3lib_div::array_merge_recursive_overrule($aPost, $aFiles);

				t3lib_div::stripSlashesOnArray($aP);
				
				if(array_key_exists("AMEOSFORMIDABLE_ENTRYID", $aP) && trim($aP["AMEOSFORMIDABLE_ENTRYID"]) !== "") {
					return intval($aP["AMEOSFORMIDABLE_ENTRYID"]);
				}
			}

			return FALSE;
		}

		function _getHumanFormData() {

			$aFormData = $this->_getFormData();

			$aValues = array();
			$aLabels = array();

			reset($aFormData);
			while(list($elementname, $value) = each($aFormData)) {

				if(array_key_exists($elementname, $this->oForm->aORenderlets)) {
					$aValues[$elementname] = $this->oForm->aORenderlets[$elementname]->_getHumanReadableValue($value);
					$aLabels[$elementname] = $this->oForm->_getLLLabel($this->oForm->aORenderlets[$elementname]->aElement["label"]);
				}
			}

			reset($aValues);
			reset($aLabels);

			return array(
				"labels"	=> $aLabels,
				"values"	=> $aValues
			);
		}

		function _initCols() {
			$this->__aCols = array();
		}
		
		function getListData($sKey = FALSE) {
			return $this->_getListData($sKey);
		}

		function _getListData($sKey = FALSE) {
			
			if($sKey !== FALSE) {
				
				if(array_key_exists($sKey, $this->__aListData)) {

					reset($this->__aListData);
					return $this->__aListData[$sKey];
				} else {
					
					return FALSE;
				}
			} else {

				reset($this->__aListData);
				return $this->__aListData;
			}
		}

		function _getParentListData($sKey = FALSE) {
			if($sKey !== FALSE) {
				
				if(array_key_exists($sKey, $this->__aParentListData)) {

					reset($this->__aParentListData);
					return $this->__aParentListData[$sKey];
				} else {
					
					return FALSE;
				}
			} else {

				reset($this->__aParentListData);
				return $this->__aParentListData;
			}
		}

		function i18n() {
			return $this->_defaultFalse("/i18n/use");
		}

		function i18n_getSysLanguageUid() {
			// http://lists.netfielders.de/pipermail/typo3-at/2005-November/007373.html

			if($this->_getThisFormData("sys_language_uid") !== "") {
				return $this->_getThisFormData("sys_language_uid");
			} else {
				return $GLOBALS["TSFE"]->tmpl->setup["config."]["sys_language_uid"];
			}
		}

		function i18n_getChildRecords($iParentUid) {

			if(($sTableName = $this->tableName())!== FALSE) {

				$aRecords = array();

				$rSql = $GLOBALS["TYPO3_DB"]->exec_SELECTquery(
					"*",
					$sTableName,
					"l18n_parent='" . $iParentUid . "'"
				);

				while(($aRs = $GLOBALS["TYPO3_DB"]->sql_fetch_assoc($rSql)) !== FALSE) {
					$aRecords[$aRs["sys_language_uid"]] = $aRs;
				}

				if(!empty($aRecords)) {
					reset($aRecords);
					return $aRecords;
				}
			}

			return array();
		}

		function i18n_getDefLangUid() {
			return $this->_navConf("/i18n/deflanguid");
		}
		
		function getT3Languages() {
			
			if($this->aT3Languages === FALSE) {

				$this->aT3Languages = array();

				$rSql = $GLOBALS["TYPO3_DB"]->exec_SELECTquery(
					"*",
					"sys_language",
					"1=1" . $this->oForm->cObj->enableFields("sys_language")//"hidden=0"
				);
				
				while(($aRs = $GLOBALS["TYPO3_DB"]->sql_fetch_assoc($rSql)) !== FALSE) {
					$this->aT3Languages[$aRs["uid"]] = $aRs;
				}
			}

			reset($this->aT3Languages);
			return $this->aT3Languages;
		}

		function i18n_currentRecordUsesDefaultLang() {
			return FALSE;
		}

		function tableName() {
			return $this->oForm->_navConf("/control/datahandler/tablename");
		}

		function keyName() {
			return $this->oForm->_navConf("/control/datahandler/keyname");
		}

		function newI18nRequested() {
			return FALSE;
		}

		function i18n_getValueDefaultLang() {
			if($this->i18n()) {

			}
		}

		function i18n_getStoredParent($bStrict = TRUE) {
			return FALSE;
		}

		function getRdtValue($sName) {
		
			if(!array_key_exists($sName, $this->oForm->aORenderlets)) {
				return "";
			}

			if($this->oForm->aORenderlets[$sName]->i18n_shouldNotTranslate()) {
				if(($aStoredI18NParent = $this->i18n_getStoredParent(TRUE)) !== FALSE) {
					if(array_key_exists($sName, $aStoredI18NParent)) {
						return $this->oForm->aORenderlets[$sName]->_unFlatten(
							$aStoredI18NParent[$sName]
						);
					}
				}
			} elseif($this->_isClearSubmitted()) {
				
				if($this->_edition()) {
					return $this->getRdtValue_noSubmit_edit($sName);
				} else {
					return $this->getRdtValue_noSubmit_noEdit($sName);
				}

			} elseif($this->_isSubmitted()) {
				
				if($this->oForm->iForcedEntryId !== FALSE) {
					// we have to use a fresh new record from database
						// so let noSubmit_edit do the job (meaning: don't consider values from submitted POST, but only those from DB)

					return $this->getRdtValue_noSubmit_edit($sName);
				} else {
					if(($mValue = $this->oForm->aORenderlets[$sName]->__getValue()) !== FALSE) {
						return $mValue;
					} else {
						if($this->oForm->aORenderlets[$sName]->_readOnly()) {
							if($this->_edition()) {
								return $this->getRdtValue_submit_readonly_edition($sName);
							} else {
								return $this->getRdtValue_submit_readonly_noEdition($sName);
							}
						} else {
							if($this->_edition()) {
								return $this->getRdtValue_submit_edition($sName);
							} else {
								return $this->getRdtValue_submit_noEdition($sName);
							}
						}
					}
				}
			} else {
				if($this->_edition()) {
					return $this->getRdtValue_noSubmit_edit($sName);
				} else {
					return $this->getRdtValue_noSubmit_noEdit($sName);
				}
			}
		}

		function getRdtValue_submit_edition($sName) {
			$aGP = $this->_GP();
			if(array_key_exists($sName, $aGP)) {
				return $aGP[$sName];
			}

			return "";
		}

		function getRdtValue_submit_noEdition($sName) {
			return $this->getRdtValue_submit_edition($sName);
		}

		function getRdtValue_submit_readonly_edition($sName) {
			
			$aData = t3lib_div::array_merge_recursive_overrule(		// permable au positionnement de valeur par GET ( et POST ? )
				$this->_getStoredData(),
				$this->_GP()
			);

			if(array_key_exists($sName, $aData)) {
				return $this->oForm->aORenderlets[$sName]->_unFlatten(
					$aData[$sName]
				);
			}

			return "";
		}

		function getRdtValue_submit_readonly_noEdition($sName) {
			
			$aGP = $this->_GP();

			if(($mValue = $this->oForm->aORenderlets[$sName]->__getValue()) !== FALSE) {			// value is prioritary if submitted
				return $this->oForm->aORenderlets[$sName]->_unFlatten($mValue);
			} elseif(array_key_exists($sName, $aGP)) {
				return $this->oForm->aORenderlets[$sName]->_unFlatten($aGP[$sName]);
			} elseif(($mValue = $this->oForm->aORenderlets[$sName]->__getDefaultValue()) !== FALSE) {
				return $this->oForm->aORenderlets[$sName]->_unFlatten($mValue);
			}

			return "";
		}

		function getRdtValue_noSubmit_noEdit($sName) {

			if(array_key_exists($sName, $this->oForm->aORenderlets)) {

				if($this->_isClearSubmitted()) {
					$aGP = $this->_G();
				} else {
					$aGP = $this->_GP();
				}

				if(($mValue = $this->oForm->aORenderlets[$sName]->__getValue()) !== FALSE) {
					return $this->oForm->aORenderlets[$sName]->_unFlatten($mValue);
				} elseif(array_key_exists($sName, $aGP)) {
					return $this->oForm->aORenderlets[$sName]->_unFlatten($aGP[$sName]);
				} elseif(($mValue = $this->oForm->aORenderlets[$sName]->__getDefaultValue()) !== FALSE) {
					return $this->oForm->aORenderlets[$sName]->_unFlatten($mValue);
				}
			}

			return "";
		}

		function getRdtValue_noSubmit_edit($sName) {
			
			$tablename	= $this->tableName();
			$keyname	= $this->keyName();

			if($tablename && $keyname) {
				
				if(array_key_exists($sName, $this->oForm->aORenderlets)) {
					
					if(($mValue = $this->oForm->aORenderlets[$sName]->__getValue()) !== FALSE) {	// value a toujours le dessus
						return $this->oForm->aORenderlets[$sName]->_unFlatten($mValue);
					} else {

						$aData = t3lib_div::array_merge_recursive_overrule(		// permable au positionnement de valeur par GET
							$this->_getStoredData(),
							$this->_G()
						);

						if(array_key_exists($sName, $aData)) {
							return $this->oForm->aORenderlets[$sName]->_unFlatten($aData[$sName]);
						}
					}
				}
			} else {
				$this->oForm->mayday("DATAHANDLER configuration isn't correct");
			}

			return "";
		}
	}

	if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/class.maindatahandler.php"])	{
		include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/class.maindatahandler.php"]);
	}
?>
