<?php

	class formidable_mainrenderer extends formidable_mainobject {

		var $aCustomHidden	= null;
		var $bFormWrap		= TRUE;
		var $bValidation	= TRUE;
		var $bDisplayLabels	= TRUE;

		function _init(&$oForm, $aElement, $aObjectType, $sXPath) {

			parent::_init($oForm, $aElement, $aObjectType, $sXPath);

			$this->_setDisplayLabels(!$this->oForm->_isFalse("/meta/displaylabels"));
		}

		function _render($aRendered) {
			return $this->_wrapIntoForm(implode("<br />\n", $aRendered));
		}
		
		function _includeLibraries() {

			if($this->oForm->useJs()) {
				$this->oForm->oJs->_includeOnceLibs();
				$this->oForm->oJs->_includeThisFormDesc();
			}
			
		}

		function _wrapIntoDebugContainer($aHtmlBag, &$oRdt) {

			$sName = $oRdt->_getName();

			$sHtml = <<<TEMPLATE

				
				<div class="ameosformidable_debugcontainer_void">
					<div style="pointer: help;" class="ameosformidable_debughandler_void">{$oRdt->aElement["type"]}:{$sName}</div>
					{$aHtmlBag["__compiled"]}
				</div>
TEMPLATE;
			$aHtmlBag["__compiled"] = $sHtml;

			if(array_key_exists("input", $aHtmlBag)) {
				
				$sInfos = rawurlencode($aHtmlBag["input"]);
				$sHtml = <<<TEMPLATE

				
				<div class="ameosformidable_debugcontainer_void">
					<div style="pointer: help;" class="ameosformidable_debughandler_void">{$sName}.input</div>
					{$aHtmlBag["input"]}
				</div>
TEMPLATE;
				$aHtmlBag["input"] = $sHtml;

			}
			return $aHtmlBag;
		}

		function _wrapIntoForm($html) {

			if(!empty($this->oForm->oDataHandler->newEntryId)) {
				$iEntryId = $this->oForm->oDataHandler->newEntryId;
			} else {
				$iEntryId = $this->oForm->oDataHandler->_currentEntryId();
			}
			
			$hidden_entryid		= $this->_getHiddenEntryId($iEntryId);
			$hidden_custom		= $this->_getHiddenCustom();
			$sSysHidden			=	"<input type='hidden' name='" . $this->oForm->formid . "[AMEOSFORMIDABLE_SERVEREVENT]' id='" . $this->oForm->formid . "_AMEOSFORMIDABLE_SERVEREVENT' />" .
									"<input type='hidden' name='" . $this->oForm->formid . "[AMEOSFORMIDABLE_SERVEREVENT_PARAMS]' id='" . $this->oForm->formid . "_AMEOSFORMIDABLE_SERVEREVENT_PARAMS' />" .
									"<input type='hidden' name='" . $this->oForm->formid . "[AMEOSFORMIDABLE_SERVEREVENT_HASH]' id='" . $this->oForm->formid . "_AMEOSFORMIDABLE_SERVEREVENT_HASH' />" .
									"<input type='hidden' name='" . $this->oForm->formid . "[AMEOSFORMIDABLE_ADDPOSTVARS]' id='" . $this->oForm->formid . "_AMEOSFORMIDABLE_ADDPOSTVARS' />" .
									"<input type='hidden' name='" . $this->oForm->formid . "[AMEOSFORMIDABLE_VIEWSTATE]' id='" . $this->oForm->formid . "_AMEOSFORMIDABLE_VIEWSTATE' />" .
									"<input type='hidden' name='" . $this->oForm->formid . "[AMEOSFORMIDABLE_SUBMITTED]' id='" . $this->oForm->formid . "_AMEOSFORMIDABLE_SUBMITTED' value='" . AMEOSFORMIDABLE_EVENT_SUBMIT_FULL . "' />";

			if(($sStepperId = $this->oForm->_getStepperId()) !== FALSE) {
				$sSysHidden .=	"<input type='hidden' name='AMEOSFORMIDABLE_STEP' id='AMEOSFORMIDABLE_STEP' value='" . $this->oForm->_getStep() . "' />" .
								"<input type='hidden' name='AMEOSFORMIDABLE_STEP_HASH' id='AMEOSFORMIDABLE_STEP_HASH' value='" . $this->oForm->_getSafeLock($this->oForm->_getStep()) . "' />";
			}
			
			$aHtmlBag =
				array(
					"SCRIPT"		=> "",
					"FORMBEGIN"		=> "",
					"CONTENT"		=> $html,
					/*"HIDDEN"		=> $hidden_entryid . $hidden_custom . $sSysHidden,*/
					"HIDDEN"		=> "<p style='position:absolute; top:-5000px; left:-5000px;'>" . $hidden_entryid . $hidden_custom . $sSysHidden . "</p>",	// in P for XHTML validation
					"FORMEND"		=> "",
				);
			
			if($this->bFormWrap) {
				
				$formid			= "";
				$formaction		= "";
				$formonsubmit	= "";
				$formmethod		= "";
				$formcustom		= "";
				
				/*$formid = " id=\"" . $this->oForm->formid . "\" name=\"" . $this->oForm->formid . "\" ";*/
				$formid = " id=\"" . $this->oForm->formid . "\" ";

				if(($sAction = $this->oForm->_navConf("/meta/form/action")) !== FALSE) {
					$formaction = " action=\"" . $this->oForm->xhtmlUrl($sAction) . "\" ";
				} else {
					$formaction = " action=\"" .  $this->oForm->xhtmlUrl(t3lib_div::getIndpEnv("TYPO3_REQUEST_URL")) . "\" ";
				}

				if(($sOnSubmit = $this->oForm->_navConf("/meta/form/onsubmit")) !== FALSE) {
					$formonsubmit = " onSubmit = \"" . $sOnSubmit . "\" ";
				}

				if(($sCustom = $this->oForm->_navConf("/meta/form/custom")) !== FALSE) {
					$formcustom = " " . $sCustom . " ";
				}
				
				$aHtmlBag["FORMBEGIN"]	=	"<form enctype=\"multipart/form-data\" " . $formid . $formaction . $formonsubmit . $formcustom . " method=\"post\">";
				$aHtmlBag["FORMEND"]	=	"</form>";
			}
			
			reset($aHtmlBag);
			return $aHtmlBag;
		}
		
		function _getFullSubmitEvent() {
			return "Formidable.f('" . $this->oForm->formid . "').submitFull();";
		}

		function _getRefreshSubmitEvent() {
			return "Formidable.f('" . $this->oForm->formid . "').submitRefresh();";
		}

		function _getDraftSubmitEvent() {
			return "Formidable.f('" . $this->oForm->formid . "').submitDraft();";
		}

		function _getTestSubmitEvent() {
			return "Formidable.f('" . $this->oForm->formid . "').submitTest();";
		}

		function _getClearSubmitEvent() {
			return "Formidable.f('" . $this->oForm->formid . "').submitClear();";
		}

		function _getSearchSubmitEvent() {
			return "Formidable.f('" . $this->oForm->formid . "').submitSearch();";
		}

		function _getServerEvent($sRdtName, $aEvent, $aData = array()) {
//debug($aData);
//			debug($sRdtName, "_getServerEvent");
//			debug(t3lib_div::debug_trail(), "_getServerEvent");
			$sEventId = $this->oForm->_getServerEventId(
				$sRdtName,
				$aEvent
			);

			$sJsParam = "false";
			$sHash = "false";

			if(!empty($aData)) {
//				debug($aData, "params");
				$aFullEvent = $this->oForm->aServerEvents[$sEventId];
//				debug($aFullEvent, "aFullEvent");
//				debug($this->oForm->aServerEvents);

//				debug($this->oForm->aServerEvents[$sEventId], "event");
//				debug($aFullEvent["params"], "needed params");


				$aGrabbedParams = array();
				reset($aFullEvent["params"]);
				while(list(, $sParam) = each($aFullEvent["params"])) {
					if(array_key_exists($sParam, $aData)) {
						$aGrabbedParams[$sParam] = $aData[$sParam];
					}
				}

//				debug($aGrabbedParams, "grabbed params");
				if(!empty($aGrabbedParams)) {
					$sJsParam = base64_encode(serialize($aGrabbedParams));
					$sHash = "'" . $this->oForm->_getSafeLock($sJsParam) . "'";
					$sJsParam = "'" . $sJsParam . "'";
				}
			}
			
			$sConfirm = "false";
			if(array_key_exists("confirm", $aEvent) && trim($aEvent["confirm"] !== "")) {
				$sConfirm = "'" . rawurlencode(
					$this->oForm->_getLLLabel(
						$aEvent["confirm"]
					)
				) . "'";
			}

			if(($sSubmitMode = $this->oForm->_navConf("submit", $aEvent)) !== FALSE) {
				switch($sSubmitMode) {
					case "full" : {
						return "Formidable.f('" . $this->oForm->formid . "').executeServerEvent('" . $sEventId . "', Formidable.SUBMIT_FULL, " . $sJsParam . ", " . $sHash . ", " . $sConfirm . ");";
						break;
					}
					case "refresh" : {
						return "Formidable.f('" . $this->oForm->formid . "').executeServerEvent('" . $sEventId . "', Formidable.SUBMIT_REFRESH, " . $sJsParam . ", " . $sHash . ", " . $sConfirm . ");";
						break;
					}
					case "draft" : {
						return "Formidable.f('" . $this->oForm->formid . "').executeServerEvent('" . $sEventId . "', Formidable.SUBMIT_DRAFT, " . $sJsParam . ", " . $sHash . ", " . $sConfirm . ");";
						break;
					}
					case "test" : {
						return "Formidable.f('" . $this->oForm->formid . "').executeServerEvent('" . $sEventId . "', Formidable.SUBMIT_TEST, " . $sJsParam . ", " . $sHash . ", " . $sConfirm . ");";
						break;
					}
				}
			} else {
				// default: REFRESH
				return "Formidable.f('" . $this->oForm->formid . "').executeServerEvent('" . $sEventId . "', Formidable.SUBMIT_REFRESH , " . $sJsParam . ", " . $sHash . ", " . $sConfirm . ");";
			}
		}
		
		function _getAjaxEvent(&$oRdt, $aEvent, $sEvent) {

			$sRdtName = $oRdt->_getName();

			$sEventId = $this->oForm->_getAjaxEventId(
				$sRdtName,
				array($sEvent => $aEvent)
			);

			$sRdtId = $oRdt->_getElementHtmlId();
			$sHash = $oRdt->_getSessionDataHashKey();
			$bCache = $this->oForm->_defaultTrue("/cache", $aEvent);
			$bPersist = $this->oForm->_defaultFalse("/persist", $aEvent);

			$aParams = array();
			$aRowParams = array();

			if(($sParams = $this->oForm->_navConf("/params", $aEvent)) !== FALSE) {
				$aParams = t3lib_div::trimExplode(",", $sParams);

				// grabbing lister current row param
				$aTempParams = $aParams;
				reset($aTempParams);
				while(list($iKey, $sParam) = each($aTempParams)) {
					if(t3lib_div::isFirstPartOfStr($sParam, "rowData::")) {
						unset($aParams[$iKey]);
						$sParamName = substr($sParam, 9);
						if(($sValue = $this->oForm->oDataHandler->_getListData($sParamName)) !== FALSE) {
							$aRowParams[$sParamName] = $sValue;
						} else {
							$aRowParams[$sParamName] = "";
						}
					} elseif(t3lib_div::isFirstPartOfStr($sParam, "rowInput::")) {
						/* replacing *id* with *id for this row*; will be handled by JS framework */
						$sParamName = substr($sParam, 10);
						$aParams[$iKey] = "rowInput::" . $sParamName . "::" . $this->oForm->aORenderlets[$sParamName]->_getElementHtmlId();
							// note: _getAjaxEvent() is called when in rows rendering for list
								// _getElementHtmlId() on a renderlet is designed to return the correct html id for the input of this row
								// in such a case
					}
				}
			}
			
			$aAjaxEventParams = $oRdt->alterAjaxEventParams(array(
				"eventname" => $sEvent,
				"eventid" => $sEventId,
				"hash" => $sHash,
				"cache" => $bCache,
				"persist" => $bPersist,
				"params" => $aParams,
				"row" => $aRowParams
			));

			$sJsonParams = $this->oForm->array2json($aAjaxEventParams["params"]);
			$sJsonRowParams = $this->oForm->array2json($aAjaxEventParams["row"]);

			return "Formidable.f('" . $this->oForm->formid . "').executeAjaxEvent('" . $aAjaxEventParams["eventname"] . "', '" . $sRdtId . "', '" . $aAjaxEventParams["eventid"] . "', '" . $aAjaxEventParams["hash"] . "', " . (($aAjaxEventParams["cache"]) ? "true" : "false") . ", " . (($aAjaxEventParams["persist"]) ? "true" : "false") . ", " . $sJsonParams . ", " . $sJsonRowParams . ", arguments);";
		}

		function wrapEventsForInlineJs($aEvents) {
			
			$aJson = array();
			reset($aEvents);
			while(list(, $sJs) = each($aEvents)) {
				$aJson[] = rawurlencode($sJs);
			}

			return "Formidable.executeInlineJs(" . $this->oForm->array2json($aJson) . ");";
		}

		function _getClientEvent($sObjectName, $aEvent = array(), $aEventData) {

			if(array_key_exists($sObjectName, $this->oForm->aORenderlets)) {
				$sObjectId = $this->oForm->aORenderlets[$sObjectName]->_getElementHtmlId();
			} elseif($sObjectName === $this->oForm->formid) {
				$sObjectId = $this->oForm->formid;
			} else {
				$sObjectId = "tx_ameosformidable";
			}
			if(empty($aEventData)) {
				$aEventData = array();
			}

			$sData = $this->oForm->array2json(
				array(
					"init" => array(),			// init and attachevents are here for majix-ajax compat
					"attachevents" => array(),
					"tasks" => $aEventData,
				)
			);

			$bPersist = $this->oForm->_defaultFalse("/persist", $aEvent);

			return "Formidable.f('" . $this->oForm->formid . "').executeClientEvent('" . $sObjectId . "', " . (($bPersist) ? "true" : "false") . ", {$sData});";
		}

		function _getHiddenEntryId($entryId) {
			
			if(!empty($entryId)) {
				return "<input type = \"hidden\" id=\"" . $this->_getHiddenHtmlId("AMEOSFORMIDABLE_ENTRYID") . "\" name=\"" . $this->_getHiddenHtmlName("AMEOSFORMIDABLE_ENTRYID") . "\" value=\"" . $entryId . "\" />";
			}

			return "";
		}
		
		function _getHiddenCustom() {
			if(is_array($this->aCustomHidden) && sizeof($this->aCustomHidden) > 0)
			{ return implode("", $this->aCustomHidden);}

			return "";
		}

		function _setHiddenCustom($name, $value) {

			if(!is_array($this->aCustomHidden)) {
				$this->aCustomHidden = array();
			}
			
			$this->aCustomHidden[$name] = "<input type=\"hidden\" id=\"" . $this->_getHiddenHtmlId($name) . "\" name=\"" . $this->_getHiddenHtmlName($name) . "\" value=\"" . $value . "\" />";
		}

		function _getHiddenHtmlName($sName) {
			return $this->_getHtmlName($sName);
		}
		
		function _getHiddenHtmlId($sName) {
			return $this->_getHtmlId($sName);
		}

		function _getHtmlId($sName) {
			return $this->oForm->formid . "_" . $sName;
		}
		
		function _getHtmlName($sName) {
			return $this->oForm->formid . "[" . $sName . "]";
		}
		
		function _setFormWrap($bWrap) {
			$this->bFormWrap = $bWrap;
		}

		function _setValidation($bValidation) {
			$this->bValidation = $bValidation;
		}

		function _getThisFormId() {
			return $this->oForm->formid;
		}

		function _setDisplayLabels($bDisplayLabels) {
			$this->bDisplayLabels = $bDisplayLabels;
		}
		
		/*function _displayLabel($label) {
			return ($this->bDisplayLabels && (trim($label) != "")) ? "<div>" . $label . "</div>\n" : "";
		}*/

		function renderStyles() {

			if(($mStyle = $this->_navConf("/style")) !== FALSE) {

				$sUrl = FALSE;
				$sStyle = FALSE;

				if($this->oForm->isUserObj($mStyle)) {
					$sStyle = $this->oForm->_callUserObj($mStyle);
				} elseif(is_array($mStyle) && array_key_exists("__value", $mStyle) && trim($mStyle["__value"]) != "") {
					$sStyle = $mStyle["__value"];
				} else {
					$sStyle = $mStyle;
				}

				if(is_array($mStyle) && array_key_exists("url", $mStyle)) {
					if($this->oForm->isUserObj($mStyle["url"])) {
						$sUrl = $this->oForm->_callUserObj($mStyle["url"]);
					} else {
						$sUrl = $mStyle["url"];
					}

					if($this->_defaultFalse("/style/rewrite") === TRUE) {
						if(!$this->oForm->isAbsWebPath($sUrl)) {
							$sUrl = $this->oForm->toServerPath($sUrl);
							$sStyle = t3lib_div::getUrl($sUrl);
							$sUrl = FALSE;
						}
					}
				}
				
				if($sStyle !== FALSE) {
					reset($this->oForm->aORenderlets);
					while(list($sName, ) = each($this->oForm->aORenderlets)) {
						$oRdt =& $this->oForm->aORenderlets[$sName];
						$sStyle = str_replace(
							array(
								"#" . $sName,
								"{PARENTPATH}"
							),
							array(
								"#" . $oRdt->_getElementCssId(),
								$this->oForm->_getParentExtSitePath()
							),
							$sStyle
						);
					}
					
					//$sStyle = str_replace(";", " !important;", $sStyle);

					$this->oForm->additionalHeaderData(
						$this->oForm->inline2TempFile(
							$sStyle,
							'css',
							"Form '" . $this->oForm->formid . "' styles"
						)
					);
				}

				if($sUrl !== FALSE) {
					$sUrl = $this->oForm->toWebPath($sUrl);
					$this->oForm->additionalHeaderData(
						"<link rel='stylesheet' type='text/css' href='" . $sUrl . "' />"
					);
				}
			}
		}

		function processHtmlBag($mHtml, &$oRdt) {
			
			$sLabel = array_key_exists("label", $oRdt->aElement) ? $this->oForm->_getLLLabel($oRdt->aElement["label"]) : "";
			
			if(is_string($mHtml)/* && (($mHtml = trim($mHtml)) !== "")*/) {		// can be empty with empty readonly 
				
				$mHtml = array(
					"__compiled"	=> $mHtml
				);
			}

			if(!empty($mHtml) && array_key_exists("__compiled", $mHtml) && is_string($mHtml["__compiled"])/* && trim($mHtml["__compiled"]) !== ""*/) {

				if(($mWrap = $oRdt->_navConf("/wrap")) !== FALSE) {
					
					if($this->oForm->isUserObj($mWrap)) {
						$mWrap = $this->oForm->_callUserObj($mWrap);
					}

					$mWrap = $this->oForm->_substLLLInHtml($mWrap);

					$mHtml["__compiled"] = str_replace("|", $mHtml["__compiled"], $mWrap);
					// wrap added for f.schossig	2006/08/29
				}
				
				if(!array_key_exists("label", $mHtml)) {
					$mHtml["label"] = $sLabel;
				}

				if(!array_key_exists("label.", $mHtml)) {
					$mHtml["label."] = array();
				}

				if(!array_key_exists("tag", $mHtml["label."])) {
					$mHtml["label."]["tag"] = "<label for=\"" . $oRdt->_getElementHtmlId() . "\" id=\"" . $oRdt->_getElementHtmlId() . "_label\">" . $sLabel . "</label>";
				}

				if(!array_key_exists("htmlname", $mHtml)) {
					$mHtml["htmlname"] = $oRdt->_getElementHtmlName();
				}

				if(!array_key_exists("htmlid", $mHtml)) {
					$mHtml["htmlid"] = $oRdt->_getElementHtmlId();
				}

/*				if(array_key_exists($oRdt->_getName(), $this->_aValidationErrors)) {
					$mHtml["error"] = $this->_aValidationErrors[$oRdt->_getName()];
				}

				debug($this->_aValidationErrors, $oRdt->_getName());
				debug($mHtml);*/

				$mHtml["help"] = t3lib_div::view_array($mHtml);

				$mHtml = $this->recombineHtmlBag(
					$mHtml,
					$oRdt
				);
				
				if($this->oForm->bDebug && $oRdt->_debugable()) {
					$mHtml = $this->_wrapIntoDebugContainer(
						$mHtml,
						$oRdt
					);
				}
			} else {
				$mHtml = array();
			}

			reset($mHtml);
			return $mHtml;
		}

		function recombineHtmlBag($mHtml, &$oRdt) {
			
			if(($mRecombine = $oRdt->_navConf("/recombine")) !== FALSE) {

				// we convert the aHtmlBag to something useable in TypoScript
				// creating sub-array for each xxx.yyy ( split on dot )

				$sTs = '';
				while(list($sCanal, $sHtml) = each($mHtml)) {
					$sTs .= '
						params.' . $sCanal . ' (
							' . $sHtml . '
						)
					';
				}

				

				require_once(PATH_t3lib."class.t3lib_tsparser.php");

				$oParser = t3lib_div::makeInstance("t3lib_tsparser");
				$oParser->tt_track = 0;	// Do not log time-performance information
				$oParser->parse($sTs);

				$aParams = $oParser->setup["params."];
				
				// recombining canals
				//reset($mHtml);
				$aCanals = array_keys($mHtml);
				while(list(, $sCanal) = each($aCanals)) {

					$sCanalPath = str_replace(".", "/", $sCanal);
//					debug($sCanal, "ici");

					if(($mRecombineCanal = $oRdt->_navConf("/recombine/" . $sCanalPath)) !== FALSE) {
						
						if($this->oForm->isUserObj($mRecombineCanal)) {

							// expecting userobj

							$sValue = $this->oForm->_callUserObj(
								$mRecombineCanal,
								$aParams,
								FALSE,
								$this,
								FALSE		// do not add dots
							);

							$mHtml[$sCanal] = $sValue;

							// reinjecting modified recombine into process for following recombines
							reset($aParams);
							$aSegments = explode(".", $sCanal);
							$aPointer =& $aParams;
							for($k = 0; $k < (count($aSegments) - 1); $k++) {
								$aPointer =& $aPointer[$aSegments[$k] . "."];
							}

							$aPointer[$aSegments[$k]] = $sValue;
						}
					}
				}

				// recombining __compiled

				if($this->oForm->isUserObj($mRecombine)) {
					
					// expecting userobj

					$mHtml["__compiled"] = $this->oForm->_callUserObj(
						$mRecombine,
						$aParams,
						FALSE,
						$this,
						FALSE		// do not add dots
					);
				}
			}

			reset($mHtml);
			return $mHtml;
		}

		function displayOnlyIfJs($aRendered) {

			$aRdts = array_keys($this->oForm->aORenderlets);
			reset($aRdts);
			while(list(, $sRdt) = each($aRdts)) {
				if($this->oForm->aORenderlets[$sRdt]->displayOnlyIfJs() === TRUE) {
					$sJson = $this->oForm->oJson->encode(
						$aRendered[$sRdt]["__compiled"]
					);

					$sId = $this->oForm->aORenderlets[$sRdt]->_getElementHtmlId() . "_unobtrusive";
					$aRendered[$sRdt]["__compiled"] = "<span id='" . $sId . "'></span>";

					$this->oForm->attachInitTaskUnobtrusive('
						if($("' . $sId . '")) {$("' . $sId . '").innerHTML=' . $sJson . ';}
					');
				}
			}

			return $aRendered;
		}

	}
	
	if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/class.mainrenderer.php"])	{
		include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/class.mainrenderer.php"]);
	}
?>