<?php

	class formidable_mainrenderlet extends formidable_mainobject {

		var $__aCacheItems = array();

		var $aChilds		= array();
		var $bChild			= FALSE;

		var $aLibs = array();
		var $sMajixClass = "";
		var $bCustomIncludeScript = FALSE;	// TRUE if the renderlet needs to handle script inclusion itself

		var $aSkin = FALSE;

		var $sCustomElementId = FALSE;		// if != FALSE, will be used instead of generated HTML id ( useful for checkbox-group renderlet )
		var $aPossibleCustomEvents = array();
		var $aCustomEvents = array();
		var $oRdtParent = FALSE;

		var $aForcedItems = FALSE;
		var $bSubmitter = FALSE;

		var $sNamePrefix = FALSE;

		function _init(&$oForm, $aElement, $aObjectType, $sXPath) {
			
			parent::_init($oForm, $aElement, $aObjectType, $sXPath);
			$this->initChilds();
			$this->initProgEvents();
		}

		function initChilds($bReInit = FALSE) {
			if($this->mayHaveChilds() && $this->hasChilds()) {

				$sXPath = $this->sXPath . "childs/";
				$this->aChilds =& $this->oForm->_makeRenderlets(
					$this->oForm->_navConf($sXPath),
					$sXPath,
					TRUE,	// $bChilds ?
					$this,
					$bReInit	// set to TRUE if existing renderlets need to be overwritten
				);					// used in rdt_modalbox->majixShowBox() for re-init before render

				//$this->oForm->d(array("Childs of " . $this->_getName(), $this->aChilds));
			}
		}

		function isChildOf($sRdtName) {
			/*if($this->oRdtParent !== FALSE) {
				debug("TESTING " . $this->oRdtParent->_getName() . " AGAINST POTENTIAL PARENT " . $sRdtName . " ON THIS=" . $this->_getName(), "isCHILD");
			} else {
				debug($this->_getName() . " HAS NO PARENT", "isCHILD");
			}*/

			return ($this->oRdtParent !== FALSE && ($this->oRdtParent->_getName() === $sRdtName));
		}

		function isDescendantOf($sRdtName) {

			if($this->oRdtParent !== FALSE && $sRdtName !== $this->_getName()) {

				$sCurrent = $this->_getName();

				if($this->oForm->aORenderlets[$sCurrent]->isChildOf($sRdtName) === TRUE) {
					return TRUE;
				}

				while(array_key_exists($sCurrent, $this->oForm->aORenderlets) && $this->oForm->aORenderlets[$sCurrent]->oRdtParent !== FALSE) {

					$sCurrent = $this->oForm->aORenderlets[$sCurrent]->oRdtParent->_getName();
					if(array_key_exists($sCurrent, $this->oForm->aORenderlets) && $this->oForm->aORenderlets[$sCurrent]->isChildOf($sRdtName)) {
						return TRUE;
					}
				}
			}

			return FALSE;
		}
		
		function checkPoint(&$aPoints) {
			/* nothing by default */
		}
		
		function initProgEvents() {
			if(($aEvents = $this->_getProgServerEvents()) !== FALSE) {

				reset($aEvents);
				while(list($sEvent, $aEvent) = each($aEvents)) {

					if($aEvent["runat"] == "server") {

						$aDefinedEvent = $aEvent;

						$sEventId = $this->oForm->_getServerEventId($this->_getName(), $aEvent);	// before any modif to get the *real* eventid

						$aNeededParams = array();

						if(array_key_exists("params", $aEvent) && is_string($aEvent["params"])) {
							$aNeededParams = t3lib_div::trimExplode(",", $aEvent["params"]);
							$aEvent["params"] = $aNeededParams;
						}

						$this->oForm->aServerEvents[$sEventId] = array(
							"eventid" => $sEventId,
							"trigger" => $sEvent,
							"when" => (array_key_exists("when", $aEvent) ? $aEvent["when"] : "after-init"),	// default when : end
							"event" => $aEvent,
							"params" => $aNeededParams,
							"raw" => $aDefinedEvent,
						);
					}

				}
			}
		}

		function _getProgServerEvents() {
			return FALSE;
		}

		function render() {
			
			if($this->_readonly()) {
				return $this->_renderReadOnly();
			}
			
			return $this->_render();
		}
		
		function _render() {
			return $this->oForm->_getLLLabel($this->aElement["label"]);
		}

		function renderWithForcedValue($mValue) {
			$this->mForcedValue = $mValue;
			$mRendered = $this->render();
			unset($this->mForcedValue);
			return $mRendered;
		}

		function renderReadOnlyWithForcedValue($mValue) {
			$this->mForcedValue = $mValue;
			$mRendered = $this->_renderReadOnly();
			unset($this->mForcedValue);
			return $mRendered;
		}
		
		function _renderReadOnly() {

			$mValue = $this->oForm->oDataHandler->getThisFormData($this->_getName());
			$mHtml = array(
				"__compiled" => $this->wrapForReadOnly(
					$this->_getHumanReadableValue($mValue)
				),
				"additionalinputparams" => $this->_getAddInputParams($sId),
				"value" => $mValue,
				"value." => array(
					"nl2br" => nl2br($mValue),
				)
			);

			if(!is_array($mHtml["__compiled"])) {
				$mHtml["__compiled"] = $this->_displayLabel($this->oForm->_getLLLabel($this->_navConf("/label"))) . $mHtml["__compiled"];
			}

			return $mHtml;
		}

		function wrapForReadOnly($sHtml) {
			return "<span class=\"readonly\" id=\"" . $this->_getElementHtmlId() . "_readonly\">" . $sHtml . "</span>";
		}

		function _displayLabel($sLabel) {
			$sId = $this->_getElementHtmlId() . "_label";
			return ($this->oForm->oRenderer->bDisplayLabels && (trim($sLabel) != "")) ? "<label id='" . $sId . "' class='formidable-rdrstd-label " . $sId . "' for='" . $this->_getElementHtmlId() . "'>" . $sLabel . "</label>\n" : "";
		}

		function _getType() {
			return $this->_navConf("/type");
		}

		function _getName() {
			$sName = $this->_getNameWithoutPrefix();
			if($this->sNamePrefix !== FALSE) {
				return $this->sNamePrefix . $sName;
			}

			return $sName;
		}

		function _getNameWithoutPrefix() {
			return $this->_navConf("/name");
		}
		
		// alias for _getName()
		function getName() {
			return $this->_getName();
		}

		function __getDefaultValue() {

			$mValue = $this->_navConf("/data/defaultvalue/");

			if($this->oForm->isUserObj($mValue)) {
				$mValue = $this->_callUserObj($this->aElement, $mValue, null);
			}

			return $this->_substituteConstants($mValue);
		}

		function declareCustomValidationErrors() {

		}
		
		function __getValue() {

			$mValue = $this->_navConf("/data/value/");

			if(is_array($mValue)) {

				// on vrifie si on doit appeler un userobj pour rcuprer la valeur par dfaut

				if($this->oForm->_navConf("/userobj/", $mValue) !== FALSE) {
					$mValue = $this->oForm->_callUserObj($mValue);
				}
				else {
					$mValue = "";
				}
			}
			
			return $this->_substituteConstants($mValue);
		}
		
		function setValue($mValue) {

			$sName = $this->_getName();
			//debug($mValue, "setvalue:" . $sName);

			$this->oForm->oDataHandler->__aFormData[$sName] = $mValue;

			if(array_key_exists($sName, $this->oForm->oDataHandler->__aFormDataManaged)) {
				$this->oForm->oDataHandler->__aFormDataManaged[$sName] = $mValue;
			}

			$this->mForcedValue = $mValue;
		}
		
		function _getListValue() {

			$mValue = $this->_navConf("/data/listvalue/");

			if(is_array($mValue)) {

				// on vrifie si on doit appeler un userobj pour rcuprer la valeur par dfaut

				if($this->oForm->_navConf("/userobj/", $mValue) !== FALSE) {
					$mValue = $this->oForm->_callUserObj($mValue);
				}
				else
				{ $mValue = "";}
			}
			
			return $this->_substituteConstants($mValue);
		}

		function _getValue() {
			
			if(isset($this->mForcedValue)) {
				return $this->mForcedValue;
			} else {
				return $this->oForm->oDataHandler->getRdtValue(
					$this->_getName()
				);
			}
		}

		function getValue() {
			return $this->_getValue();
		}
		
		function _substituteConstants($sValue) {

			if($sValue === "CURRENT_TIMESTAMP") {
				$sValue = time();
			} elseif($sValue === "CURRENT_PAGEID") {
				// front end only
				$sValue = $GLOBALS["TSFE"]->id;
			} elseif($sValue === "CURRENT_USERID") {
				// front end only
				$sValue = $GLOBALS["TSFE"]->fe_user->user["uid"];
			}

			return $sValue;
		}

		function _getAddInputParamsArray() {

			$aAddParams = array();
			
			if(($sClass = trim($this->_getClass())) !== "") {
				$aAddParams[] = $sClass;
			}

			if(($sStyle = trim($this->_getStyle())) !== "") {
				$aAddParams[] = $sStyle;
			}

			if(($sCustom = trim($this->_getCustom())) !== "") {
				$aAddParams[] = $sCustom;
			}

			if(($sEvents = trim($this->_getEvents())) !== "") {
				$aAddParams[] = $sEvents;
			}

			/*
				disabled-property for renderlets patch by Manuel Rego Casasnovas
				@see http://lists.netfielders.de/pipermail/typo3-project-formidable/2007-December/000803.html
			*/

			if(($sDisabled = trim($this->_getDisabled())) !== "") {
				$aAddParams[] = $sDisabled;
			}
			
			if(($sTitle = $this->_navConf("/title")) !== FALSE) {
				if($this->oForm->isUserObj($sTitle)) {
					$sTitle = $this->oForm->_callUserObj($sTitle);
				}
				$sTitle = $this->oForm->_substLLLInHtml($sTitle);

				if(trim($sTitle) !== "") {
					$aAddParams[] = "title=\"" . $sTitle . "\"";
				}
			}

			return $aAddParams;
		}
		
		function _getAddInputParams() {
			
			$aAddParams = $this->_getAddInputParamsArray();
			
			if(count($aAddParams) > 0) {
				return " " . implode(" ", $aAddParams) . " ";
			} else {
				return "";
			}
		}
		
		function _getCustom() {
			
			if(($mCustom = $this->_navConf("/custom/")) !== FALSE) {
				if($this->oForm->isUserObj($mCustom)) {
					$mCustom = $this->oForm->_callUserObj($mCustom);
				}
				
				return " " . $mCustom . " ";
			}

			return "";
		}
		
		function _getStyle() {

			if(($mStyle = $this->_navConf("/style/")) !== FALSE) {
				if($this->oForm->isUserObj($mStyle)) {
					$mStyle = $this->oForm->_callUserObj($mStyle);
				}
				
				return " style=\"" . str_replace('"', "'", $mStyle) . "\" ";
			}

			return "";
		}

		function _getClass() {
			if(($mClass = $this->_navConf("/class/")) !== FALSE) {
				if($this->oForm->isUserObj($mClass)) {
					$mClass = $this->oForm->_callUserObj($mClass);
				}
				
				return " class=\"" . str_replace('"', "'", $mClass) . "\" ";
			}

			return "";
		}

		/*
			disabled-property for renderlets patch by Manuel Rego Casasnovas
			@see http://lists.netfielders.de/pipermail/typo3-project-formidable/2007-December/000803.html
		*/

		function _getDisabled() {
			
			if($this->_defaultFalse("/disabled/")) {
				return " disabled=\"disabled\" ";
			}

			return "";
		}

		function _getEventsArray() {

			$aEvents = array();
			
			$aGrabbedEvents = $this->oForm->__getEventsInConf($this->aElement);
			
			reset($aGrabbedEvents);
			while(list(, $sEvent) = each($aGrabbedEvents)) {

				if(($mEvent = $this->_navConf("/" . $sEvent . "/")) !== FALSE) {
//					debug($mEvent);

					if(is_array($mEvent)) {

						$sRunAt = (array_key_exists("runat", $mEvent) && in_array($mEvent["runat"], array("inline", "client", "ajax", "server"))) ? $mEvent["runat"] : "client";

						switch($sRunAt) {
							case "server": {
								
								$aEvent = $this->oForm->oRenderer->_getServerEvent(
									$this->_getNameWithoutPrefix(),	// because prefix is not available at compilation time, in tx_ameosformidable::_grabServerAndAjaxEvents()
									$mEvent,
									$this->oForm->oDataHandler->_getListData()
								);
								break;

							}
							case "ajax": {

								$sEventId = $this->oForm->_getAjaxEventId(
									$this->_getName(),
									array($sEvent => $mEvent)
								);

								//debug($sEventId, $this->_getName() . ":" . $sEvent);

								
								$aTemp = array(
									"name" => $this->_getName(),
									"eventid" => $sEventId,
									"trigger" => $sEvent,
									"cache" => $this->oForm->_defaultTrue("/cache", $mEvent),
									"event" => $mEvent,
								);

								if(!array_key_exists($sEventId, $this->oForm->aAjaxEvents)) {
									$this->oForm->aAjaxEvents[$sEventId] = $aTemp;
								}

								if($sEvent === "onload") {
									if(!array_key_exists($sEventId, $this->oForm->aOnloadEvents["ajax"])) {
										$this->oForm->aOnloadEvents["ajax"][$sEventId] = $aTemp;
									}
								}
								

								if($this->oForm->_defaultFalse("/needparent", $xEvent) === TRUE) {
									$this->oForm->bStoreParentInSession = TRUE;
								}

								$aEvent = $this->oForm->oRenderer->_getAjaxEvent(
									$this,
									$mEvent,
									$sEvent
								);

								// an ajax event is declared
								// we have to store this form in session
								// for serving ajax requests
								
								$this->oForm->bStoreFormInSession = TRUE;

								$GLOBALS["_SESSION"]["ameos_formidable"]["ajax_services"]["tx_ameosformidable"]["ajaxevent"][$this->_getSessionDataHashKey()] = array(
									"requester" => array(
										"name" => "tx_ameosformidable",
										"xpath" => "/",
									),
								);

								break;
							}
							case "client": {
								
								// array client mode event

								if($sEvent !== "onload") {
									if($this->oForm->isUserObj($mEvent)) {
										$aEvent = $this->oForm->_callUserObj($mEvent);
										
										if(is_array($aEvent)) {
											// event is an array of tasks to execute on js objects
											$aEvent = $this->oForm->oRenderer->_getClientEvent(
												$this->_getName(),
												$mEvent,
												$aEvent
											);
										} else {
											// event has been converted from userobj to custom string event
										}

									} else {
										if(array_key_exists("refresh", $mEvent)) {
											$aEvent = $this->_getEventRefresh($mEvent["refresh"]);
										} elseif(array_key_exists("submit", $mEvent)) {
											$aEvent = $this->_getEventSubmit();
										}
									}
								} else {

									if($this->oForm->isUserObj($mEvent)) {
										$aEvent = $this->oForm->_callUserObj($mEvent);
									} else {
										$aEvent = $mEvent;
									}

									$this->oForm->aOnloadEvents["client"]["onload:" . $this->_getName()] = array(
										"name" => $this->_getName(),
										"event" => $mEvent,
										"eventdata" => $aEvent
									);
								}
								break;
							}
							case "inline": {

								if($this->oForm->isUserObj($mEvent)) {
									$aEvent = $this->oForm->_callUserObj($mEvent);
								} else {
									$aEvent = $mEvent["__value"];
								}

								break;
							}
						}
					} else {

						$aEvent = $mEvent;
						/*
						// custom string client mode event
						if($this->oForm->isUserObj($mEvent)) {
							$aEvent = $this->oForm->_callUserObj($mEvent);
						} else {
						}*/
					}

					if(($iPos = strpos($sEvent, "-")) !== FALSE) {
						$sEventName = substr($sEvent, 0, $iPos);
					} else {
						$sEventName = $sEvent;
					}

					if($sEventName !== "onload" && !$this->isCustomEventHandler($sEventName)) {
						if(!array_key_exists($sEventName, $aEvents)) {
							$aEvents[$sEventName] = array();
						}

						$aEvents[$sEventName][] = $aEvent;
					} else {
						if($this->isCustomEventHandler($sEventName)) {
							$this->aCustomEvents[$sEventName][] = $aEvent;
						}
					}
				}
			}

			if($this->aSkin && $this->skin_declaresHook("geteventsarray")) {

				$aEvents = $this->oForm->_callUserObj(
					$this->aSkin["submanifest"]["hooks"]["geteventsarray"],
					array(
						"object" => &$this,
						"events" => $aEvents
					)
				);
			}

			reset($aEvents);
			return $aEvents;
		}

		function alterAjaxEventParams($aParams) {
			return $aParams;
		}

		function isCustomEventHandler($sEvent) {
			return in_array(
				$sEvent,
				$this->aPossibleCustomEvents
			);
		}

		function skin_declaresHook($sHook) {
			return	$this->aSkin
					&& array_key_exists("hooks", $this->aSkin["submanifest"])
					&& array_key_exists($sHook, $this->aSkin["submanifest"]["hooks"])
					&& $this->oForm->isUserObj($this->aSkin["submanifest"]["hooks"][$sHook]);
		}

		function _getEvents() {

			$aHtml = array();
			$aEvents = $this->_getEventsArray();

			if(!empty($aEvents)) {
				reset($aEvents);
				while(list($sEvent, $aEvent) = each($aEvents)) {

					if($sEvent == "custom") {
						$aHtml[] = implode(" ", $aEvent);
					} else {
						if($this->oForm->bInlineEvents === TRUE) {
							$aHtml[] = $sEvent . "='" . $this->oForm->oRenderer->wrapEventsForInlineJs($aEvent) . "'";
						} else {
							$this->attachEvents($sEvent, $aEvent);
						}
					}
				}
			}

			return " " . implode(" ", $aHtml) . " ";
		}

		function attachEvents($sEvent, $aEvents) {
			$sEventHandler = str_replace("on", "", $sEvent);
			$sFunction = implode(";\n", $aEvents);
			$sElementId = $this->_getElementHtmlId();

			$sEvents =<<<JAVASCRIPT
Formidable.f("{$this->oForm->formid}").attachEvent("{$sElementId}", "{$sEventHandler}", function(event) {{$sFunction}});
JAVASCRIPT;
			
			if($this->oForm->__getEnvExecMode() === "EID") {
				$this->oForm->aRdtEventsAjax[$sEvent . "-" . $sElementId] = $sEvents;
			} else {
				$this->oForm->aRdtEvents[$sEvent . "-" . $sElementId] = $sEvents;
			}
		}
		
		function _getEventRefresh($mRefresh) {

			if(is_array($mRefresh)) {
				
				if(($mAction = $this->oForm->_navConf("/action", $mRefresh)) !== FALSE) {

					if($this->oForm->isUserObj($mAction)) {
						$mAction = $this->oForm->_callUserObj($mAction);
					}

//					debug($mAction, "mAction");
				}
				
				return $this->oForm->oRenderer->_getRefreshSubmitEvent(
					$this->oForm->_navConf("/formid", $mRefresh),
					$mAction
				);

			} elseif($this->oForm->_isTrueVal($mRefresh) || empty($mRefresh)) {
				return $this->oForm->oRenderer->_getRefreshSubmitEvent();
			}
		}
		
		function _getEventSubmit() {
			return $this->oForm->oRenderer->_getFullSubmitEvent();
		}
		
		function _getSessionDataHashKey() {
			return $this->oForm->_getSafeLock(
				$GLOBALS["TSFE"]->id . "||" . $this->_getElementHtmlId()
			);
		}

		function forceItems($aItems) {
			$this->aForcedItems = $aItems;
		}
		
		function _getItems() {

			if($this->aForcedItems !== FALSE) {
				reset($this->aForcedItems);
				return $this->aForcedItems;
			}

			$elementname = $this->_getName();
				
			$aItems = array();
			$aXmlItems = array();
			$aUserItems = array();

			if(($bFromTCA = $this->_defaultFalse("/data/items/fromtca")) === TRUE) {
				t3lib_div::loadTCA($this->oForm->oDataHandler->tableName());
				if(($aItems = $this->oForm->_navConf("columns/" . $this->_getName() . "/config/items", $GLOBALS["TCA"][$this->oForm->oDataHandler->tableName()])) !== FALSE) {
					return $this->oForm->_tcaToRdtItems($aItems);
				}
			} else {

				$aXmlItems = $this->_navConf("/data/items/");

				if(!is_array($aXmlItems)) {
					$aXmlItems = array();
				}

				reset($aXmlItems);
				while(list($sKey, ) = each($aXmlItems)) {
					
					if($this->oForm->isUserObj($aXmlItems[$sKey]["caption"])) {
						$aXmlItems[$sKey]["caption"] = $this->oForm->_callUserObj(
							$aXmlItems[$sKey]["caption"]
						);
					}

					if($this->oForm->isUserObj($aXmlItems[$sKey]["value"])) {
						$aXmlItems[$sKey]["value"] = $this->oForm->_callUserObj(
							$aXmlItems[$sKey]["value"]
						);
					}

					if(array_key_exists("custom", $aXmlItems[$sKey])) {
						if($this->oForm->isUserObj($aXmlItems[$sKey]["custom"])) {
							$aXmlItems[$sKey]["custom"] = $this->oForm->_callUserObj(
								$aXmlItems[$sKey]["custom"]
							);
						}
					}

					if(array_key_exists("labelcustom", $aXmlItems[$sKey])) {
						if($this->oForm->isUserObj($aXmlItems[$sKey]["labelcustom"])) {
							$aXmlItems[$sKey]["labelcustom"] = $this->oForm->_callUserObj(
								$aXmlItems[$sKey]["labelcustom"]
							);
						}
					}

					$aXmlItems[$sKey]["caption"] = $this->oForm->_getLLLabel($aXmlItems[$sKey]["caption"]);
					$aXmlItems[$sKey]["value"] = $this->_substituteConstants($aXmlItems[$sKey]["value"]);

				}

				reset($aXmlItems);
				$aUserItems = $this->_callUserObj($this->aElement, $this->_navConf("/data/"), $aXmlItems);
				$aItems = $this->_callUserObjMergeItems($aXmlItems, $aUserItems);
			}

			reset($aItems);
			return $aItems;
		}

		function _callUserObj($aElement, $aUserobj, $aData) {
			return $this->oForm->_callUserObj($aUserobj, array(), $aData);
		}

		function _callUserObjMergeItems($aXmlItems, $aUserItems) {

			if(!is_array($aXmlItems)) { $aXmlItems = array();}
			if(!is_array($aUserItems)) { $aUserItems = array();}

			$aItems = array_merge($aXmlItems, $aUserItems);

			if(is_array($aItems) && sizeof($aItems) > 0) {
				reset($aItems);
				return $aItems;
			}

			return array();
		}
		
		function _flatten($mData) {
			return $mData;
		}

		function _unFlatten($sData) {
			return $sData;
		}
		
		function _getHumanReadableValue($data) {
			return $data;
		}
		
		function _emptyFormValue($value) {
			if(is_array($value)) {
				return empty($value);
			} else {
				return (strlen(trim($value)) == 0);
			}
		}
		
		function _sqlSearchClause($sValue, $sFieldPrefix = "", $sFieldName = "", $bRec = TRUE) {
			
			$sTable = $this->oForm->oDataHandler->tableName();
			
			if($sFieldName === "") {
				$sName = $this->_getName();
			} else {
				$sName = $sFieldName;
			}

			$sSql = $sFieldPrefix . $sName . " LIKE '%" . $GLOBALS["TYPO3_DB"]->quoteStr($sValue, $sTable) . "%'";

			if($bRec === TRUE) {
				$sSql = $this->overrideSql(
					$sValue,
					$sFieldPrefix,
					$sName,
					$sSql
				);
			}

			return $sSql;
		}

		function overrideSql($sValue, $sFieldPrefix, $sFieldName, $sSql) {
			$sTable = $this->oForm->oDataHandler->tableName();
			
			if($sFieldName === "") {
				$sName = $this->_getName();
			} else {
				$sName = $sFieldName;
			}

			$aFields = array($sName);

			if(($aConf = $this->_navConf("/search/")) !== FALSE) {

				if(array_key_exists("overridesql", $aConf)) {
					
					if($this->oForm->isUserObj($aConf["overridesql"])) {

						$sSql = $this->oForm->_callUserObj(
							$aConf["overridesql"],
							array(
								"name"		=> $sName,
								"table"		=> $sTable,
								"value"		=> $sValue,
								"prefix"	=> $sFieldPrefix,
							)
						);

					} else {
						$sSql = $aConf["overridesql"];
					}

					$sSql = str_replace("|", $sValue, $sSql);
				} else {
					if(array_key_exists("onfields", $aConf)) {

						if($this->oForm->isUserObj($aConf["onfields"])) {
							$sOnFields = $this->oForm->_callUserObj($aConf["onfields"]);
						} else {
							$sOnFields = $aConf["onfields"];
						}

						$aFields = t3lib_div::trimExplode(",", $sOnFields);
						reset($aFields);
					} else {
						$aFields = array($this->_getName());
					}



					if(array_key_exists("mode", $aConf)) {
						if((is_array($aConf["mode"]) && array_key_exists("startswith", $aConf["mode"])) || $aConf["mode"] == "startswith") {
							// on effectue la recherche sur le dbut des champs avec LIKE A%

							$sValue = trim($sValue);
							$aSql = array();
							
							reset($aFields);
							while(list(, $sField) = each($aFields)) {
								if($sValue != "number") {
									$aSql[] = "(" . $sFieldPrefix . $sField . " LIKE '" . $GLOBALS["TYPO3_DB"]->quoteStr($sValue, $sTable) . "%')";
								} else {
									for($k = 0; $k < 10; $k++) {
										$aSql[] = "(" . $sFieldPrefix . $sField . " LIKE '" . $GLOBALS["TYPO3_DB"]->quoteStr($k, $sTable) . "%')";
									}
								}
							}

							if(!empty($aSql)) {
								$sSql = " (" . implode(" OR ", $aSql) . ") ";
							}

						} elseif((is_array($aConf["mode"]) && (array_key_exists("googlelike", $aConf["mode"]) || array_key_exists("orlike", $aConf["mode"]))) || $aConf["mode"] == "googlelike" || $aConf["mode"] == "orlike") {
							// on doit effectuer la recherche comme le ferait google :)
							// comportement : recherche AND sur "espaces", "+", ","
							//				: gestion des pluriels
							//				: recherche full text si "jj kjk jk"

							$sValue = str_replace(array(" ", ",", " and ", " And ", " aNd ", " anD ", " AnD ", " ANd ", " aND ", " AND ", " et ", " Et ", " eT ", " ET "), "+", trim($sValue));
							$aWords = t3lib_div::trimExplode("+", $sValue);
							
							if(is_array($aConf["mode"]) && array_key_exists("handlepluriels", $aConf["mode"])) {
								reset($aWords);
								while(list($sKey, $sWord) = each($aWords)) {
									if(strtolower(substr($sWord, -1, 1)) === "s") {
										$aWords[$sKey] = substr($sWord, 0, (strlen($sWord) - 1));
									}
								}
							}
							
							$aSql = array();
							
							reset($aFields);
							while(list(, $sField) = each($aFields)) {

								$aTemp = array();

								reset($aWords);
								while(list($iKey, $sWord) = each($aWords)) {
									$aTemp[] = $sFieldPrefix . $sField . " LIKE '%" . $GLOBALS["TYPO3_DB"]->quoteStr($sWord, $sTable) . "%' ";
								}

								if(!empty($aTemp)) {
									if((is_array($aConf["mode"]) && array_key_exists("orlike", $aConf["mode"])) || $aConf["mode"] == "orlike") {
										$aSql[] = "(" . implode(" OR ", $aTemp) . ")";
									} else {
										$aSql[] = "(" . implode(" AND ", $aTemp) . ")";
									}
								}
							}

							if(!empty($aSql)) {
								$sSql = " (" . implode(" OR ", $aSql) . ") ";
							}
						}
					} else {	/* default mode */
						
						$sValue = trim($sValue);
						$aSql = array();

						reset($aFields);
						while(list(, $sField) = each($aFields)) {
							//$aSql[] = "(" . $sFieldPrefix . $sField . " LIKE '%" . $GLOBALS["TYPO3_DB"]->quoteStr($sValue, $sTable) . "%')";
							$aSql[] = $this->_sqlSearchClause(
								$sValue,
								$sFieldPrefix,
								$sField,
								$bRec = FALSE
							);
						}
						
						if(!empty($aSql)) {
							$sSql = " (" . implode(" OR ", $aSql) . ") ";
						}
					}
				}
			}

			return $sSql;
		}
		
		function _renderOnly() {
			return $this->_isTrue("/renderonly/") || $this->i18n_shouldNotTranslate();
		}
		
		function hasData() {
			return $this->_defaultFalse("/hasdata") || ($this->_renderOnly() === FALSE);
		}
		
		function _activeListable() {		// listable as an active HTML FORM field or not in the lister
			return $this->_defaultFalse("/activelistable/");
		}

		function _listable() {
			return $this->_defaultTrue("/listable/");
		}

		function _translatable() {
			return $this->_defaultTrue("/i18n/translate/");
		}

		function i18n_shouldNotTranslate() {
			/*
			$this->oForm->d(
				array(
					"name" => $this->_getName(),
					"props" => array(
						"i18n ?" => $this->oForm->oDataHandler->i18n(),
						"NOT default lang ?" => !$this->oForm->oDataHandler->i18n_currentRecordUsesDefaultLang(),
						"NOT translatable ?" => !$this->_translatable()
					)
				)
			);*/

			return		$this->oForm->oDataHandler->i18n()	// DH handles i18n ?
					&&	!$this->oForm->oDataHandler->i18n_currentRecordUsesDefaultLang()	// AND record is NOT in default language
					&&	!$this->_translatable();	// AND renderlet is NOT translatable
		}

		function _hideableIfNotTranslatable() {
			return $this->_defaultFalse("/i18n/hideifnottranslated");
		}

		function i18n_hideBecauseNotTranslated() {
			if($this->i18n_shouldNotTranslate()) {
				return $this->_hideableIfNotTranslatable();
			}

			return FALSE;
		}

		function _hasToValidateForDraft() {
			return $this->_defaultFalse("/validatefordraft/");
		}

		function _debugable() {
			return $this->_defaultTrue("/debugable/");
		}

		function _readOnly() {
			return ($this->_isTrue("/readonly/")) || $this->i18n_shouldNotTranslate();
		}

		function _searchable() {
			return $this->_defaultTrue("/searchable/");
		}

		function _virtual() {
			return in_array(
				$this->_getName(),
				$this->oForm->oDataHandler->__aVirCols
			);
		}

		function _getElementHtmlName($sName = FALSE) {
			
			if($sName === FALSE) {
				$sName = $this->_getName();
			}
			
			return $this->oForm->oRenderer->_getHtmlName($sName);
		}

		function _getElementHtmlId($sId = FALSE) {

			if($this->sCustomElementId !== FALSE) {
				return $this->sCustomElementId;
			}

			if($sId === FALSE) {
				$sId = $this->_getName();
			}

			/* suffixing ids with rowX for render in lists */
			$sSuffix = "";
			$aData =& $this->oForm->oDataHandler->_getListData();

			if(!empty($aData)/* && ($this->_activeListable() || $this->isChild() && !$this->_readOnly())*/) {
				$sSuffix = "_row" . $aData["uid"];
			}
			
			return $this->oForm->oRenderer->_getHtmlId($sId) . $sSuffix;
		}

		function _getElementCssId($sId = FALSE) {
			return str_replace(
				array("[", "]"),
				array("\[", "\]"),
				$this->_getElementHtmlId($sId)
			);
		}
		
		// alias of _hasThrown(), for convenience
		function hasThrown($sEvent, $sWhen = FALSE) {
			return $this->_hasThrown($sEvent, $sWhen);
		}

		function _hasThrown($sEvent, $sWhen = FALSE) {

			if(array_key_exists($sEvent, $this->aElement) && array_key_exists("runat", $this->aElement[$sEvent]) && $this->aElement[$sEvent]["runat"] == "server") {
				$aEvent = $this->aElement[$sEvent];
			} elseif(($aProgEvents = $this->_getProgServerEvents()) !== FALSE && array_key_exists($sEvent, $aProgEvents)) {
				$aEvent = $aProgEvents[$sEvent];
			} else {
				return FALSE;
			}

			if($sWhen === FALSE || $aEvent[$sEvent]["when"] == $sWhen) {
				$aP = $this->oForm->_getRawPost();
				if(array_key_exists("AMEOSFORMIDABLE_SERVEREVENT", $aP)) {
					if(array_key_exists($aP["AMEOSFORMIDABLE_SERVEREVENT"], $this->oForm->aServerEvents)) {
						
						$sEventId = $this->oForm->_getServerEventId($this->_getName(), $aEvent);
						return ($sEventId === $aP["AMEOSFORMIDABLE_SERVEREVENT"]);
					}
				}
			}

			return FALSE;
		}

		function includeLibs() {
			if(!empty($this->aLibs)) {

				reset($this->aLibs);
				while(list($sKey, $sLib) = each($this->aLibs)) {

					$this->oForm->additionalHeaderData(
						'<script type="text/javascript" src="' . $this->sExtWebPath . $sLib . '"></script>',
						$sKey
					);

				}
			}
		}
		
		function includeScripts($aConfig = array()) {
			
			if($this->sMajixClass != "") {
				$sClass = $this->sMajixClass;
			} else {
				$sClass = "RdtBaseClass";
			}

			$sHtmlId = $this->_getElementHtmlId();
			$sJson = $this->oForm->array2json(
				array_merge(
					array(
						"id" => $sHtmlId,
						"formid" => $this->oForm->formid,
					),
					$aConfig
				)
			);

			$sScript =<<<JAVASCRIPT

Formidable.Context.Forms["{$this->oForm->formid}"].Objects["{$sHtmlId}"] = new Formidable.Classes.{$sClass}(
	{$sJson}
);

JAVASCRIPT;

			$this->oForm->attachInitTask(
				$sScript,
				$sClass . " " . $sHtmlId . " initialization",
				$sHtmlId
			);
		}

		function mayHaveChilds() {
			return FALSE;
		}

		function hasChilds() {
			return isset($this->aElement["childs"]);
		}

		function isChild() {
			return $this->bChild;
		}

		function renderChildsBag() {

			$aRendered = array();

			if($this->mayHaveChilds() && $this->hasChilds()) {

				reset($this->aChilds);
				while(list($sName, ) = each($this->aChilds)) {
					$oRdt =& $this->aChilds[$sName];
					//debug($oRdt, "Rendering child");
					$aRendered[$sName] = $this->oForm->_renderElement($oRdt);
				}
			}

			reset($aRendered);
			return $aRendered;
		}

		function renderChildsCompiled($aChildsBag) {

			if(($aTemplate = $this->_navConf("/childs/template")) !== FALSE) {
				// templating childs
					// mechanism:
					// childs can be templated if name of parent renderlet is present in template as a subpart marker
					// like for instance with renderlet:BOX name="mybox", subpart will be <!-- ###mybox### begin--> My childs here <!-- ###mybox### end-->
				
				$sPath = t3lib_div::getFileAbsFileName($this->oForm->_navConf("/path", $aTemplate));
				if(($sSubPart = $this->oForm->_navConf("/subpart", $aTemplate)) === FALSE) {
					$sSubPart = $this->getName();
				}

				return $this->oForm->_parseTemplate(
					$sPath,
					$sSubPart,
					$aChildsBag,
					array(),
					FALSE
				);
			} else {
				
				if($this->oForm->oRenderer->_getType() === "TEMPLATE") {
					
					// child-template is not defined, but maybe is it implicitely the same as current template renderer ?

					$sSubpart = $this->oForm->oHtml->getSubpart(
						$this->oForm->oRenderer->getTemplateHtml(),
						"###" . $this->getName() . "###"
					);

					if(!empty($sSubpart)) {
						return $this->oForm->_parseTemplateCode(
							$sSubpart,
							$aChildsBag,
							array(),
							FALSE
						);
					}
				}

				$sCompiled = "";
				
				reset($aChildsBag);
				while(list($sName, $aBag) = each($aChildsBag)) {
					if($this->oForm->_defaultFalse("/childs/autowrap/", $this->aElement)) {
						$sCompiled .= "\n<div class='formidable-rdrstd-rdtwrap'>" . $aBag["__compiled"] . "</div>";
					} else {
						$sCompiled .= "\n" . $aBag["__compiled"];
					}
				}

				return $sCompiled;
			}
		}




		function buildMajixExecuter($sMethod, $aData = array()) {
			return $this->oForm->buildMajixExecuter(
				$sMethod,
				$aData,
				$this->_getElementHtmlId()
			);
		}

		function majixDisplayBlock() {
			return $this->buildMajixExecuter("displayBlock");
		}

		function majixDisplayNone() {
			return $this->buildMajixExecuter("displayNone");
		}

		function majixDisplayDefault() {
			return $this->buildMajixExecuter("displayDefault");
		}

		function majixVisible() {
			return $this->buildMajixExecuter("visible");
		}

		function majixHidden() {
			return $this->buildMajixExecuter("hidden");
		}

		function majixDisable() {
			return $this->buildMajixExecuter("hidden");
		}

		function majixEnable() {
			return $this->buildMajixExecuter("enable");
		}

		function majixReplaceData($sData) {
			return $this->buildMajixExecuter(
				"replaceData",
				$sData
			);
		}

		function majixReplaceLabel($sLabel) {
			return $this->buildMajixExecuter(
				"replaceLabel",
				$this->oForm->_getLLLabel($sLabel)
			);
		}

		function majixClearData() {
			return $this->buildMajixExecuter(
				"clearData"
			);
		}

		function majixClearValue() {
			return $this->buildMajixExecuter(
				"clearValue"
			);
		}

		function majixSetValue($sValue) {
			return $this->buildMajixExecuter(
				"setValue",
				$sValue
			);
		}

		function majixFx($sEffect, $aParams = array()) {
			return $this->buildMajixExecuter(
				"Fx",
				array(
					"effect" => $sEffect,
					"params" => $aParams,
				)
			);
		}

		function majixFocus() {
			return $this->buildMajixExecuter(
				"focus"
			);
		}

		function skin_init($sMode) {
		
			if(($aSkin = $this->_navConf("/skin")) !== FALSE) {
				
				if(($aManifest = $this->skin_getManifest($aSkin)) !== FALSE) {
					
					reset($aManifest);
					if(array_key_exists($this->aObjectType["OBJECT"], $aManifest["skin"])) {
						
						reset($aManifest["skin"][$this->aObjectType["OBJECT"]]);
						while(list(, $aSubManifest) = each($aManifest["skin"][$this->aObjectType["OBJECT"]])) {
							if($aSubManifest["type"] == $this->aObjectType["TYPE"]) {

								$aModes = t3lib_div::trimExplode(",", $aSubManifest["modes"]);
								if(in_array($sMode, $aModes)) {
									
									$this->aSkin = array(
										"declaredskin"	=> $aSkin,
										"manifest"		=> $aManifest,
										"submanifest"	=> $aSubManifest,
										"mode"			=> $sMode,
										"template"		=> array(
											"full"		=> "",
											"compiled"	=> "",
											"channels"	=> array(),
										)
									);

									//debug($aSubManifest);

									// getting template and channels

									if(array_key_exists("template", $this->aSkin["submanifest"]["resources"])) {
										$sSrc = $this->aSkin["manifest"]["control"]["serverpath"] . $this->oForm->_removeStartingSlash($this->aSkin["submanifest"]["resources"]["template"]["file"]["src"]);
										if(file_exists($sSrc) && is_readable($sSrc)) {

											

											$this->aSkin["template"]["full"] = t3lib_parsehtml::getSubpart(
												t3lib_div::getUrl($sSrc),
												$this->aSkin["submanifest"]["resources"]["template"]["subpart"]
											);

											if(($aChannels = $this->oForm->_navConf("/channels", $this->aSkin["submanifest"]["resources"]["template"])) !== FALSE) {
												//debug($aChannels);
												reset($aChannels);
												while(list(, $aChannel) = each($aChannels)) {

													$this->aSkin["template"]["channels"][$aChannel["name"]] = $this->oForm->_parseTemplateCode(
														t3lib_parsehtml::getSubpart(
															$this->aSkin["template"]["full"],
															"###CHANNEL:" . $aChannel["name"] . "###"
														),	// HTML code
														$this->aSkin["template"]["channels"],	// substitute tags
														array(),	// exclude tags
														FALSE		// don't clean non replaced {tags}
													);
												}

												$this->aSkin["template"]["compiled"] = $this->oForm->_parseTemplateCode(
													t3lib_parsehtml::getSubpart(
														$this->aSkin["template"]["full"],
														"###COMPILED###"
													),
													$this->aSkin["template"]["channels"],
													array(),
													FALSE
												);
											}


											/*return $this->oForm->_parseTemplate(
												$sSrc,
												$this->aSkin["submanifest"]["resources"]["template"]["subpart"],
												$aSkinFeed["tags"]
											);*/
										}
									}

									break;
								}
							}
						}
					}
				}
			}
		}

		function skin_apply($aHtmlBag, $aDefaultHtmlBag) {

			if($this->aSkin !== FALSE) {
				
				$this->skin_includeCss(
					$this->aSkin["declaredskin"],
					$this->aSkin["manifest"],
					$this->aSkin["submanifest"],
					$aSkinFeed,
					$this->aSkin["sMode"]
				);

				// applying template

				if(!empty($this->aSkin["template"]["channels"])) {
					
					reset($this->aSkin["template"]["channels"]);
					while(list($sName, ) = each($this->aSkin["template"]["channels"])) {
						$aHtmlBag[$sName] = $this->oForm->_parseTemplateCode(
							$this->aSkin["template"]["channels"][$sName],
							$aHtmlBag,
							array(),
							FALSE
						);
					}

					$aHtmlBag["__compiled"] = $this->oForm->_parseTemplateCode(
						$this->aSkin["template"]["compiled"],
						$aHtmlBag,
						array(),
						FALSE
					);
				}

				reset($aHtmlBag);
				return $aHtmlBag;

				//debug($this->aSkin);
			} else {

				reset($aDefaultHtmlBag);
				while(list($sName, ) = each($aDefaultHtmlBag)) {
					$aDefaultHtmlBag[$sName] = $this->oForm->_parseTemplateCode(
						$aDefaultHtmlBag[$sName],
						array_merge($aHtmlBag, $aDefaultHtmlBag),
						array(),
						FALSE
					);
				}
				
				return array_merge($aHtmlBag, $aDefaultHtmlBag);
			}
		}

		function skin_getManifest($aSkin) {

			if(($sSrc = $this->oForm->_navConf("/src", $aSkin)) !== FALSE) {

				$sHash = md5($sSrc);

				if(!array_key_exists($sHash, $this->oForm->aSkinManifests)) {
					$sDir = $this->oForm->toServerPath($sSrc);
					$sPath = $sDir . "manifest.xml";

					if(file_exists($sPath) && is_readable($sPath)) {
						$this->oForm->aSkinManifests[$sHash] = $this->oForm->_getXml($sPath);
						if(array_key_exists("skin", $this->oForm->aSkinManifests[$sHash])) {
							
							$this->oForm->aSkinManifests[$sHash]["control"] = array(
								"serverpath"	=> $sDir,
								"webpath"		=> $this->oForm->toWebPath($sDir),
								"manifest.xml"	=> $sPath,
							);

							return $this->oForm->aSkinManifests[$sHash];
						}
					}
				} else {
					return $this->oForm->aSkinManifests[$sHash];
				}
			}

			return FALSE;
		}

		function skin_includeCss($aSkinDeclaration, $aManifest, $aObjectManifest, $aSkinFeed, $sMode) {

			if(($aCssFiles = $this->oForm->_navConf("/resources/css/", $aObjectManifest)) !== FALSE) {
				reset($aCssFiles);
				while(list(, $aCssFile) = each($aCssFiles)) {
					
					$sCssPath = $aManifest["control"]["webpath"] . $this->oForm->_removeStartingSlash($aCssFile["src"]);
					$sCssTag = '<link rel="stylesheet" type="text/css" media="all" href="' . $sCssPath . '" />';

					if(array_key_exists("wrap", $aCssFile)) {
						$sCssTag = str_replace("|", $sCssTag, $aCssFile["wrap"]);
					}
					
					$this->oForm->additionalHeaderData(
						$sCssTag,
						md5($sCssPath)
					);
				}
			}
		}

		function defaultWrap() {
			return $this->_defaultTrue("/defaultwrap");
		}

		function hideIfJs() {
			return $this->_defaultFalse("/hideifjs");
		}

		function displayOnlyIfJs() {
			return $this->_defaultFalse("/displayonlyifjs");
		}

		function cleanBeforeSession() {
			unset($this->oRdtParent);	// TODO: reconstruct ajax-side
			parent::cleanBeforeSession();
		}

		function hasSubmitted() {
			$aP = $this->oForm->_getRawPost();

			if(array_key_exists($this->_getName(), $aP)) {
				return TRUE;
			} else {
				return FALSE;
			}
		}

		function wrap($sHtml) {
			if(($mWrap = $this->_navConf("/wrap")) !== FALSE) {
				if($this->oForm->isUserObj($mWrap)) {
					$mWrap = $this->oForm->_callUserObj($mWrap);
				}

				return $this->oForm->cObj->noTrimWrap($sHtml, $mWrap);
			}

			return $sHtml;
		}

		function getFalse() {
			return FALSE;
		}

		function getTrue() {
			return TRUE;
		}

		function shouldProcess() {
			
			$mProcess = $this->_navConf("/process");
			
			if($mProcess !== FALSE) {
				if($this->oForm->isUserObj($mProcess)) {

					$mProcess = $this->oForm->_callUserObj($mProcess);

					if($mProcess === FALSE) {
						return FALSE;
					}
				} elseif($this->oForm->_isFalseVal($mProcess)) {
					return FALSE;
				}
			}

			$aUnProcessMap = $this->oForm->_navConf("/control/factorize/switchprocess");
			if($this->oForm->isUserObj($aUnProcessMap)) {
				$aUnProcessMap = $this->oForm->_callUserObj($aUnProcessMap);
			}

			if(is_array($aUnProcessMap) && array_key_exists($this->_getName(), $aUnProcessMap)) {
				return $aUnProcessMap[$this->_getName()];
			}
			
			return TRUE;
		}
	}
	
	if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/class.mainrenderlet.php"])	{
		include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/class.mainrenderlet.php"]);
	}
?>
