<?php

	class formidable_mainvalidator extends formidable_mainobject {

		function _matchConditions($aConditions) {
			return $this->oForm->_matchConditions($aConditions);
		}

		function _doTheMagic($aInfos, $aConf, $aElement) {
			
			$oRdt = $this->oForm->aORenderlets[$this->oForm->_navConf("/name", $aElement)];
			$sName = $oRdt->_getName();
			$value = $this->oForm->oDataHandler->_getThisFormData($sName);

			if($this->oForm->_navConf("/required", $aConf) !== FALSE && $this->oForm->_defaultTrue("/required/value/", $aConf)) {

				$this->oForm->_debug(null, "VALIDATOR[" . $aInfos["TYPE"] . "][required] on '" . $sName . "', TYPE [" . $aElement["type"] . "]");

				if($this->_isEmpty($aElement, $value)) {
					$message = $this->oForm->_getLLLabel($this->oForm->_navConf("/required/message/", $aConf));
					$this->oForm->_declareValidationError($sName, "STANDARD:required", $message);
				}
			}
			
			if($this->oForm->_navConf("/authentified", $aConf) !== FALSE && $this->oForm->_defaultTrue("/authentified/value/", $aConf)) {

				$this->oForm->_debug(null, "VALIDATOR[" . $aInfos["TYPE"] . "][authentified] on '" . $sName . "', TYPE [" . $aElement["type"] . "]");

				if(!$this->_isAuthentified()) {
					$message = $this->oForm->_getLLLabel($this->oForm->_navConf("/authentified/message/", $aConf));
					$this->oForm->_declareValidationError($sName, "STANDARD:authentified", $message);
				}
			}
			
			if($this->oForm->_navConf("/maxsize", $aConf) !== FALSE) {

				$maxsize = intval($this->oForm->_navConf("/maxsize/value/", $aConf));
				$this->oForm->_debug(null, "VALIDATOR[" . $aInfos["TYPE"] . "][maxsize = '" . $maxsize . "'] on '" . $sName . "', TYPE [" . $aElement["type"] . "]");

				if($this->_isTooLong($aElement, $value, $maxsize)) {
					$message = $this->oForm->_getLLLabel($this->oForm->_navConf("/maxsize/message/", $aConf));
					$this->oForm->_declareValidationError($sName, "STANDARD:maxsize", $message);
				}
			}

			if($this->oForm->_navConf("/minsize", $aConf) !== FALSE) {

				$minsize = intval($this->oForm->_navConf("/minsize/value/", $aConf));
				$this->oForm->_debug(null, "VALIDATOR[" . $aInfos["TYPE"] . "][minsize = '" . $minsize . "'] on '" . $sName . "', TYPE [" . $aElement["type"] . "]");

				if($this->_isTooSmall($aElement, $value, $minsize)) {
					$message = $this->oForm->_getLLLabel($this->oForm->_navConf("/minsize/message/", $aConf));
					$this->oForm->_declareValidationError($sName, "STANDARD:minsize", $message);
				}
			}

			if($this->oForm->_navConf("/size", $aConf) !== FALSE) {

				$size = intval($this->oForm->_navConf("/size/value/", $aConf));
				$this->oForm->_debug(null, "VALIDATOR[" . $aInfos["TYPE"] . "][size = '" . $minsize . "'] on '" . $sName . "', TYPE [" . $aElement["type"] . "]");

				if(!$this->_sizeIs($aElement, $value, $size)) {
					$message = $this->oForm->_getLLLabel($this->oForm->_navConf("/size/message/", $aConf));
					$this->oForm->_declareValidationError($sName, "STANDARD:size", $message);
				}
			}

			if($this->oForm->_navConf("/sameas", $aConf) !== FALSE) {

				$sameas = trim($this->oForm->_navConf("/sameas/value/", $aConf));

				$this->oForm->_debug(null, "VALIDATOR[" . $aInfos["TYPE"] . "][sameas '" . $sameas . "'] on '" . $sName . "', TYPE [" . $aElement["type"] . "]");

				$samevalue = $this->oForm->aORenderlets[$sameas]->_unFlatten(
					$this->oForm->oDataHandler->_getThisFormData(
						$this->oForm->aORenderlets[$sameas]->_getName()
					)
				);
				
				if(!$this->_isSameAs($value, $samevalue)) {
					$message = $this->oForm->_getLLLabel($this->oForm->_navConf("/sameas/message/", $aConf));
					$this->oForm->_declareValidationError($sName, "STANDARD:sameas", $message);
				}
			}
			
			if($this->oForm->_navConf("/email", $aConf) !== FALSE && $this->oForm->_defaultTrue("/email/value/", $aConf)) {
				
				$this->oForm->_debug(null, "VALIDATOR[" . $aInfos["TYPE"] . "][email '" . $value . "'] on '" . $sName . "', TYPE [" . $aElement["type"] . "]");

				// le champ est obligatoire
				// on vrifie qu'il est bien renseign

				if(!$this->_isEmail($aElement, $value)){

					$message = $this->oForm->_getLLLabel($this->oForm->_navConf("/email/message/", $aConf));
					$this->oForm->_declareValidationError($sName, "STANDARD:email", $message);
				}
			}
			
			if(($mUserObj = $this->oForm->_navconf("/userobj", $aConf)) !== FALSE) {
				if(($mResult = $this->oForm->_callUserObj($aConf, array("value" => $value))) !== TRUE) {

					if(is_string($mResult)) {
						$message = $this->oForm->_getLLLabel($message);
					} else {
						$message = $this->oForm->_getLLLabel($this->oForm->_navConf("/userobj/message/", $aConf));
					}

					$this->oForm->_declareValidationError($sName, "STANDARD:userobj", $message);
				}
			}
		}

		
		function _isEmpty($aElement, $value) {
			return $this->oForm->aORenderlets[$aElement["name"]]->_emptyFormValue($value);
		}
		

		function _isTooLong($aElement, $value, $maxSize) {
			
			if(is_array($value)) {
				return (count($value) > $maxSize);
			}
			
			return (strlen(trim($value)) > $maxSize);
		}

		function _isTooSmall($aElement, $value, $minSize) {

			if(is_array($value)) {
				return (count($value) < $minSize);
			}
			
			return (strlen(trim($value)) < $minSize);
		}
		
		function _sizeIs($aElement, $value, $iSize) {

			if(is_array($value)) {
				return (count($value) == intval($iSize));
			}
			
			return (strlen(trim($value)) == $iSize);
		}

		function _isSameAs($value1, $value2) {
			return ($value1 === $value2);
		}

		function _isEmail($aElement, $value) {
			return trim($value) == "" || t3lib_div::validEmail($value);
		}

		function _isAuthentified() {
			return (is_array(($aUser = $GLOBALS["TSFE"]->fe_user->user)) && array_key_exists("uid", $aUser) && intval($aUser["uid"]) > 0);
		}
	}
	
	if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/class.mainvalidator.php"])	{
		include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/class.mainvalidator.php"]);
	}
?>
